#ifndef __APATARN_H__
#define __APATARN_H__

/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include"Macro.h"
#include"Struct.h"

////////////////////////////////////////////////////////////////////////////
//GNX^[(L)
////////////////////////////////////////////////////////////////////////////
extern RECT	rcSlath[3];
extern RECT	rcFire1[10];
extern RECT	rcFire2[15];
extern RECT	rcFire3[6];
extern RECT	rcFire3d[6];
extern RECT	rcFire4[10];
extern RECT	rcWater[4];
extern RECT	rcWater2[5];
extern RECT	rcWater3[17];
extern RECT	rcWater4[6];
extern RECT	rcWater5d[13];
extern RECT	rcWater6[5];
extern RECT	rcEarth;
extern RECT	rcEarth2;
extern RECT	rcEarth3[14];
extern RECT	rcEarth4[3];
extern RECT	rcEarth5[5];
extern RECT	rcEarth6[20];
extern RECT	rcWind[13];
extern RECT	rcWind2[15];
extern RECT	rcWind5[6];
extern RECT	rcWind6[8];
extern RECT	rcRight[5];
extern RECT	rcRight2[6];
extern RECT	rcRight3[7];
extern RECT	rcRight4[5];
extern RECT	rcRight6[13];
extern RECT	rcNon[5];
extern RECT	rcNon2;
extern RECT	rcNon3[7];
extern RECT	rcNon4[9];
extern RECT	rcNon5[5];
extern RECT	rcNon6[8];
extern RECT	rcRec[20];
extern RECT	rcPoison[20];
extern RECT	rcDele[20];
extern RECT	rcDark[20];
extern RECT	rcRSlath[9];
extern RECT	rcRSlath2[3];
extern RECT	rcRSlath3[3];
extern RECT	rcRSlath4[3];
extern RECT	rcRSlath5[3];
extern RECT	rcRRight[5];
extern RECT	rcRWind[15];
extern RECT	rcRWind2[5];
extern RECT	rcRFire[9];
extern RECT	rcAll[2];
extern RECT	rcAll2[6];
extern RECT	rcRWind3[10];
extern RECT	rcRRight2[5];
extern RECT	rcAll3[2];

extern POSE	poseSlathData[ 4 ];
extern POSE	poseFire1Data[ 11 ];
extern POSE	poseFire2Data[ 11 ];
extern POSE	poseFire3Data[ 16 ];
extern POSE	poseFire4Data[ 11 ];
extern POSE	poseFire5Data[ 7 ];
extern POSE	poseFire6Data[ 11 ];
extern POSE	poseWaterData[ 5 ]; 
extern POSE	poseWater2Data[ 6 ];
extern POSE	poseWater3Data[ 18 ];
extern POSE	poseWater4Data[ 7 ];
extern POSE	poseWater5Data[ 18 ];
extern POSE	poseWater6Data[ 6 ];
extern POSE	poseEarthData[ 2 ];
extern POSE	poseEarthData2[ 2 ];
extern POSE	poseEarthData3[ 15 ];
extern POSE	poseEarthData4[ 3 ];
extern POSE	poseEarthData5[ 6 ];
extern POSE	poseEarthData6[ 21 ];
extern POSE	poseWindData[ 14 ];
extern POSE	poseWind2Data[ 16 ];
extern POSE	poseWind3Data[ 14 ];
extern POSE	poseWind4Data[ 16 ];
extern POSE	poseWind5Data[ 7 ];
extern POSE	poseWind6Data[ 9 ];
extern POSE	poseRightData[ 6 ];
extern POSE	poseRight2Data[ 7 ];
extern POSE	poseRight3Data[ 8 ];
extern POSE	poseRight4Data[ 6 ];
extern POSE	poseRight5Data[ 7 ];
extern POSE	poseRight6Data[ 14 ];
extern POSE	poseNonData[ 6 ];
extern POSE	poseNon2Data[ 2 ];
extern POSE	poseNon3Data[ 8 ];
extern POSE	poseNon4Data[ 10 ];
extern POSE	poseNon5Data[ 6 ];
extern POSE	poseNon6Data[ 17 ];
extern POSE	poseRecData[ 21 ];
extern POSE	poseRec2Data[ 21 ];
extern POSE	poseRec3Data[ 21 ];
extern POSE	poseRec4Data[ 21 ];
extern POSE	poseRec5Data[ 21 ];
extern POSE	poseRec6Data[ 21 ];
extern POSE	poseRec7Data[ 21 ];
extern POSE	poseRec8Data[ 21 ];
extern POSE	posePoiData[ 21 ];
extern POSE	posePalData[ 21 ];
extern POSE	poseDelData[ 21 ];
extern POSE	poseDarkData[ 21 ];
extern POSE	posePanicData[ 21 ];
extern POSE	poseCrazyData[ 21 ];
extern POSE	poseSleepData[ 21 ];
extern POSE	poseRetData[ 21 ];
extern POSE	poseRet2Data[ 21 ];
extern POSE	poseHeaData[ 21 ];
extern POSE	poseHea2Data[ 21 ];
extern POSE	poseUpData[ 21 ];
extern POSE	poseUp2Data[ 21 ];
extern POSE	poseUp3Data[ 21 ];
extern POSE	poseUp4Data[ 21 ];
extern POSE	poseUp5Data[ 21 ];
extern POSE	poseUp6Data[ 21 ];
extern POSE	poseUp7Data[ 21 ];
extern POSE	poseUp8Data[ 21 ];
extern POSE	poseSPData[ 1 ];
extern POSE	poseSP2Data[ 1 ];
extern POSE	poseRSlaData[ 10 ];
extern POSE	poseRRightData[ 6 ];
extern POSE	poseRWindData[ 16 ];
extern POSE	poseRFireData[ 10 ];
extern POSE	poseAllData[ 3 ];
extern POSE	poseRNonData[ 16 ];
extern POSE	poseRFire2Data[ 16 ];
extern POSE	poseRWind2Data[ 16 ];
extern POSE	poseRRight2Data[ 14 ];
extern POSE	poseAll2Data[ 3 ];

////////////////////////////////////////////////////////////////////////////
//GNX^[(X^[)
////////////////////////////////////////////////////////////////////////////
extern RECT	rcREM[17];
extern RECT	rcREM2[20];
extern RECT	rcREM3[22];
extern RECT	rcREM4[24];
extern RECT	rcREM5[5];

extern POSE	poseREMData[ 18 ];
extern POSE	poseREM2Data[ 21 ];
extern POSE	poseREM3Data[ 23 ];
extern POSE	poseREM4Data[ 23 ];
extern POSE	poseREM5Data[ 18 ];
extern POSE	poseREM6Data[ 21 ];
extern POSE	poseREM7Data[ 23 ];
extern POSE	poseREM8Data[ 23 ];
extern POSE	poseREM9Data[ 6 ];
extern POSE	poseREM10Data[ 6 ];

#endif