
/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include<ddraw.h>
#include"DirectDraw.h"
#include"DD_Draw.h"
#include"Macro.h"
#include"Global.h"
#include"DD_Clip.h"

#include"DD_Alpha.h"
#include"DD_Mosaic.h"
#include"DD_Mask.h"
#include"DD_AddBlend.h"
#include"DD_Monotone.h"
#include"DD_Rotate.h"
#include"FightCommand.h"

/////////////////////////////////////////////////////////////////
// DD_Flip֐
// ŏIo
/////////////////////////////////////////////////////////////////
void DD_Flip()
{
	RECT		rcDst,rcSrc;
	POINT		stdPos = { 0,0 };
	static int	mx=2;
	static int	my=3;
	static int	backx = 0, backy = 0;
	static int	Wait = 0, SetData = FALSE;

	if( AttackCheackMon == TRUE ){
		Wait++;
		if( Wait < 20 ){
			backx+=mx;
			backy+=my;
			if(backx == 2 || backx == -2){
				mx*=-1;
				my*=-1;
			}
		}else{
			Wait = 0;
			AttackCheackMon = FALSE;
		}
	}else{
		backx=0;
		backy=0;
		Wait = 0;
		SetData = FALSE;
	}

	//ŏIo	
	if( fDDrawMode == MODE_FULLSCREEN ){//tXN[[h
		if( AttackCheackMon == TRUE ){
			if( SetData == FALSE ){
				SetData = TRUE;
				SetRect( &rcSrc, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );
				ClipBltFast( lpDDSBlankBuffer, 0, 0,lpDDSBackBuffer,rcSrc, NULL );
			}
		}
		SetRect( &rcSrc, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );
		ClipBltFast( lpDDSBackBuffer, 0+backx, 0+backy,lpDDSBlankBuffer,rcSrc, NULL );
		//}else{			
		//	ClipBltFast( lpDDSBackBuffer, 0, 0,lpDDSBlankBuffer,rcSrc, NULL );
		//}
		lpDDSPrimary->Flip( lpDDSBackBuffer, DDFLIP_WAIT );
	}else{							//EBhE[h
		ClientToScreen( hWnd, &stdPos );
		SetRect( &rcSrc, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );
		SetRect( &rcDst, stdPos.x + backx, stdPos.y + backy, 
			stdPos.x + SCREEN_WIDTH + backx, stdPos.y + SCREEN_HEIGHT + backy );
		lpDDSPrimary->Blt( &rcDst, lpDDSBackBuffer, &rcSrc, DDBLT_WAIT, NULL );
	}

	return;
}

/////////////////////////////////////////////////////////////////
// ClipBlt֐
// NbsOBlt
/////////////////////////////////////////////////////////////////
HRESULT ClipBlt(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT rcSrc,
	DWORD dwFlags )
{

	Clipping( &rcDst, &rcSrc );

	return lpDDSDst->Blt( &rcDst, lpDDSSrc, &rcSrc, DDBLT_WAIT | dwFlags, NULL );

}

/////////////////////////////////////////////////////////////////
// ClipBltFast֐
// NbsOBltFast
/////////////////////////////////////////////////////////////////
HRESULT ClipBltFast(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	int dstX, int dstY,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT rcSrc,
	DWORD dwFlags )
{
	
	RECT	rcDst = {			//]
		dstX,
		dstY,
		dstX + ( rcSrc.right - rcSrc.left ),
		dstY + ( rcSrc.bottom - rcSrc.top )
	};
	
	Clipping( &rcDst, &rcSrc );

	return lpDDSDst->BltFast( rcDst.left, rcDst.top, lpDDSSrc, &rcSrc, DDBLTFAST_WAIT | dwFlags );

}

/////////////////////////////////////////////////////////////////
//	DrawStr֐
//@\siSp̂݁j
//@
//	PF]T[tFCX
//	QF̃|C^
//	RF]XW
//	SF]YW
//	TF\镶
//	ߒlF
/////////////////////////////////////////////////////////////////
void DD_DrawStr( LPDIRECTDRAWSURFACE7 lpDDSDst, LPSTR pStr, int x, int y, DWORD len )
{
	int		i,j;				//[vJE^
	int		xpos = 0, ypos = 0;	//e̕\ʒu
	DWORD	lenCnt = 0;			//\镶܂ł̃JE^
	static RECT	rcMoji[ 60 ] = {0};
	static BOOL	fSetData = FALSE;
	char	regiMoji[] = "ĂƂȂɂʂ˂̂͂Ђӂւق܂݂ނ߂@@@@IH􁙁RCl";

	if( !fSetData ){
		for( i = 0 ; i < 12 ; i++ ){
			for( j = 0 ; j < 5 ; j++ ){
				SetRect( &rcMoji[ i * 5 + j ], j * 16, i * 16, j * 16 + 16, i * 16 + 16 );
			}
		}
		fSetData = TRUE;
	}	

	i = 0;	
	while( pStr[ i ] != '\0' && lenCnt < len  ){
		if( pStr[ i ] == '#' ){	//ꕶ
			switch( pStr[ i + 1 ] ){
			case 'n':	//s
				ypos ++;
				xpos = 0;			
				break;
			case 's':	//Xy[X
				xpos ++;
				break;
			}
			i += 2;
			continue;
		}
		j = 0;
		while( regiMoji[ j ] != '\0' ){
			if( pStr[ i ] == regiMoji[ j ] && pStr[ i + 1 ] == regiMoji[ j + 1 ] ){
				lpDDSDst->BltFast(
					x + xpos * 16,
					y + ypos * 16,
					lpDDSOffscreen[ 2 ],
					&rcMoji[ j / 2 ],
					DDBLTFAST_WAIT );
			}
			j += 2;
		}	
		i += 2;
		xpos ++;
		lenCnt ++;
	}
	return;
}

/////////////////////////////////////////////////////////////////
// DD_AlphaBlt֐
// 
/////////////////////////////////////////////////////////////////
HRESULT DD_AlphaBlt(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	double				 alpha,
	DWORD				 dwFlags )
{
	switch( g_dwRGBBitCount ){
		case 16:	//16Bit[h̎
			return	DD_AlphaBlt16( lpDDSDst, rcDst, lpDDSSrc, rcSrc, alpha, dwFlags );
			break;
		case 24:	//24Bit[h̎
			return	DD_AlphaBlt24( lpDDSDst, rcDst, lpDDSSrc, rcSrc, alpha, dwFlags );
			break;
		case 32:	//32Bit[h̎
			return	DD_AlphaBlt32( lpDDSDst, rcDst, lpDDSSrc, rcSrc, alpha, dwFlags );
			break;
	}

	return DD_OK;
}



/////////////////////////////////////////////////////////////////
// DD_MosaicBlt16֐
// UCN
/////////////////////////////////////////////////////////////////
HRESULT DD_MosaicBlt(
	LPDIRECTDRAWSURFACE7 lpDDS,
	RECT				 rcDst,
	int					 size )
{
	switch( g_dwRGBBitCount ){
		case 16:	//16Bit[h̎
			return	DD_MosaicBlt16( lpDDS, rcDst,size );
			break;
		case 24:	//24Bit[h̎
			return	DD_MosaicBlt24( lpDDS, rcDst, size );
			break;
		case 32:	//32Bit[h̎
			return	DD_MosaicBlt32( lpDDS, rcDst, size );
			break;
	}

	return DD_OK;
}



/////////////////////////////////////////////////////////////////
// DD_DD_MaskBlt֐
// }XNJ[
/////////////////////////////////////////////////////////////////
HRESULT DD_MaskBlt(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,	
	DWORD				 dwFlags )
{
	switch( g_dwRGBBitCount ){
		case 16:	//16Bit[h̎
			return	DD_MaskBlt16( lpDDSDst, rcDst, lpDDSSrc, rcSrc, dwFlags );
			break;
		case 24:	//24Bit[h̎
			return	DD_MaskBlt24( lpDDSDst, rcDst, lpDDSSrc, rcSrc, dwFlags );
			break;
		case 32:	//32Bit[h̎
			return	DD_MaskBlt32( lpDDSDst, rcDst, lpDDSSrc, rcSrc, dwFlags );
			break;
	}

	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_DD_AddBlendBlt֐
// Z
/////////////////////////////////////////////////////////////////
HRESULT DD_AddBlendBlt(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	DWORD				 dwFlags )
{
	switch( g_dwRGBBitCount ){
		case 16:	//16Bit[h̎
			return	DD_AddBlendBlt16( lpDDSDst, rcDst, lpDDSSrc, rcSrc, dwFlags );
			break;
		case 24:	//24Bit[h̎
			return	DD_AddBlendBlt24( lpDDSDst, rcDst, lpDDSSrc, rcSrc, dwFlags );
			break;
		case 32:	//32Bit[h̎
			return	DD_AddBlendBlt32( lpDDSDst, rcDst, lpDDSSrc, rcSrc, dwFlags );
			break;
	}

	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_MonotoneBlt֐
// mg[
/////////////////////////////////////////////////////////////////
HRESULT DD_MonotoneBlt(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	DWORD				 dwFlags )
{
	switch( g_dwRGBBitCount ){
		case 16:	//16Bit[h̎
			return	DD_MonotoneBlt16( lpDDSDst, rcDst, lpDDSSrc, rcSrc, dwFlags );
			break;
		case 24:	//24Bit[h̎
			return	DD_MonotoneBlt24( lpDDSDst, rcDst, lpDDSSrc, rcSrc, dwFlags );
			break;
		case 32:	//32Bit[h̎
			return	DD_MonotoneBlt32( lpDDSDst, rcDst, lpDDSSrc, rcSrc, dwFlags );
			break;
	}

	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_RotateBlt16֐
// 摜]
/////////////////////////////////////////////////////////////////
HRESULT DD_RotateBlt(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	int					 angle,
	DWORD				 dwFlags )
{
	switch( g_dwRGBBitCount ){
		case 16:	//16Bit[h̎
			return	DD_RotateBlt16( lpDDSDst, rcDst, lpDDSSrc, rcSrc, angle, dwFlags );
			break;
		case 24:	//24Bit[h̎
			return	DD_RotateBlt24( lpDDSDst, rcDst, lpDDSSrc, rcSrc, angle, dwFlags );
			break;
		case 32:	//32Bit[h̎
			return	DD_RotateBlt32( lpDDSDst, rcDst, lpDDSSrc, rcSrc, angle, dwFlags );
			break;
	}

	return DD_OK;
}
