
/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include<ddraw.h>
#include"DirectDraw.h"
#include"DD_Draw.h"
#include"Macro.h"
#include"Global.h"
#include"DD_Clip.h"


//////////////////////////////////////////////////////////////////
// DD_MonotoneBlt16֐
// mg[
/////////////////////////////////////////////////////////////////
HRESULT DD_MonotoneBlt16(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;		//]T[tFCX̏
	DDSURFACEDESC2	ddsdSrc;		//]T[tFCX̏
	WORD			*lpSurfaceDst;				//]T[tFCX̃|C^
	WORD			*lpSurfaceSrc;				//]T[tFCX̃|C^
	DWORD			colorKey;					//J[L[
	DWORD			RDst,GDst,BDst;				//]RGBl
	DWORD			RSrc,GSrc,BSrc;				//]RGBl
	DWORD			RBitMask,GBitMask,BBitMask;	//J[}XNl
	LONG			lPitchDst;					//]̃|C^i߂l
	LONG			lPitchSrc;					//]̃|C^i߂l
	int				i, j;
	int				nWidth;
	int				nHeight;
	HRESULT			ret;

	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );
	
	//Vtgbit
	DWORD			RShiftCnt = 0, GShiftCnt = 0, BShiftCnt = 0;
	DWORD			ratio;

	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )		return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
			lpDDSDst->Unlock( NULL );
			return ret;
	}
	//]E|C^擾
	lpSurfaceDst = ( WORD* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( WORD* )ddsdSrc.lpSurface;	
	//|C^i߂l
	lPitchDst = ddsdDst.lPitch / sizeof( WORD );
	lPitchSrc = ddsdSrc.lPitch / sizeof( WORD );
	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	//J[L[̎擾
	colorKey = ( WORD )ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;
	//J[}XNl̎擾
	RBitMask = ddsdSrc.ddpfPixelFormat.dwRBitMask;
	GBitMask = ddsdSrc.ddpfPixelFormat.dwGBitMask;
	BBitMask = ddsdSrc.ddpfPixelFormat.dwBBitMask;

	//e}XÑrbg𒲂ׂ
	for( i = 0; i < 32; i++ ){
		if( ( ( RBitMask>>i ) & 0x1 ) == 1 ){
			RShiftCnt = i;
			break;
		}
	}
	for( i = 0; i < 32; i++ ){
			if( ( ( GBitMask>>i ) & 0x1 ) == 1 ){
			GShiftCnt = i;
			break;
		}
	}
	for( i = 0; i < 32; i++ ){
		if( ( ( BBitMask>>i ) & 0x1 ) == 1 ){
			BShiftCnt = i;
			break;
		}
	}

	//摜
	for( i = 0; i < nHeight; i++ ){
		for( j = 0; j < nWidth; j++ ){
			if( !( lpSurfaceSrc[ j ] == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				//]RGBl̊
				RSrc = ( ( lpSurfaceSrc[ j ] & RBitMask )>>RShiftCnt ) * 100 / ( RBitMask>>RShiftCnt );
				GSrc = ( ( lpSurfaceSrc[ j ] & GBitMask )>>GShiftCnt ) * 100 / ( GBitMask>>GShiftCnt );
				BSrc = ( ( lpSurfaceSrc[ j ] & BBitMask )>>BShiftCnt ) * 100 / ( BBitMask>>BShiftCnt );
				//ςo
				ratio = ( RSrc + GSrc + BSrc ) / 3;
				//ꂼɒl߂
				RDst = ( ( RBitMask>>RShiftCnt ) * ratio / 100 )<<RShiftCnt;
				GDst = ( ( GBitMask>>GShiftCnt ) * ratio / 100 )<<GShiftCnt;
				BDst = ( ( BBitMask>>BShiftCnt ) * ratio / 100 )<<BShiftCnt;
				//l1ɂ
				lpSurfaceDst[j] = (WORD)((RDst)|(GDst)|(BDst));				
			}
		}
		lpSurfaceDst += lPitchDst;	//|C^i߂
		lpSurfaceSrc += lPitchSrc;
	}

	//]ẼAbN
	lpDDSSrc->Unlock( NULL );
	lpDDSDst->Unlock( NULL );	
	
	return DD_OK;
}


/////////////////////////////////////////////////////////////////
// DD_MonotoneBlt24֐
// mg[
/////////////////////////////////////////////////////////////////
HRESULT DD_MonotoneBlt24(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;		//]T[tFCX̏
	DDSURFACEDESC2	ddsdSrc;		//]T[tFCX̏
	RGBTRIPLE		*lpSurfaceDst;				//]T[tFCX̃|C^
	RGBTRIPLE		*lpSurfaceSrc;				//]T[tFCX̃|C^
	DWORD			colorKey;					//J[L[
	DWORD			srcColorKey;
	DWORD			ratio;						//ϒl
	LONG			lPitchDst;					//]̃|C^i߂l
	LONG			lPitchSrc;					//]̃|C^i߂l
	int				i, j;
	int				nWidth;
	int				nHeight;	
	HRESULT			ret;

	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );
		
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )		return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
			lpDDSDst->Unlock( NULL );
			return ret;
	}
	
	//]E|C^擾
	lpSurfaceDst = ( RGBTRIPLE* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( RGBTRIPLE* )ddsdSrc.lpSurface;	
	
	//|C^i߂l
	lPitchDst = ddsdDst.lPitch / sizeof( RGBTRIPLE );
	lPitchSrc = ddsdSrc.lPitch / sizeof( RGBTRIPLE );
	
	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	
	//J[L[̎擾
	colorKey = ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;

	//摜
	for( i = 0; i < nHeight; i++ ){
		for( j = 0; j < nWidth; j++ ){
			srcColorKey = *(DWORD*)&lpSurfaceSrc[ j ];
			srcColorKey &= 0xffffff;
			if( !( srcColorKey == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				//ςo				
				ratio = ( lpSurfaceSrc[ j ].rgbtRed + lpSurfaceSrc[ j ].rgbtGreen + lpSurfaceSrc[ j ].rgbtBlue ) / 3;
				//RGBlɕς
				lpSurfaceDst[ j ].rgbtRed = (BYTE)ratio;
				lpSurfaceDst[ j ].rgbtGreen = (BYTE)ratio;
				lpSurfaceDst[ j ].rgbtBlue = (BYTE)ratio;
			}
		}
		lpSurfaceDst += lPitchDst;	//|C^i߂
		lpSurfaceSrc += lPitchSrc;
	}

	//]ẼAbN
	lpDDSSrc->Unlock( NULL );
	lpDDSDst->Unlock( NULL );	
	
	return DD_OK;
}

/////////////////////////////////////////////////////////////////
// DD_MonotoneBlt32֐
// mg[
/////////////////////////////////////////////////////////////////
HRESULT DD_MonotoneBlt32(
	LPDIRECTDRAWSURFACE7 lpDDSDst,
	RECT				 rcDst,
	LPDIRECTDRAWSURFACE7 lpDDSSrc,
	RECT				 rcSrc,
	DWORD				 dwFlags )
{
	DDSURFACEDESC2	ddsdDst;		//]T[tFCX̏
	DDSURFACEDESC2	ddsdSrc;		//]T[tFCX̏
	RGBQUAD			*lpSurfaceDst;				//]T[tFCX̃|C^
	RGBQUAD			*lpSurfaceSrc;				//]T[tFCX̃|C^
	DWORD			colorKey;					//J[L[
	DWORD			srcColorKey;
	DWORD			ratio;						//ϒl
	LONG			lPitchDst;					//]̃|C^i߂l
	LONG			lPitchSrc;					//]̃|C^i߂l
	int				i, j;
	int				nWidth;
	int				nHeight;	
	HRESULT			ret;

	//]̈̏C
	Clipping( &rcDst, &rcSrc );
	//]̈̃TCY߂
	nWidth = ( rcSrc.right ) - ( rcSrc.left );
	nHeight = ( rcSrc.bottom ) - ( rcSrc.top );
		
	ddsdDst.dwSize = sizeof( ddsdDst );
	ddsdSrc.dwSize = sizeof( ddsdSrc );
	
	//]AT[tFCX̃bN
	ret = lpDDSDst->Lock( NULL, &ddsdDst, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )		return ret;
	ret = lpDDSSrc->Lock( NULL, &ddsdSrc, DDLOCK_WAIT, NULL );
	if( ret != DD_OK ){
			lpDDSDst->Unlock( NULL );
			return ret;
	}
	
	//]E|C^擾
	lpSurfaceDst = ( RGBQUAD* )ddsdDst.lpSurface;
	lpSurfaceSrc = ( RGBQUAD* )ddsdSrc.lpSurface;	
	
	//|C^i߂l
	lPitchDst = ddsdDst.lPitch / sizeof( RGBQUAD );
	lPitchSrc = ddsdSrc.lPitch / sizeof( RGBQUAD );
	
	//ẅ܂ŁA|C^炷
	lpSurfaceDst += ( rcDst.top * lPitchDst + rcDst.left );
	lpSurfaceSrc += ( rcSrc.top * lPitchSrc + rcSrc.left );
	
	//J[L[̎擾
	colorKey = ddsdSrc.ddckCKSrcBlt.dwColorSpaceLowValue;

	//摜
	for( i = 0; i < nHeight; i++ ){
		for( j = 0; j < nWidth; j++ ){
			srcColorKey = *(DWORD*)&lpSurfaceSrc[ j ];			
			if( !( srcColorKey == colorKey && ( USE_COLORKEY & dwFlags ) ) ){
				//ςo				
				ratio = ( lpSurfaceSrc[ j ].rgbRed + lpSurfaceSrc[ j ].rgbGreen + lpSurfaceSrc[ j ].rgbBlue ) / 3;
				//RGBlɕς
				lpSurfaceDst[ j ].rgbRed = (BYTE)ratio;
				lpSurfaceDst[ j ].rgbGreen = (BYTE)ratio;
				lpSurfaceDst[ j ].rgbBlue = (BYTE)ratio;
			}
		}
		lpSurfaceDst += lPitchDst;	//|C^i߂
		lpSurfaceSrc += lPitchSrc;
	}

	//]ẼAbN
	lpDDSSrc->Unlock( NULL );
	lpDDSDst->Unlock( NULL );	
	
	return DD_OK;
}