
/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include<ddraw.h>
#include"DirectDraw.h"
#include"Macro.h"
#include"Global.h"
#include"DirectSound.h"
#include"DirectMusic.h"

/////////////////////////////////////////////////////////////////
//	CN[ht@C
//////////////////////////////////////////////////////////////////

LPDIRECTDRAW7			lpDD = NULL;			//DirectDrawIuWFNg
LPDIRECTDRAWSURFACE7	lpDDSPrimary = NULL;	//vC}T[tFCX	
LPDIRECTDRAWSURFACE7	lpDDSBackBuffer = NULL;	//obNobt@
LPDIRECTDRAWSURFACE7	lpDDSBlankBuffer = NULL;	//obNobt@
LPDIRECTDRAWCLIPPER		lpDDClipper = NULL;		//Nbp[IuWFNg
LPDIRECTDRAWSURFACE7	lpDDSOffscreen[ DDSOFFMAX ] = { 0 };	//ItXN[T[tFCX
LPSTR					lpszStorageFileName[ DDSOFFMAX ];
BYTE					bDDSOffMax = 0;		//gpItXN[
DWORD					g_dwRGBBitCount = 0;	//bpp
DWORD					RShift, GShift, BShift;	//Vtg
DWORD					RMax, GMax, BMax;		//eFől

/////////////////////////////////////////////////////////////////
//	InitDirectDraw֐
// DirectDraw̏ݒ
// []
//	1:EBhEnh
//	2:ʕ
//	3:ʍ
//	4:J[[h(rbgP)
// [ߒl]
//	:TRUE
//	s:FALSE
/////////////////////////////////////////////////////////////////
BOOL InitDirectDraw( HWND hWnd, int width, int height, int depth )
{
	BOOL	fInitDDraw;//̌

	//J[\̕\A\
	if( fDDrawMode == MODE_FULLSCREEN ){	//tXN[
		while( ShowCursor( FALSE ) >= 0 );	//\
	}else{									//EBhE
		while( ShowCursor( TRUE ) < 0 );	//\
	}

	if( fDDrawMode == MODE_FULLSCREEN ){
		//tXN[[h̏
		fInitDDraw = InitDDFullscreenMode( hWnd, width, height, depth );
	}else{
		//EBhE[h̏
		fInitDDraw = InitDDWindowMode( hWnd, width, height, depth );
	}

	//̌ʂԂ
	return	fInitDDraw;
}

/////////////////////////////////////////////////////////////////
//@InitDDFullscreenMode֐
/////////////////////////////////////////////////////////////////
BOOL InitDDFullscreenMode( HWND hWnd, int width, int height, int depth )
{
	HRESULT			ret;		//G[`FbN
	RECT			rect;
	DDSURFACEDESC2	ddsd;		//T[tFCX
	DDSCAPS2		ddscaps;	//T[tFCX̔\́A
	
	//EBhEX^CƃNCAg̈̒
	SetWindowLong( hWnd, GWL_STYLE, FULLSTYLE );
	SetWindowLong( hWnd, GWL_EXSTYLE, FULLSTYLEEX );

	SetRect( &rect, 0, 0, width, height );
	AdjustWindowRectEx(	&rect, FULLSTYLE, FALSE, FULLSTYLEEX );
	SetWindowPos( hWnd, 0, 0, 0, rect.right - rect.left, rect.bottom - rect.top,
					SWP_SHOWWINDOW );

	//DirectDrawIuWFNg̍쐬
	ret = DirectDrawCreateEx( NULL, (void **)&lpDD, IID_IDirectDraw7, NULL );
	if( ret != DD_OK ){
		MessageBox( hWnd, "DirectDrawIuWFNg̍쐬Ɏs", "DirectDrawCreateEx", MB_OK );
		return FALSE;
	}
	//x̐ݒ
	ret = lpDD->SetCooperativeLevel( hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT );
	if( ret != DD_OK ){
		MessageBox( hWnd, "x̐ݒɎs", "SetCooperativeLevel", MB_OK );
		return FALSE;
	}
	//fBXvC[h̐ݒ
	ret = lpDD->SetDisplayMode( width, height, depth, 0, 0 );
	if( ret != DD_OK ){
		MessageBox( hWnd, "fBXvC[h̐ݒɎs", "SetDisplayMode", MB_OK );
		return FALSE;
	}
	//vC}T[tFCXAobNobt@̍쐬
	ZeroMemory( &ddsd, sizeof( DDSURFACEDESC2 ) );
	ddsd.dwSize = sizeof( DDSURFACEDESC2 );
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount = 2;

	ret = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
	if( ret != DD_OK ){
		MessageBox( hWnd, "vC}T[tFCX̍쐬Ɏs", "CreateSurface", MB_OK );
		return FALSE;
	}
	//obNobt@̎擾
	ZeroMemory( &ddscaps, sizeof( DDSCAPS2 ) );
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	ret = lpDDSPrimary->GetAttachedSurface( &ddscaps, &lpDDSBackBuffer );
	if( ret != DD_OK ){
		MessageBox( hWnd, "obNobt@̎擾Ɏs", "GetAttachedSurface", MB_OK );
		return FALSE;
	}
	//obNobt@̎擾
	ZeroMemory( &ddscaps, sizeof( DDSCAPS2 ) );
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	ret = lpDDSPrimary->GetAttachedSurface( &ddscaps, &lpDDSBlankBuffer );
	if( ret != DD_OK ){
		MessageBox( hWnd, "obNobt@̎擾Ɏs", "GetAttachedSurface", MB_OK );
		return FALSE;
	}

	//rbg[hɂF̕ωɂĎ擾
	ret = GetSurfaceFormat( lpDDSBackBuffer );
	if( ret == FALSE )	return FALSE;

	//DirectDraw
	//MessageBox( hWnd, "DirectDraw", "mFp", MB_OK );
	return TRUE;
}

/////////////////////////////////////////////////////////////////
//	InitDDWindowMode֐
/////////////////////////////////////////////////////////////////
BOOL InitDDWindowMode( HWND hWnd, int width, int height, int depth )
{
	HRESULT			ret;		//G[`FbN
	
	RECT			rect;
	HDC				hdc;
	DWORD			x, y;

	DDSURFACEDESC2	ddsd;		//T[tFCX

	//EBhEX^CƃNCAg̈̒
	hdc = GetDC(hWnd);
	x = GetDeviceCaps(hdc, HORZRES);
	y = GetDeviceCaps(hdc, VERTRES);
	ReleaseDC(hWnd, hdc);

	SetWindowLong( hWnd, GWL_STYLE, WNDSTYLE );
	SetWindowLong( hWnd, GWL_EXSTYLE, WNDSTYLEEX );

	SetRect( &rect, 0, 0, width, height );
	AdjustWindowRectEx(	&rect, WNDSTYLE, FALSE, WNDSTYLEEX );

	x -= rect.right - rect.left;	x /= 2;
	y -= rect.bottom - rect.top;	y /= 2;

	SetWindowPos( hWnd, HWND_NOTOPMOST, x, y, rect.right - rect.left, rect.bottom - rect.top,
					SWP_SHOWWINDOW);

	//DirectDrawIuWFNg̍쐬
	ret = DirectDrawCreateEx( NULL, (void **)&lpDD, IID_IDirectDraw7, NULL );
	if( ret != DD_OK ){
		MessageBox( hWnd, "DirectDrawIuWFNg̍쐬Ɏs", "DirectDrawCreateEx", MB_OK );
		return FALSE;
	}
	//x̐ݒ
	ret = lpDD->SetCooperativeLevel( hWnd, DDSCL_NORMAL );
	if( ret != DD_OK ){
		MessageBox( hWnd, "x̐ݒɎs", "SetCooperativeLevel", MB_OK );
		return FALSE;
	}

	//vC}T[tFCX̍쐬
	ZeroMemory( &ddsd, sizeof( DDSURFACEDESC2 ) );
	ddsd.dwSize = sizeof( DDSURFACEDESC2 );
	ddsd.dwFlags = DDSD_CAPS;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;	
	ret = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
	if( ret != DD_OK ){
		MessageBox( hWnd, "vC}T[tFCX̍쐬Ɏs", "CreateSurface", MB_OK );
		return FALSE;
	}
	//obNobt@̍쐬
	ZeroMemory( &ddsd, sizeof( DDSURFACEDESC2 ) );
	ddsd.dwSize = sizeof( DDSURFACEDESC2 );
	ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
	ddsd.dwWidth = width;
	ddsd.dwHeight = height;
	ret = lpDD->CreateSurface( &ddsd, &lpDDSBackBuffer, NULL );
	if( ret != DD_OK ){
		MessageBox( hWnd, "obNobt@̍쐬Ɏs", "CreateSurface", MB_OK );
		return FALSE;
	}
	
	//Nbp[IuWFNg̍쐬
	ret = lpDD->CreateClipper( 0, &lpDDClipper, NULL );
	if( ret != DD_OK ){
		MessageBox( hWnd, "Nbp[IuWFNg̍쐬Ɏs", "CreateClipper", MB_OK );
		return FALSE;
	}
	ret = lpDDClipper->SetHWnd( 0, hWnd );
	if( ret != DD_OK ){
		MessageBox( hWnd, "Nbp[IuWFNg̐ݒɎs", "SetHWnd", MB_OK );
		return FALSE;
	}
	ret = lpDDSPrimary->SetClipper( lpDDClipper );
	if( ret != DD_OK ){
		MessageBox( hWnd, "Nbp[IuWFNg̊֘AtɎs", "SetClipper", MB_OK );
		return FALSE;
	}

	//rbg[hɂF̕ωɂĎ擾
	ret = GetSurfaceFormat( lpDDSBackBuffer );
	if( ret == FALSE )	return FALSE;

	//DirectDraw
	//MessageBox( hWnd, "DirectDraw", "mFp", MB_OK );
	return TRUE;
}

/////////////////////////////////////////////////////////////////
//@ChangeDDrawMode֐
/////////////////////////////////////////////////////////////////
BOOL ChangeDDrawMode( HWND hWnd, int width, int height, int depth )
{
	int		i;
	BOOL	fInitDDraw;//̌

	//DirectDraw
	for( i = 0 ; i < DDSOFFMAX ; i++ ){//ItXN[T[tFCX
		ReleaseDDSOffScreen( lpszStorageFileName[ i ], &lpDDSOffscreen[ i ] );
	}
	//ZJ_obt@̍폜
	for( i = 0 ; i < bDSSBufMax ; i++ ){		
		ReleaseDSSBuffer( &lpDSSBuffer[ i ] );
	}
	//ZOg̍폜
	for( i = 0 ; i < bDMSegMax ; i++ ){		
		ReleaseDMSegment( &lpDMSegment[ i ] );
	}
	
	ReleaseDD();	//̑IuWFNg	

	//[htO؂ւ
	fDDrawMode = !fDDrawMode;

	//J[\̕\A\
	if( fDDrawMode == MODE_FULLSCREEN ){	//tXN[
		while( ShowCursor( FALSE ) >= 0 );	//\
	}else{									//EBhE
		while( ShowCursor( TRUE ) < 0 );	//\
	}

	//tXN[EEBhE[h̐؂ւ
	if( fDDrawMode == MODE_FULLSCREEN ){
		//tXN[[h̏
		fInitDDraw = InitDDFullscreenMode( hWnd, width, height, depth );
	}else{
		//EBhE[h̏
		fInitDDraw = InitDDWindowMode( hWnd, width, height, depth );
	}
	//bpp𒲂ׂ
	g_dwRGBBitCount = CheckRGBBitCount( lpDDSBackBuffer );

	bGameOpeningMode = FUNC_INIT;
	bGamePrologueMode = FUNC_INIT;
	bGamePlayMode = FUNC_INIT;
	bGameEndingMode = FUNC_INIT;

	//̌ʂԂ
	return	fInitDDraw;

}

/////////////////////////////////////////////////////////////////
//	LoadBitmapImage֐
// 쐬ItXN[T[tFCXɃrbg}bvu
// []
//	1:ǂݍރrbg}bṽt@C̕ۑꏊ
//	2:ǂݍރrbg}bṽt@C
//	3:쐬ItXN[T[tFCX̃|C^i[̈̃|C^
//	4:쐬ItXN[T[tFCX̃tO
//	5:EBhEnh
//  6:ʂ̕
// [ߒl]
//	:TRUE
//	s:FALSE
/////////////////////////////////////////////////////////////////
BOOL LoadBitmapImage(
	LPSTR *lpszStorageFileName,
	LPSTR lpszFileName,
	LPDIRECTDRAWSURFACE7 *lplpDDSurface,
	DWORD dwFlags,
	HWND hWnd,
	int width )
{
	DDSURFACEDESC2	ddsd;			//T[tFCX
	DDCOLORKEY		ddck;			//J[L[ݒp\̕ϐ
	DWORD			dwColorKey;		//J[L[
	BITMAP			bitmap;			//rbg}bvf[^
	HBITMAP			hBitmap;		//rbg}bvnh
	HDC				hDC,hMemDC;		//DCnh
	DWORD			dwBitmapWidth;	//rbg}bv̕
	LRESULT			ret;			//G[`FbNp

	//ǂݍރt@Cۑ
	*lpszStorageFileName = (LPSTR)malloc( lstrlen(lpszFileName ) + 1 );
	strcpy( *lpszStorageFileName, lpszFileName );

	//ɑ݂Ă
	ReleaseDDSOffScreen( *lpszStorageFileName, lplpDDSurface );

	//rbg}bv̓ǂݍ
	hBitmap = ( HBITMAP )LoadImage( NULL, *lpszStorageFileName, IMAGE_BITMAP,
		0, 0, LR_CREATEDIBSECTION | LR_LOADFROMFILE );
	if( !hBitmap ){
		MessageBox( hWnd, "rbg}bv̓ǂݍ݂Ɏs", *lpszStorageFileName, MB_OK );
		return FALSE;
	}
	//rbg}bv̎擾
	if( !GetObject( hBitmap, sizeof( BITMAP ), &bitmap ) ){
		MessageBox( hWnd, "rbg}bv̎擾Ɏs", *lpszStorageFileName, MB_OK );
		DeleteObject( hBitmap );
		return FALSE;
	}
	//쐬ItXN[̏ݒ
	ZeroMemory( &ddsd, sizeof( DDSURFACEDESC2 ) );
	ddsd.dwSize = sizeof( DDSURFACEDESC2 );
	ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
	ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | dwFlags;
	dwBitmapWidth = bitmap.bmWidth > width ? width : bitmap.bmWidth;
	ddsd.dwWidth = dwBitmapWidth;
	ddsd.dwHeight = abs( bitmap.bmHeight );
	//ItXN[̍쐬
	ret = lpDD->CreateSurface( &ddsd, lplpDDSurface, NULL );
	if( ret != DD_OK ){
		MessageBox( hWnd, "ItXN[̍쐬Ɏs", *lpszStorageFileName, MB_OK );
		DeleteObject( hBitmap );
		return FALSE;
	}

	//rbg}bvf[^ItXN[ɓ]
	( *lplpDDSurface )->GetDC( &hDC );
	hMemDC = CreateCompatibleDC( hDC );	
	SelectObject( hMemDC, hBitmap );
	BitBlt( hDC, 0, 0, ddsd.dwWidth, ddsd.dwHeight, hMemDC, 0, 0, SRCCOPY );
	DeleteDC( hMemDC );	
	( *lplpDDSurface )->ReleaseDC( hDC );
	DeleteObject( hBitmap );

	//J[L[̐ݒ
	dwColorKey = DD_GetColorKey( lplpDDSurface );
	ZeroMemory( &ddck, sizeof( DDCOLORKEY ) );
	ddck.dwColorSpaceLowValue = dwColorKey;
	ddck.dwColorSpaceHighValue = dwColorKey;
	ret = ( *lplpDDSurface )->SetColorKey( DDCKEY_SRCBLT, &ddck );
	if( ret != DD_OK ){
		MessageBox( hWnd, "J[L[̐ݒɎs", *lpszStorageFileName, MB_OK );		
		return FALSE;
	}

	//LoadBitmapImage
	return TRUE;
}

/////////////////////////////////////////////////////////////////
//	ReLoadBitmapImage֐
// ēxrbg}bvǂݍ݃ItXN[T[tFCXɓ]
// []
//	1:ǂݍރrbg}bṽt@C
//	2:쐬ItXN[T[tFCX̃|C^i[̈̃|C^
//	3:EBhEnh
//  4:ʂ̕
// [ߒl]
//	:TRUE
//	s:FALSE
/////////////////////////////////////////////////////////////////
BOOL ReLoadBitmapImage(
	LPSTR lpszStorageFileName,
	LPDIRECTDRAWSURFACE7 *lplpDDSurface,
	HWND hWnd,
	int width )
{

	BITMAP			bitmap;			//rbg}bvf[^
	HBITMAP			hBitmap;		//rbg}bvnh
	HDC				hDC,hMemDC;		//DCnh
	DWORD			dwBitmapWidth;	//rbg}bv̕
	DWORD			dwBitmapHeight;	//rbg}bv̍
	
	//rbg}bv̓ǂݍ
	hBitmap = ( HBITMAP )LoadImage( NULL, lpszStorageFileName, IMAGE_BITMAP,
		0, 0, LR_CREATEDIBSECTION | LR_LOADFROMFILE );
	if( !hBitmap ){
		MessageBox( hWnd, "rbg}bv̓ǂݍ݂Ɏs", lpszStorageFileName, MB_OK );
		return FALSE;
	}
	//rbg}bv̎擾
	if( !GetObject( hBitmap, sizeof( BITMAP ), &bitmap ) ){
		MessageBox( hWnd, "rbg}bv̎擾Ɏs", lpszStorageFileName, MB_OK );
		DeleteObject( hBitmap );
		return FALSE;
	}
	//rbg}bṽTCY擾
	dwBitmapWidth = bitmap.bmWidth > width ? width : bitmap.bmWidth;
	dwBitmapHeight = abs( bitmap.bmHeight );
	
	//rbg}bvf[^ItXN[ɓ]
	( *lplpDDSurface )->GetDC( &hDC );
	hMemDC = CreateCompatibleDC( hDC );	
	SelectObject( hMemDC, hBitmap );
	BitBlt( hDC, 0, 0, dwBitmapWidth, dwBitmapHeight, hMemDC, 0, 0, SRCCOPY );
	DeleteDC( hMemDC );
	( *lplpDDSurface )->ReleaseDC( hDC );
	DeleteObject( hBitmap );

	//ReLoadBitmapImage
	return TRUE;
}

/////////////////////////////////////////////////////////////////
// ReleaseDD֐
// eIuWFNg̉
/////////////////////////////////////////////////////////////////
void ReleaseDD()
{
	//EBhE[ĥ	
	if( fDDrawMode == MODE_WINDOW ){
		//Nbp[IuWFNg̉
		if( lpDDClipper != NULL ){
			lpDDClipper->Release();
			lpDDClipper = NULL;
		}
		//obNobt@̉
		if( lpDDSBackBuffer != NULL ){
			lpDDSBackBuffer->Release();
			lpDDSBackBuffer = NULL;
		}
	}
	//vC}T[tFCX̉
	if( lpDDSPrimary != NULL ){
		lpDDSPrimary->Release();
		lpDDSPrimary = NULL;
	}
	//DirectDrawIuWFNg̉
	if( lpDD != NULL ){
		lpDD->Release();
		lpDD = NULL;
	}
	return;
}

/////////////////////////////////////////////////////////////////
//ReleaseDDSOffScreen֐
//ItXN[T[tFCX̉
/////////////////////////////////////////////////////////////////
void ReleaseDDSOffScreen( LPSTR	lpszStorageFileName, LPDIRECTDRAWSURFACE7 *lplpDDSurface )
{

	//T[tFCX̉
	if( ( *lplpDDSurface ) != NULL ){
		( *lplpDDSurface )->Release();
		( *lplpDDSurface ) = NULL;
		//ۑĂt@C
		if( lpszStorageFileName != NULL ){
			free( lpszStorageFileName );
			lpszStorageFileName = NULL;
		}
	}

	return;

}

/////////////////////////////////////////////////////////////////
//CheckDDSurfaceLost֐
//T[tFCXXg̃`FbN
/////////////////////////////////////////////////////////////////
void CheckDDSurfaceLost( HWND hWnd, int width )
{
	int		i;
	
	//vC}T[tFCX̃`FbN
	if( lpDDSPrimary != NULL ){
		if( lpDDSPrimary->IsLost() == DDERR_SURFACELOST ){
			lpDDSPrimary->Restore();
		}
	}
	//EBhE[ĥ	
	if( fDDrawMode == MODE_WINDOW ){
		//obNobt@̃`FbN
		if( lpDDSBackBuffer != NULL ){
			if( lpDDSBackBuffer->IsLost() == DDERR_SURFACELOST ){
				lpDDSBackBuffer->Restore();
			}
		}
	}
	//ItXN[T[tFCX̃`FbN
	for( i = 0 ; i < DDSOFFMAX ; i++ ){
		if( lpDDSOffscreen[ i ] != NULL ){
			if( lpDDSOffscreen[ i ]->IsLost() == DDERR_SURFACELOST ){
				lpDDSOffscreen[ i ]->Restore();
				ReLoadBitmapImage( lpszStorageFileName[ i ], &lpDDSOffscreen[ i ], hWnd, width );
			}
		}
	}

	return;
}

/////////////////////////////////////////////////////////////////
//DD_GetColorKey֐
//J[L[̎擾
/////////////////////////////////////////////////////////////////
DWORD	DD_GetColorKey( LPDIRECTDRAWSURFACE7 *lplpDDSurface )
{
	DWORD				dwColorKey = 0;		//J[L[
	HRESULT				ret;				//G[`FbN
	DDSURFACEDESC2		ddsd;				//T[tFCX

	//\̎gp
	ZeroMemory( &ddsd, sizeof( ddsd ) );
	ddsd.dwSize = sizeof( ddsd );

	//T[tFCXbN
	ret = (*lplpDDSurface)->Lock( NULL, &ddsd, DDLOCK_WAIT, NULL );
	if( ret != DD_OK )		return 0;	//bNs
	//RGBl擾
	dwColorKey = *( ( DWORD* )ddsd.lpSurface );
	//32rbgJ[Ⴂ͗]
	if( ddsd.ddpfPixelFormat.dwRGBBitCount < 32 ){
		dwColorKey &= ( 1 << ( ddsd.ddpfPixelFormat.dwRGBBitCount ) ) - 1;
	}	
	//T[tFCXAbN
	(*lplpDDSurface)->Unlock( NULL );
	//J[L[RGBlƂĕԂ
	return	dwColorKey;

}

/////////////////////////////////////////////////////////////////
// CheckRGBBitCount
// rbgJEg𒲂ׂ
//@FׂT[tFCX
//	ߒlFrbgJEg
/////////////////////////////////////////////////////////////////
DWORD	CheckRGBBitCount( LPDIRECTDRAWSURFACE7 lpDDSurface )
{
	
	DDSURFACEDESC2		ddsd;	//T[tFCX

	//T[tFCX̎擾
	ddsd.dwSize = sizeof( ddsd );
	lpDDSurface -> GetSurfaceDesc( &ddsd );
	
	//rbgJEgԂ
	return	ddsd.ddpfPixelFormat.dwRGBBitCount;
}

//////////////////////////////////////////////////////////////////
//rbg[hɂF̕ωɂĎ擾
//cc̏ɂP񂾂Ăяo
//FobNobt@
//ߒlFEs
//////////////////////////////////////////////////////////////////
BOOL GetSurfaceFormat( LPDIRECTDRAWSURFACE7 lpSurface)
{
	DDSURFACEDESC2 ddsd={0};//T[tFCXi[p
	DWORD temp;	//vZp
	
	//G[`FbN
	if( !lpSurface ) return FALSE;

	//T[tFCX̎擾
	ddsd.dwSize = sizeof(ddsd);
	if( FAILED(lpSurface->GetSurfaceDesc( &ddsd ) ) )	return FALSE;
		
	//R̃Vtg
	temp = ddsd.ddpfPixelFormat.dwRBitMask;
	for( RShift = 0 ;  !( temp & 1 ) ; RShift++  )	temp >>= 1;
	//G̃Vtg
	temp = ddsd.ddpfPixelFormat.dwGBitMask;
	for( GShift = 0 ;  !( temp & 1 ) ; GShift++  )	temp >>= 1;
	//B̃Vtg
	temp = ddsd.ddpfPixelFormat.dwBBitMask;
	for( BShift = 0 ;  !( temp & 1 ) ; BShift++  )	temp >>= 1;

	//eF̍ől
	RMax = ddsd.ddpfPixelFormat.dwRBitMask >> RShift;
	GMax = ddsd.ddpfPixelFormat.dwGBitMask >> GShift;
	BMax = ddsd.ddpfPixelFormat.dwBBitMask >> BShift;

	return TRUE;
}

//////////////////////////////////////////////////////////////////
//F擾
//F@Ԃ̏
//		@΂̏
//		O@̏
//ߒlFF
//////////////////////////////////////////////////////////////////
DWORD GetRGB( DWORD r , DWORD g , DWORD b ){
	int R = ( (r * RMax) >> 8 ) << RShift;
	int G = ( (g * GMax) >> 8 ) << GShift;
	int B = ( (b * BMax) >> 8 ) << BShift;
	return R | G | B;
}