#ifndef __DIRECTDRAW_H__
#define __DIRECTDRAW_H__

#include<ddraw.h>

/////////////////////////////////////////////////////////////////
//}N
/////////////////////////////////////////////////////////////////
#define DDSOFFMAX	56

/////////////////////////////////////////////////////////////////
//	GNX^[
/////////////////////////////////////////////////////////////////
extern LPDIRECTDRAWSURFACE7	lpDDSPrimary;		//vC}T[tFCX	
extern LPDIRECTDRAWSURFACE7	lpDDSBackBuffer;	//obNobt@
extern LPDIRECTDRAWSURFACE7	lpDDSBlankBuffer;	//obNobt@
extern LPDIRECTDRAWSURFACE7	lpDDSOffscreen[ DDSOFFMAX ];//ItXN[T[tFCX
extern LPSTR				lpszStorageFileName[ DDSOFFMAX ];
extern BYTE					bDDSOffMax;		//gpItXN[
extern DWORD				g_dwRGBBitCount;	//bpp
extern DWORD				RShift, GShift, BShift;	//Vtg
extern DWORD				RMax, GMax, BMax;		//eFől

/////////////////////////////////////////////////////////////////
//	vg^Cv
/////////////////////////////////////////////////////////////////
BOOL InitDirectDraw( HWND, int, int, int );
BOOL InitDDFullscreenMode( HWND, int, int, int );
BOOL InitDDWindowMode( HWND, int, int, int );
BOOL ChangeDDrawMode( HWND, int, int, int );

BOOL LoadBitmapImage( LPSTR*, LPSTR, LPDIRECTDRAWSURFACE7 *, DWORD, HWND, int );
BOOL ReLoadBitmapImage(	LPSTR,	LPDIRECTDRAWSURFACE7 * );
void ReleaseDD();
void ReleaseDDSOffScreen( LPSTR, LPDIRECTDRAWSURFACE7 * );
void CheckDDSurfaceLost( HWND, int );
DWORD DD_GetColorKey( LPDIRECTDRAWSURFACE7 * );
DWORD CheckRGBBitCount( LPDIRECTDRAWSURFACE7 );
BOOL GetSurfaceFormat( LPDIRECTDRAWSURFACE7 );
DWORD GetRGB( DWORD, DWORD, DWORD );

#endif