
/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include<dmusicc.h>
#include<dmusici.h>
#include"DirectSound.h"
#include"DirectMusic.h"
#include"Macro.h"
#include"Global.h"

/////////////////////////////////////////////////////////////////
//	O[o
/////////////////////////////////////////////////////////////////

IDirectMusic			*lpDM = NULL;				//DirectMusicIuWFNg
IDirectMusicPerformance *lpDMPerformance = NULL;	//DirectMusicPerformanceIuWFNg
IDirectMusicLoader		*lpDMLoader = NULL;			//DirectMusicLoaderIuWFNg
IDirectMusicSegment		*lpDMSegment[ DMSEGMAX ] = {0};//DirectMusicSegmentIuWFNg
BYTE					bDMSegMax = 0;					//gpMIDI̐	

/////////////////////////////////////////////////////////////////
//	InitDirectMusic֐
//@DirectMusic̏
/////////////////////////////////////////////////////////////////
BOOL InitDirectMusic()
{
	//COM̏
	if( FAILED( CoInitialize( NULL ) ) ){
		MessageBox( hWnd, "COM̏Ɏs","CoInitialize", MB_OK );
		return FALSE;
	}
	//ptH[}XIuWFNg̐
	if( FAILED( CoCreateInstance(
		CLSID_DirectMusicPerformance,
		NULL, CLSCTX_INPROC,
		IID_IDirectMusicPerformance2,
		( void ** )&lpDMPerformance ) ) ){
		MessageBox( hWnd, "ptH[}XIuWFNg̐Ɏs","CoCreateInstance", MB_OK );
		return FALSE;
	}
	//ptH[}XIuWFNg̏
	if( FAILED( lpDMPerformance->Init( &lpDM, lpDS, NULL ) ) ){
		MessageBox( hWnd, "ptH[}XIuWFNg̏Ɏs","lpDMPerformance->Init", MB_OK );
		return FALSE;
	}
	//[_[IuWFNg̐
	if( FAILED( CoCreateInstance(
		CLSID_DirectMusicLoader,
		NULL, CLSCTX_INPROC,
		IID_IDirectMusicLoader,
		( void ** )&lpDMLoader ) ) ){
		MessageBox( hWnd, "[_[IuWFNg̐Ɏs","CoCreateInstance", MB_OK );
		return FALSE;
	}
	//|[g̑I
	if( FAILED( lpDMPerformance->AddPort( NULL ) ) ){
		MessageBox( hWnd, "|[g̑IɎs","lpDMPerformance->AddPort", MB_OK );
		return FALSE;
	}

	//DirectMusic̏
	return	TRUE;
}

/////////////////////////////////////////////////////////////////
//	CreateDMSegment֐
//@ZOg̐
/////////////////////////////////////////////////////////////////
BOOL CreateDMSegment(
	LPSTR lpszMidiName,
	IDirectMusicSegment **lplpDMSegment )
{
	DMUS_OBJECTDESC		ObjDesc;		//ZOg̏
	int					nStrlen = 0;	//t@C̕
	int					i;
	
	//ɑ݂Ă
	ReleaseDMSegment( lplpDMSegment );

	//ZOg̏̐ݒ
	ObjDesc.dwSize = sizeof( ObjDesc );
	ObjDesc.guidClass = CLSID_DirectMusicSegment;
	ObjDesc.dwValidData = DMUS_OBJ_CLASS | DMUS_OBJ_FILENAME;
	MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, lpszMidiName, -1,
		ObjDesc.wszFileName, _MAX_PATH );
	//ZOg̐
	if( FAILED( lpDMLoader->GetObject( &ObjDesc, IID_IDirectMusicSegment2, ( void ** )lplpDMSegment ) ) ){
		//t@Cŕϊ
		nStrlen = lstrlen( lpszMidiName );
		for( i = 0 ; i < nStrlen ; i++ ){
			ObjDesc.wszFileName[ i ] = (WCHAR)lpszMidiName[ i ];
		}
		ObjDesc.wszFileName[ i ] = 0;
		if( FAILED( lpDMLoader->GetObject( &ObjDesc, IID_IDirectMusicSegment2, ( void ** )lplpDMSegment ) ) ){
			MessageBox( hWnd, "ZOg̐Ɏs","lpDMLoader->GetObject", MB_OK );
			return FALSE;
		}
	}
	//tf[^̐ݒ
	if( FAILED( ( *lplpDMSegment )->SetParam( GUID_StandardMIDIFile, 0xFFFFFFFF,
		0, 0, ( void * )lpDMPerformance ) ) ){
		MessageBox( hWnd, "tf[^̐ݒɎs","SetParam", MB_OK );
		return FALSE;
	}
	//DLS_E[h
	if( FAILED( ( *lplpDMSegment )->SetParam( GUID_Download, 0xFFFFFFFF,
		0, 0, ( void * )lpDMPerformance ) ) ){
		MessageBox( hWnd, "DLS_E[hɎs","SetParam", MB_OK );
		return FALSE;
	}

	//ZOg̐ɐ
	return TRUE;
}

/////////////////////////////////////////////////////////////////
//	ReleaseDMSegment֐
//@ZOg̉
/////////////////////////////////////////////////////////////////
void ReleaseDMSegment(  IDirectMusicSegment **lplpDMSegment)
{
	//ZOg̉
	if( ( *lplpDMSegment ) != NULL ){		
		lpDMPerformance->Stop( NULL, NULL, 0, 0 );	//~
		( *lplpDMSegment )->SetParam( GUID_Unload, 0xFFFFFFFF, 0, 0,
			(void*)lpDMPerformance );				//DLS̃A[h
		( *lplpDMSegment )->Release();
		( *lplpDMSegment ) = NULL;
	}
	return;
}

/////////////////////////////////////////////////////////////////
//	ReleaseDM֐
//@DirectMusic̉
/////////////////////////////////////////////////////////////////
void ReleaseDM()
{
	//[_[̉
	if( lpDMLoader != NULL ){
		lpDMLoader->Release();
		lpDMLoader = NULL;
	}
	//ptH[}XIuWFNg̉
	if( lpDMPerformance != NULL ){
		lpDMPerformance->CloseDown();
		lpDMPerformance->Release();
		lpDMPerformance = NULL;
	}
	//DirectMusicIuWFNg̉
	if( lpDM != NULL ){
		lpDM->Release();
		lpDM = NULL;
	}
	//COM̉
	CoUninitialize();

	return;
}
