#define PI 3.141592 / 180			//~

//////////////////////////////////////////////////////////////////
//\̃f[^
//////////////////////////////////////////////////////////////////
#include<windows.h>
#include<math.h>
#include"Main.h"
#include"Global.h"
#include"Input.h"
#include"FigData.h"

//Ff[^iFhcf[^j
RGBCOLOR	RGBC[] = {
      0,  0,255,
      0,255,  0,
	255,  0,  0,
	255,  0,255,
	  0,255,255,
	 10, 10,255
};

FIGDATA	FigData[FIG_NUM];

//|Sf[^̍쐬
void	CreatePolygon()
{

	int	i;

	//ê̏W
	VERTEX		Local[ FIG_NUM ] = {
		  0.0f, 100.0f,    0.0f
	};

	//ễTCY
	VERTEX		Size[ FIG_NUM ] = {
		1.0f, 1.0f, 1.0f
	};

	//_̈ړ
	VERTEX		Move[ FIG_NUM ] = {
		{  0.0f,  0.0f,   0.0f}
	};

	//ễf[^
	CreateGlobe( &FigData[0], &Local[0], 50.0, 16, &Size[0], &Move[0], 2 );

	FigData[0].pFig_Parent = NULL;

	for( i = 0; i < FIG_NUM; i++ ){
		FigData[i].Local_Cnt = FigData[i].Local;
		FigData[i].Angle_c = FigData[i].RotateAngle;
	}

}

///////////////////////////////////////////////////////////////////////////
//̂̍쐬
//F@|S\
//		@[JW
//		O@ӂ̒
//		l@TCY
//		܁@_̈ړ
//		Z@F
//ߒlFȂ
////////////////////////////////////////////////////////////////////////////
void	CreateCube(
					FIGDATA		*i_model,
					VERTEX		*Local,
					float		i_side,
					VERTEX		*i_size,
					VERTEX		*i_move,
					int			col
					)
{

	int		i;

	float r = ( float )i_side / 2;

	//̒_f[^ANf[^
	VERTEX	CubeVer[ 8 ] = {
		-r,	-r,	-r,
		r,	-r,	-r,
		r,	-r,	r,
		-r,	-r,	r,
		-r,	r,	-r,
		r,	r,	-r,
		r,	r,	r,
		-r,	r,	r,
	};

	LINKDATA	CubeLink[ 12 ] = {	//_̌q,ʂ̐F
		{ 0, 1, 2},
		{ 0, 2, 3},
		{ 0, 5, 1},
		{ 0, 4, 5},
		{ 0, 7, 4},
		{ 0, 3, 7},
		{ 1, 6, 2},
		{ 1, 5, 6},
		{ 2, 7, 3},
		{ 2, 6, 7},
		{ 4, 7, 5},
		{ 5, 7, 6}
	};	

	//TCY̕ύX
	for( i = 0; i < 8; i++ ){
		CubeVer[ i ].x *= i_size->x;
		CubeVer[ i ].y *= i_size->y;
		CubeVer[ i ].z *= i_size->z;
	}

	//_̈ړimɂ͒_f[^炷j
	for( i = 0; i < 8; i++ ){
		CubeVer[ i ].x += i_move->x;
		CubeVer[ i ].y += i_move->y;
		CubeVer[ i ].z += i_move->z;
	}

	i_model->nVertex		=	8;									//_
	i_model->nPlane			=	12;									//ʐ
	i_model->pVertexBuf		=	new	VERTEX[ i_model->nVertex ];		//_Wi[p
	i_model->pVertexBuf_cnt	=	new	VERTEX[ i_model->nVertex ];		//_WvZp
	i_model->pShadowBuf		=	new	VERTEX[ i_model->nVertex ];		//eWi[AvZp
	i_model->pLinkBuf		=	new	LINKDATA[ i_model->nPlane ];	//Nf[^
	i_model->pPolygonOrder	=	new	int[ i_model->nPlane ];			//ʃ\[gf[^
	i_model->pBrightness	=	new	float[ i_model->nVertex ];		//f[^
	i_model->col			=	new RGBCOLOR[ i_model->nVertex ];	//Ff[^
	i_model->col_c			=	new RGBCOLOR[ i_model->nVertex ];	//Ff[^vZp
	i_model->VerVect		=	new	VERTEX[ i_model->nVertex ];		//_̖@xNg

	memcpy( i_model->pLinkBuf, CubeLink, sizeof( CubeLink ) );		//_f[^̃Rs[
	memcpy( i_model->pVertexBuf, CubeVer, sizeof( CubeVer ) );		//Nf[^̃Rs[

	i_model->Local		=	*Local;
	i_model->RotateAngle.xy	=	0;
	i_model->RotateAngle.yz	=	0;
	i_model->RotateAngle.zx	=	0;
	i_model->Angle_c = i_model->RotateAngle;

	//Fݒ
	for( i = 0; i < 8; i++ ){
		i_model->col[i].r = i;
		i_model->col[i].g = i;
		i_model->col[i].b = 255;
	}

}

///////////////////////////////////////////////////////////////////////////
//̂̍쐬ij
//F@|S\
//		@[JW
//		O@ӂ̒
//		l@TCY
//		܁@_̈ړ
//		Z@F
//ߒlFȂ
////////////////////////////////////////////////////////////////////////////
void	CreateCube2(
					FIGDATA		*i_model,
					VERTEX		*Local,
					float		i_side,
					VERTEX		*i_size,
					VERTEX		*i_move,
					int			col
					)
{

	int		i;

	float r = ( float )i_side / 2;

	//̒_f[^ANf[^
	VERTEX	CubeVer[ 8 ] = {
		-r-30,	-r,	-r-30,
		r+30,	-r,	-r-30,
		r+30,	-r,	r+30,
		-r-30,	-r,	r+30,
		-r-30,	r,	-r-30,
		r+30,	r,	-r-30,
		r+30,	r,	r+30,
		-r-30,	r,	r+30,
	};

	LINKDATA	CubeLink[ 12 ] = {	//_̌q
		{ 0, 1, 2},
		{ 0, 2, 3},
		{ 0, 5, 1},
		{ 0, 4, 5},
		{ 0, 7, 4},
		{ 0, 3, 7},
		{ 1, 6, 2},
		{ 1, 5, 6},
		{ 2, 7, 3},
		{ 2, 6, 7},
		{ 4, 7, 5},
		{ 5, 7, 6}
	};	

	//TCY̕ύX
	for( i = 0; i < 8; i++ ){
		CubeVer[ i ].x *= i_size->x;
		CubeVer[ i ].y *= i_size->y;
		CubeVer[ i ].z *= i_size->z;
	}

	//_̈ړimɂ͒_f[^炷j
	for( i = 0; i < 8; i++ ){
		CubeVer[ i ].x += i_move->x;
		CubeVer[ i ].y += i_move->y;
		CubeVer[ i ].z += i_move->z;
	}

	i_model->nVertex		=	8;									//_
	i_model->nPlane			=	12;									//ʐ
	i_model->pVertexBuf		=	new	VERTEX[ i_model->nVertex ];		//_Wi[p
	i_model->pVertexBuf_cnt	=	new	VERTEX[ i_model->nVertex ];		//_WvZp
	i_model->pShadowBuf		=	new	VERTEX[ i_model->nVertex ];		//eWi[AvZp
	i_model->pLinkBuf		=	new	LINKDATA[ i_model->nPlane ];	//Nf[^
	i_model->pPolygonOrder	=	new	int[ i_model->nPlane ];			//ʃ\[gf[^
	i_model->pBrightness	=	new	float[ i_model->nVertex ];		//f[^
	i_model->col			=	new RGBCOLOR[ i_model->nVertex ];	//Ff[^
	i_model->col_c			=	new RGBCOLOR[ i_model->nVertex ];	//Ff[^vZp
	i_model->VerVect		=	new	VERTEX[ i_model->nVertex ];		//_̖@xNg

	memcpy( i_model->pLinkBuf, CubeLink, sizeof( CubeLink ) );		//_f[^̃Rs[
	memcpy( i_model->pVertexBuf, CubeVer, sizeof( CubeVer ) );		//Nf[^̃Rs[

	i_model->Local		=	*Local;
	i_model->RotateAngle.xy	=	0;
	i_model->RotateAngle.yz	=	0;
	i_model->RotateAngle.zx	=	0;	
	i_model->Angle_c = i_model->RotateAngle;

	//Fݒ
	for( i = 0; i < 8; i++ ){
		i_model->col[i].r = 0;
		i_model->col[i].g = 0;
		i_model->col[i].b = 255;
	}

}

////////////////////////////////////////////////////////////////////////////
//̂̍쐬
//F@|S\
//		@[JW
//		O@̔a
//		l@
//		܁@TCY
//		Z@_̈ړ
//		掵@F
//ߒlFȂ
////////////////////////////////////////////////////////////////////////////
void	CreateGlobe(
			FIGDATA		*i_model,	//ff[^
			VERTEX		*i_Local,	//[JW
			float		radius,		//̔a
			int			n,			//
			VERTEX		*i_size,
			VERTEX		*i_move,
			int			col)
{
	int		i,j;
	int		add;								//vfԍp
	float	devide = ( float )( 180.0 / n );		//px
	float	degree = 90.f;						//px
	VERTEX		*GlobeVer;
	LINKDATA	*GlobeLink;

	i_model->nVertex		=	2 + ( n - 1 ) * n * 2;				//_
	i_model->nPlane			=	( ( n - 1 ) * 2 ) * n * 2;			//ʐ
	i_model->pVertexBuf		=	new	VERTEX[ i_model->nVertex ];		//_Wi[p
	i_model->pVertexBuf_cnt	=	new	VERTEX[ i_model->nVertex ];		//_WvZp
	i_model->pShadowBuf		=	new	VERTEX[ i_model->nVertex ];		//eWi[AvZp
	i_model->pLinkBuf		=	new	LINKDATA[ i_model->nPlane ];	//Nf[^	
	i_model->pPolygonOrder	=	new	int[ i_model->nPlane ];			//ʃ\[gf[^
	i_model->pBrightness	=	new	float[ i_model->nVertex ];		//f[^
	i_model->col			=	new RGBCOLOR[ i_model->nVertex ];	//Ff[^
	i_model->col_c			=	new RGBCOLOR[ i_model->nVertex ];	//Ff[^vZp
	i_model->VerVect		=	new	VERTEX[ i_model->nVertex ];		//_̖@xNg

	//vZpm
	GlobeVer	=	new	VERTEX[ i_model->nVertex ];
	GlobeLink	=	new	LINKDATA[ i_model->nPlane ];

	//_W߂
	//ŏ_ƍŉ_
	GlobeVer[0].x = 0;
	GlobeVer[0].y = radius;
	GlobeVer[0].z = 0;
	GlobeVer[1].x = 0;
	GlobeVer[1].y = -radius;
	GlobeVer[1].z = 0;

	//_WݒiPC̎c蒸_y]j
	for( i=2; i<=n; i++ )
	{ 
		degree -= devide;
		GlobeVer[i].x	=	( float )( GlobeVer[0].y * cos( degree * PI ) );
		GlobeVer[i].y	=	( float )( GlobeVer[0].y * sin( degree * PI ) );
		GlobeVer[i].z	=	0;
	}
	//_WݒicS_x]j
	degree = 0;
	for( i=1; i<n*2; i++ )
	{
		degree += devide;	//]px̐ݒ
		add = (n-1) * i;	//vfԍ
		for( j=2; j<=n; j++ )
		{
			GlobeVer[ j+add ].x = ( float )( GlobeVer[ j ].x * cos( degree * PI ) );
			GlobeVer[ j+add ].y = GlobeVer[ j ].y;
			GlobeVer[ j+add ].z = ( float )( GlobeVer[ j ].x * sin( degree * PI ) );
		}
	}

	//Nf[^߂
	//PC
	GlobeLink[ 0 ].v0 = 0;
	GlobeLink[ 0 ].v1 = 2+(n-1);
	GlobeLink[ 0 ].v2 = 2;
	GlobeLink[ 1 ].v0 = 1;
	GlobeLink[ 1 ].v1 = n;
	GlobeLink[ 1 ].v2 = n+(n-1);
	int	vnum;
	for( i=2,vnum=2; vnum<n; i+=2,vnum++ )
	{
		GlobeLink[ i ].v0	=	vnum;
		GlobeLink[ i ].v1	=	vnum+(n-1);
		GlobeLink[ i ].v2	=	vnum+n;
		GlobeLink[ i+1 ].v0	=	vnum+1;
		GlobeLink[ i+1 ].v1	=	vnum;
		GlobeLink[ i+1 ].v2	=	vnum+n;
	}
	
	//Op`f[^(ŏICc胉Cj
	int fnum;
	for( i=1; i<n*2-1; i++ )
	{
		add  = (n-1) * i;	//ꃉC̒_ԍ̉Zl
		fnum = (n*2-2) * i;	//[vƂɊJnOp`ԍ
		GlobeLink[ fnum ].v0 = 0;
		GlobeLink[ fnum ].v1 = GlobeLink[0].v1 + add;
		GlobeLink[ fnum ].v2 = GlobeLink[0].v2 + add;
		GlobeLink[ fnum+1 ].v0 = 1;
		GlobeLink[ fnum+1 ].v1 = GlobeLink[1].v1 + add;
		GlobeLink[ fnum+1 ].v2 = GlobeLink[1].v2 + add;
		for( j=2,vnum=2; vnum<n; j+=2,vnum++ )
		{
			GlobeLink[ j+fnum ].v0 = GlobeLink[ j ].v0 + add;
			GlobeLink[ j+fnum ].v1 = GlobeLink[ j ].v1 + add;
			GlobeLink[ j+fnum ].v2 = GlobeLink[ j ].v2 + add;
			GlobeLink[ j+fnum+1 ].v0 = GlobeLink[ j+1 ].v0 + add;
			GlobeLink[ j+fnum+1 ].v1 = GlobeLink[ j+1 ].v1 + add;
			GlobeLink[ j+fnum+1 ].v2 = GlobeLink[ j+1 ].v2 + add;
		}
	}

	//Op`f[^(ŏICj
	add  = (n-1) * i;
	fnum = (n*2-2) * i;
	GlobeLink[ fnum ].v0 = 0;
	GlobeLink[ fnum ].v1 = 2;
	GlobeLink[ fnum ].v2 = GlobeLink[0].v2 + add;
	GlobeLink[ fnum+1 ].v0 = 1;
	GlobeLink[ fnum+1 ].v1 = GlobeLink[1].v1 + add;
	GlobeLink[ fnum+1 ].v2 = n;
	for( i=2,vnum=2; vnum<n; i+=2,vnum++ )
	{
		GlobeLink[ i+fnum ].v0 = GlobeLink[i].v0 + add;
		GlobeLink[ i+fnum ].v1 = GlobeLink[i].v0;
		GlobeLink[ i+fnum ].v2 = GlobeLink[i].v0+1;
		GlobeLink[ i+fnum+1 ].v0 = GlobeLink[i+1].v0 + add;
		GlobeLink[ i+fnum+1 ].v1 = GlobeLink[i+1].v0 + add - 1;
		GlobeLink[ i+fnum+1 ].v2 = GlobeLink[i+1].v0;
	}

	//TCY̕ύX
	for( i = 0; i < i_model->nVertex; i++ ){
		GlobeVer[ i ].x *= i_size->x;
		GlobeVer[ i ].y *= i_size->y;
		GlobeVer[ i ].z *= i_size->z;
	}

	//_̈ړimɂ͒_f[^炷j
	for( i = 0; i < i_model->nVertex; i++ ){
		GlobeVer[ i ].x += i_move->x;
		GlobeVer[ i ].y += i_move->y;
		GlobeVer[ i ].z += i_move->z;
	}

	//Fݒ
	/*for( i = 0; i < i_model->nVertex; i++ ){
		switch( i % 3 ){
		case 0:
			i_model->col[i].r = 0;
			i_model->col[i].g = 0;
			i_model->col[i].b = 255;
			break;
		case 1:
			i_model->col[i].r = 255;
			i_model->col[i].g = 0;
			i_model->col[i].b = 0;
			break;
		case 2:
			i_model->col[i].r = 0;
			i_model->col[i].g = 255;
			i_model->col[i].b = 0;
			break;
		}
	}*/
	for( i = 0; i < i_model->nVertex; i++ ){
		i_model->col[i].r = RGBC[col].r;
		i_model->col[i].g = RGBC[col].g;
		i_model->col[i].b = RGBC[col].b;
	}

	//_f[^̃Rs[
	memcpy( i_model->pLinkBuf, GlobeLink, sizeof( LINKDATA ) * i_model->nPlane );
	//Nf[^̃Rs[
	memcpy( i_model->pVertexBuf, GlobeVer, sizeof( VERTEX ) * i_model->nVertex );

	//[JW̐ݒ
	i_model->Local		=	*i_Local;
	//]px̐ݒ
	i_model->RotateAngle.xy	=	0;
	i_model->RotateAngle.yz	=	0;
	i_model->RotateAngle.zx	=	0;
	i_model->Angle_c = i_model->RotateAngle;

}

///////////////////////////////////////////////////////////////////////////
//S̍쐬
//F@|S\
//		@[JW
//		O@ӂ̒
//		l@TCY
//		܁@_̈ړ
//		Z@F
//ߒlFȂ
////////////////////////////////////////////////////////////////////////////
void	CreateS(
					FIGDATA		*i_model,
					VERTEX		*Local,
					float		i_side,
					VERTEX		*i_size,
					VERTEX		*i_move,
					int			col
					)
{
	int		i;

	//Op_f[^ANf[^
	VERTEX	TriVer[ 60 ] = {
		 50.0,  30.0, -15.0,		//_O
		 17.0,  50.0, -15.0,		//_P
		 28.0,  30.0, -15.0,		//_Q
		 17.0,  40.0, -15.0,		//_R
		-17.0,  50.0, -15.0,		//_S
		-17.0,  40.0, -15.0,		//_T
		-28.0,  30.0, -15.0,		//_U
		-50.0,  30.0, -15.0,		//_V
		-28.0,  20.0, -15.0,		//_W
		-50.0,  20.0, -15.0,		//_X
		-17.0,   7.0, -15.0,		//_PO
		-17.0,  -7.0, -15.0,		//_PP
		 17.0,   7.0, -15.0,		//_PQ
		 17.0,  -7.0, -15.0,		//_PR
		 50.0, -20.0, -15.0,		//_PS
		 28.0, -20.0, -15.0,		//_PT
		 50.0, -30.0, -15.0,		//_PU
		 28.0, -30.0, -15.0,		//_PV
		 17.0, -50.0, -15.0,		//_PW
		 17.0, -40.0, -15.0,		//_PX
		-17.0, -40.0, -15.0,		//_QO
		-17.0, -50.0, -15.0,		//_QP
		-28.0, -30.0, -15.0,		//_QQ
		-50.0, -30.0, -15.0,		//_QR
		 50.0,  30.0,  15.0,		//_QS
		 17.0,  50.0,  15.0,		//_QT
		 28.0,  30.0,  15.0,		//_QU
		 17.0,  40.0,  15.0,		//_QV
		-17.0,  50.0,  15.0,		//_QW
		-17.0,  40.0,  15.0,		//_QX
		-28.0,  30.0,  15.0,		//_RO
		-50.0,  30.0,  15.0,		//_RP
		-28.0,  20.0,  15.0,		//_RQ
		-50.0,  20.0,  15.0,		//_RR
		-17.0,   7.0,  15.0,		//_RS
		-17.0,  -7.0,  15.0,		//_RT
		 17.0,   7.0,  15.0,		//_RU
		 17.0,  -7.0,  15.0,		//_RV
		 50.0, -20.0,  15.0,		//_RW
		 28.0, -20.0,  15.0,		//_RX
		 50.0, -30.0,  15.0,		//_SO
		 28.0, -30.0,  15.0,		//_SP
		 17.0, -50.0,  15.0,		//_SQ
		 17.0, -40.0,  15.0,		//_SR
		-17.0, -40.0,  15.0,		//_SS
		-17.0, -50.0,  15.0,		//_ST
		-28.0, -30.0,  15.0,		//_SU
		-50.0, -30.0,  15.0,		//_SV
		 39.0,  40.0, -15.0,		//_SW
		-39.0,  40.0, -15.0,		//_SX
		-42.0,  10.0, -15.0,		//_TO
		 42.0, -10.0, -15.0,		//_TP
		 39.0, -40.0, -15.0,		//_TQ
		-39.0, -40.0, -15.0,		//_TR
		 39.0,  40.0,  15.0,		//_TS
		-39.0,  40.0,  15.0,		//_TT
		-39.0,  10.0,  15.0,		//_TU
		 39.0, -10.0,  15.0,		//_TV
		 39.0, -40.0,  15.0,		//_TW
		-39.0, -40.0,  15.0 		//_TX
	};

	LINKDATA	TriLink[ 117 ] = {	//_̌q,ʂ̐F
		{0, 2, 48},{48,2, 3 },{48,3, 1 },{1, 3, 4 },
		{3, 5, 4 },{4, 5, 49},{5, 6, 49},{49,6, 7 },
		{6, 9, 7 },{6, 8, 9 },{8, 50,9 },{8, 10,50},
		{10,11,50},{10,13,11},{12,13,10},{12,51,13},
		{51,15,13},{51,14,15},{14,16,15},{16,17,15},
		{16,52,17},{17,52,19},{52,18,19},{19,18,20},
		{18,21,20},{20,21,53},{20,53,22},{22,53,23},
		{24,54,26},{26,54,27},{27,54,25},{27,25,28},
		{29,27,28},{29,28,55},{30,29,55},{30,55,31},
		{33,30,31},{33,32,30},{56,32,33},{56,34,32},
		{35,34,56},{35,37,34},{37,36,34},{37,57,36},
		{39,57,37},{39,38,57},{40,38,39},{41,40,39},
		{58,40,41},{58,41,43},{42,58,43},{42,43,44},
		{45,42,44},{45,44,59},{59,44,46},{59,46,47},
		{48,24,0 },{54,24,48},{54,48,1 },{25,54,1 },
		{25,1, 4 },{28,25,4 },{4, 49,28},{28,49,55},
		{49,7, 55},{55,7, 31},{7, 9, 31},{9, 33,31},
		{9, 50,33},{50,56,33},{50,11,56},{11,35,56},
		{11,13,35},{13,37,35},{13,15,37},{15,39,37},
		{15,17,39},{17,41,39},{17,19,41},{41,19,43},
		{19,20,43},{43,20,44},{20,22,44},{22,46,44},
		{22,23,46},{46,23,47},{0, 26,2 },{24,26,0 },
		{2, 26,3 },{26,27,3 },{3, 27,5 },{27,29,5 },
		{5, 29, 6},{29,30,6 },{6, 30,8 },{30,32,8 },
		{8, 32,10},{32,34,10},{10,34,12},{34,36,12},
		{12,36,51},{36,57,51},{51,57,14},{57,38,14},
		{14,38,16},{38,40,16},{16,40,52},{40,58,52},
		{52,58,18},{58,42,18},{18,42,21},{42,45,21},
		{21,45,53},{45,59,53},{53,59,23},{59,47,23}
	};	

	//TCY̕ύX
	for( i = 0; i < 60; i++ ){
		TriVer[ i ].x *= i_size->x;
		TriVer[ i ].y *= i_size->y;
		TriVer[ i ].z *= i_size->z;
	}

	//_̈ړimɂ͒_f[^炷j
	for( i = 0; i < 60; i++ ){
		TriVer[ i ].x += i_move->x;
		TriVer[ i ].y += i_move->y;
		TriVer[ i ].z += i_move->z;
	}

	i_model->nVertex		=	60;									//_
	i_model->nPlane			=	116;								//ʐ
	i_model->pVertexBuf		=	new	VERTEX[ i_model->nVertex ];		//_Wi[p
	i_model->pVertexBuf_cnt	=	new	VERTEX[ i_model->nVertex ];		//_WvZp
	i_model->pShadowBuf		=	new	VERTEX[ i_model->nVertex ];		//eWi[AvZp
	i_model->pLinkBuf		=	new	LINKDATA[ i_model->nPlane ];	//Nf[^
	i_model->pPolygonOrder	=	new	int[ i_model->nPlane ];			//ʃ\[gf[^
	i_model->pBrightness	=	new	float[ i_model->nVertex ];		//f[^
	i_model->col			=	new RGBCOLOR[ i_model->nVertex ];	//Ff[^
	i_model->col_c			=	new RGBCOLOR[ i_model->nVertex ];	//Ff[^vZp
	i_model->VerVect		=	new	VERTEX[ i_model->nVertex ];		//_̖@xNg

	memcpy( i_model->pLinkBuf, TriLink, sizeof( TriLink ) );		//_f[^̃Rs[
	memcpy( i_model->pVertexBuf, TriVer, sizeof( TriVer ) );		//Nf[^̃Rs[

	i_model->Local		=	*Local;
	i_model->RotateAngle.xy	=	0;
	i_model->RotateAngle.yz	=	0;
	i_model->RotateAngle.zx	=	0;
	i_model->Angle_c = i_model->RotateAngle;

	//Fݒ
	for( i = 0; i < i_model->nVertex; i++ ){
		i_model->col[i].r = 0;
		i_model->col[i].g = 0;
		i_model->col[i].b = 255;
	}

}

///////////////////////////////////////////////////////////////////////////
//Op`̍쐬iꖇj
//F@|S\
//		@[JW
//		O@ӂ̒
//		l@TCY
//		܁@_̈ړ
//		Z@F
//ߒlFȂ
////////////////////////////////////////////////////////////////////////////
void	CreateTri(
					FIGDATA		*i_model,
					VERTEX		*Local,
					float		i_side,
					VERTEX		*i_size,
					VERTEX		*i_move,
					int			col
					)
{

	float r = ( float )i_side / 2;

	//̒_f[^ANf[^
	VERTEX	CubeVer[ 3 ] = {
		  0, 50, 0,
		-50,  0, 0,
		 50,  0, 0
	};

	LINKDATA	CubeLink[ 1 ] = {	//_̌q,ʂ̐F
		{ 2, 1, 0}
	};	

	//TCY̕ύX
	for( int i = 0; i < 3; i++ ){
		CubeVer[ i ].x *= i_size->x;
		CubeVer[ i ].y *= i_size->y;
		CubeVer[ i ].z *= i_size->z;
	}

	//_̈ړimɂ͒_f[^炷j
	for( i = 0; i < 3; i++ ){
		CubeVer[ i ].x += i_move->x;
		CubeVer[ i ].y += i_move->y;
		CubeVer[ i ].z += i_move->z;
	}

	i_model->nVertex		=	3;									//_
	i_model->nPlane			=	1;									//ʐ
	i_model->pVertexBuf		=	new	VERTEX[ i_model->nVertex ];		//_Wi[p
	i_model->pVertexBuf_cnt	=	new	VERTEX[ i_model->nVertex ];		//_WvZp
	i_model->pShadowBuf		=	new	VERTEX[ i_model->nVertex ];		//eWi[AvZp
	i_model->pLinkBuf		=	new	LINKDATA[ i_model->nPlane ];	//Nf[^
	i_model->pPolygonOrder	=	new	int[ i_model->nPlane ];			//ʃ\[gf[^
	i_model->pBrightness	=	new	float[ i_model->nVertex ];		//f[^
	i_model->col			=	new RGBCOLOR[ i_model->nVertex ];	//Ff[^
	i_model->col_c			=	new RGBCOLOR[ i_model->nVertex ];	//Ff[^vZp
	i_model->VerVect		=	new	VERTEX[ i_model->nVertex ];		//_̖@xNg

	memcpy( i_model->pLinkBuf, CubeLink, sizeof( CubeLink ) );		//_f[^̃Rs[
	memcpy( i_model->pVertexBuf, CubeVer, sizeof( CubeVer ) );		//Nf[^̃Rs[

	i_model->Local		=	*Local;
	i_model->RotateAngle.xy	=	0;
	i_model->RotateAngle.yz	=	0;
	i_model->RotateAngle.zx	=	0;
	i_model->Angle_c = i_model->RotateAngle;

	//Fݒ
	/*for( i = 0; i < i_model->nVertex; i++ ){
		i_model->col[i].r = i*20+10;
		i_model->col[i].g = i*40+40;
		i_model->col[i].b = i*60+80;
	}*/
	i_model->col[0].r = 0;
	i_model->col[0].g = 0;
	i_model->col[0].b = 255;
	i_model->col[1].r = 0;
	i_model->col[1].g = 255;
	i_model->col[1].b = 0;
	i_model->col[2].r = 255;
	i_model->col[2].g = 0;
	i_model->col[2].b = 0;

}

///////////////////////////////////////////////////////////////////
//|Sf[^̃J
//FȂ
//ߒlFȂ
///////////////////////////////////////////////////////////////////
void	DeletePolygon()
{
	int	i;
	for( i=0; i<FIG_NUM; i++ ){
		delete	[]FigData[i].pVertexBuf;
		delete	[]FigData[i].pVertexBuf_cnt;
		delete	[]FigData[i].pShadowBuf;
		delete	[]FigData[i].pLinkBuf;
		delete	[]FigData[i].pPolygonOrder;
		delete	[]FigData[i].pBrightness;		
		delete	[]FigData[i].col;
		delete	[]FigData[i].col_c;
	}
}
