//////////////////////////////////////////////////////////
//CN[ht@C
//////////////////////////////////////////////////////////
#include<windows.h>
#include<math.h>
#include<stdio.h>
#include"Main.h"
#include"Light.h"
#include"FigData.h"
#include"ScanLine.h"

//////////////////////////////////////////////////////////
//GNX^[
//////////////////////////////////////////////////////////
LIGHT light = { {0,100,0},	//ʒu
				{0.0,-1.0,1.0},	//xNg
				1,				//^Cv
				10000.0,		//E
				0.3f,			//
				{1.0, 1.0, 1.0}	//Ǝ˗
};

//////////////////////////////////////////////////////////
//֘A
//////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
//|Sʂ̐FvZij
//F|S\
//ߒlFȂ
//////////////////////////////////////////////////////////////////////
void GetPolygonColor( FIGDATA *fig ){

	if( light.type == FALSE ){
		GetPolygonBright( fig->VerVect,
						 fig->pBrightness,
						 fig->nVertex);
		GetPolygonShadow( fig->pShadowBuf, 
			fig->pVertexBuf_cnt, fig->nVertex );
	}else{
		GetPointBright( fig->pBrightness, fig->pVertexBuf_cnt, 
			fig->VerVect, &light, fig->nVertex );
		GetPointShadow( fig->pShadowBuf, fig->pVertexBuf_cnt, 
			&light.pos, fig->nVertex );
	}

}

///////////////////////////////////////////////////////////////
//|Sʂ̐FvZiLj
//F@_̖@xNg
//		@Ff[^i[p
//		O@_
//ߒl@Ȃ
///////////////////////////////////////////////////////////////
void GetPolygonBright( VERTEX	*pVect,			//_̖@xNg
					   float	*pbrightness,	//Ff[^iʕۑpj
					   int		nVer			//_
){

	int		i;
	float	csa,L1, L2;	//pcosli[p
	VERTEX	vect={-light.vect.x, -light.vect.y, -light.vect.z};//txNg

	for( i = 0; i < nVer; i++ ){

		//xNgƖ@xNĝȂpx߂
		L1 = (float)sqrt( vect.x * vect.x + vect.y * vect.y + vect.z * vect.z );
		L2 = (float)sqrt( pVect->x * pVect->x + pVect->y * pVect->y + pVect->z * pVect->z );
		csa = ( vect.x * pVect->x + vect.y * pVect->y + vect.z * pVect->z ) / (L1 * L2);

		csa += 1.0;
		csa /= 2.0;

		//Px̌vZ
		pbrightness[i] = csa;
		//̋

		pVect++;
	}

}

///////////////////////////////////////////////////////////////////
//evZiLj
//F@e̒_f[^i[p
//		@_f[^
//		O@_
//ߒl@Ȃ
///////////////////////////////////////////////////////////////////
void GetPolygonShadow( VERTEX *vertex_s, VERTEX *vertex_c, short nVertex ){

	int			i;
	float		X, Y, Z;

	//_xNgtxNgɂ
	for( i = 0; i < nVertex; i++ ){
		X = vertex_c[i].x;
		Y = vertex_c[i].y;
		Z = vertex_c[i].z;

		//Ɣ
		vertex_s[i].x = X + light.vect.x * ( -Y / light.vect.y );
		vertex_s[i].y = 0;
		vertex_s[i].z = Z + light.vect.z * ( -Y / light.vect.y );

		/*
		//ȏ
		vertex_s[i].x = ( Light.x * Y - Light.y * X) / ( Y - Light.y );
		vertex_s[i].y = 0;
		vertex_s[i].z = ( Light.z * Y - Light.y * Z) / ( Y - Light.y );
		*/
	}

}


////////////////////////////////////////////////////////////////////
//_
//F@ϊ̖ʂ̐Fi[p
//		@_f[^(O[oWnϊ)
//		O@_@xNg
//		l@xNgf[^
//		܁@_
//ߒl@Ȃ
////////////////////////////////////////////////////////////////////
void	GetPointBright(
					float		*pBright,	//ϊ̖ʂ̐Fi[p
					VERTEX		*pVer,		//_f[^(O[oWnϊ)
					VERTEX		*pVect,		//_@xNg
					LIGHT		*pLight,	//xNgf[^
					DWORD		nVer		//_
					)
{

	//ϐ錾
	DWORD	i;
	VERTEX	LightBuf;	//vZp
	float	Cos;		//pi[p
	float	Dis;		//ʂƌ̋
	float	Pow;		//̋

	for( i=0; i<nVer; i++ ){

		//xNg߂
		LightBuf.x = pVer->x - pLight->pos.x;
		LightBuf.y = pVer->y - pLight->pos.y;
		LightBuf.z = pVer->z - pLight->pos.z;

		//ʂƌ̋߂
		Dis = ( float )sqrt( LightBuf.x * LightBuf.x
			+ LightBuf.y * LightBuf.y + LightBuf.z * LightBuf.z );

		//txNg
		LightBuf.x *= -1;
		LightBuf.y *= -1;
		LightBuf.z *= -1;

		//xNgƖ@xNĝȂp߂
		Cos = ( ( LightBuf.x * pVect->x + LightBuf.y * pVect->y + LightBuf.z * pVect->z ) /
			( Dis * sqrtf( pVect->x * pVect->x + pVect->y * pVect->y + pVect->z * pVect->z ) ) );

		//lC
		Cos += 1.0;	//-1.0`1.0 -> 0.0`2.0
		Cos /= 2.0;	// 0.0`2.0 -> 0.0`1.0

		//̋
		if( Dis >= pLight->limit ){
			//EzłキȂ
			Pow = 0.0;
		}else{
			Pow = 1 - ( Dis / pLight->limit );
		}
		Cos = Cos * Pow;

		//̊i[
		*pBright = Cos;

		pBright++;
		pVect++;

	}

}

//////////////////////////////////////////////////////////////////////
//e̍W߂(_)
//F@eWi[p
//		@_f[^(O[oWϊAr[WϊO)
//		O@̈ʒu
//		l@_
//ߒl@Ȃ
//////////////////////////////////////////////////////////////////////
void	GetPointShadow(
						VERTEX	*pShadow,	//eWi[p
						VERTEX	*pVer,		//_f[^(O[oWϊAr[WϊO)
						VERTEX	*pLightPos,	//̈ʒu
						DWORD	dwVer		//_
						)
{

	DWORD	i;
	VERTEX	light;

	for( i=0; i<dwVer; i++ ){

		//e_̌xNg߂
		light.x = pVer->x - pLightPos->x;
		light.y = pVer->y - pLightPos->y;
		light.z = pVer->z - pLightPos->z;

		//e̍W߂
		pShadow->x = pVer->x + light.x * ( -pVer->y / light.y );
		pShadow->y = 0;
		pShadow->z = pVer->z + light.z * ( -pVer->y / light.y );

		pShadow++;
		pVer++;
	}

}

///////////////////////////////////////////////////////////////////
//}`̉e`
//F@HDC
//		@|S\
//ߒl@Ȃ
///////////////////////////////////////////////////////////////////
void DrawShadow( HDC hdc,			//foCXReLXg̃nh
			     FIGDATA *fig ){

	short	i;
	HPEN	hPen, hPEN;
	HBRUSH	hBrush, hBRUSH;
	POINT	Triangle[3];
	int		v0, v1, v2;

	//yAuV
	hPen = CreatePen( PS_SOLID, 2, RGB( 0,0,0) );	//y
	hPEN = ( HPEN )SelectObject( hdc, hPen );		//yݒ	

	hBrush = CreateSolidBrush( RGB( 0,0,0 ) );
	hBRUSH = (HBRUSH)SelectObject( hdc, hBrush );	

	for( i = 0; i < fig->nPlane; i++ ){
		v0 = fig->pLinkBuf[i].v0;
		v1 = fig->pLinkBuf[i].v1;
		v2 = fig->pLinkBuf[i].v2;
		
		Triangle[0].x = (int)fig->pShadowBuf[v0].x;
		Triangle[0].y = (int)fig->pShadowBuf[v0].y;

		Triangle[1].x = (int)fig->pShadowBuf[v1].x;
		Triangle[1].y = (int)fig->pShadowBuf[v1].y;

		Triangle[2].x = (int)fig->pShadowBuf[v2].x;
		Triangle[2].y = (int)fig->pShadowBuf[v2].y;	

		//XN[Wnɕϊ
		Triangle[0].x += (LONG)GXO;
		Triangle[0].y = (LONG)(GYO - Triangle[0].y);
		Triangle[1].x += (LONG)GXO;
		Triangle[1].y = (LONG)(GYO - Triangle[1].y);
		Triangle[2].x += (LONG)GXO;
		Triangle[2].y = (LONG)(GYO - Triangle[2].y);

		Polygon( hdc, Triangle, 3 );
	}

	SelectObject( hdc, hBRUSH );
	DeleteObject( hBrush );
	SelectObject( hdc, hPEN );							//yɖ߂
	DeleteObject( hPen );								//y폜	

}

//////////////////////////////////////////////////////////////////
//}``
//F@|S\
//		@obNobt@
//		O@e_̍ŏIړW
//		l@_̈ړ
//ߒl@Ȃ
//////////////////////////////////////////////////////////////////
void Draw( FIGDATA *fig,
		   LPDIRECTDRAWSURFACE7	lpSurface,
		   VERTEX *pPer,
		   VERTEX *pMov
){

	short		i, j;
	POINT		Triangle[3];
	int			v0, v1, v2;
	RGBCOLOR	Col[3];

	for( i = 0; i < fig->nPlane; i++ ){
		j = fig->pPolygonOrder[i];	//\ʂ̔ԍ
		v0 = fig->pLinkBuf[j].v0;
		v1 = fig->pLinkBuf[j].v1;
		v2 = fig->pLinkBuf[j].v2;

		//ÿړ
		fig->pVertexBuf_cnt[v0].z += pMov[j].z;
		fig->pVertexBuf_cnt[v1].z += pMov[j].z;
		fig->pVertexBuf_cnt[v2].z += pMov[j].z;
		
		Triangle[0].x = (int)fig->pVertexBuf_cnt[v0].x;
		Triangle[0].y = (int)fig->pVertexBuf_cnt[v0].y;

		Triangle[1].x = (int)fig->pVertexBuf_cnt[v1].x;
		Triangle[1].y = (int)fig->pVertexBuf_cnt[v1].y;

		Triangle[2].x = (int)fig->pVertexBuf_cnt[v2].x;
		Triangle[2].y = (int)fig->pVertexBuf_cnt[v2].y;

		//ʂ̈ړ
		Triangle[0].x += (LONG)pMov[j].x;
		Triangle[0].y += (LONG)pMov[j].y;
		Triangle[1].x += (LONG)pMov[j].x;
		Triangle[1].y += (LONG)pMov[j].y;
		Triangle[2].x += (LONG)pMov[j].x;
		Triangle[2].y += (LONG)pMov[j].y;

		Col[0] = fig->col_c[v0];
		Col[1] = fig->col_c[v1];
		Col[2] = fig->col_c[v2];

		//XN[Wnɕϊ
		Triangle[0].x += (LONG)GXO;
		Triangle[0].y = (LONG)(GYO - Triangle[0].y);
		Triangle[1].x += (LONG)GXO;
		Triangle[1].y = (LONG)(GYO - Triangle[1].y);
		Triangle[2].x += (LONG)GXO;
		Triangle[2].y = (LONG)(GYO - Triangle[2].y);
		
		if( !SideCheck( Triangle ) ){
			SLPolygon( lpSurface, Triangle, Col );
		}
	}	

}

//////////////////////////////////////////////////////////////////
//}`̐F߂
//F@Ff[^
//		@Ff[^(vZp)
//		O@Fi邳j
//		l@f[^
//		܁@_
//ߒl@Ȃ
///////////////////////////////////////////////////////////////////
void	GetModelColor( RGBCOLOR *col, RGBCOLOR * col_c, float *pBright, LIGHT *pLight, DWORD dwVer ){
	DWORD i;
	RGBCOLOR	lowstcol;

	for( i=0; i<dwVer; i++ ){
		//ŒcF
		lowstcol.r	=	( BYTE )( col[i].r * pLight->min );
		lowstcol.g	=	( BYTE )( col[i].g * pLight->min );
		lowstcol.b	=	( BYTE )( col[i].b * pLight->min );

		//cFŌ
		col_c[i].r =	( BYTE )( ( col[i].r * ( 1 - pLight->min ) )
			* pBright[ i ] * pLight->col.r ) + lowstcol.r;
		col_c[i].g =	( BYTE )( ( col[i].g * ( 1 - pLight->min ) )
			* pBright[ i ] * pLight->col.g ) + lowstcol.g;
		col_c[i].b =	( BYTE )( ( col[i].b * ( 1 - pLight->min ) )
			* pBright[ i ] * pLight->col.b ) + lowstcol.b;
	}
}

///////////////////////////////////////////////////////////////////////
//ʂ̖@xNg߂
//F@_f[^
//		@Nf[^
//		O@@xNgi[p
//ߒl@Ȃ
///////////////////////////////////////////////////////////////////////
void GetFaceVect( VERTEX *pVer, LINKDATA *pLink, VERTEX *vect ){

	float		x0,x1,x2,y0,y1,y2,z0,z1,z2;

	//_f[^i[
	x0 = pVer[ pLink->v0 ].x;
	y0 = pVer[ pLink->v0 ].y;
	z0 = pVer[ pLink->v0 ].z;

	x1 = pVer[ pLink->v1 ].x;
	y1 = pVer[ pLink->v1 ].y;
	z1 = pVer[ pLink->v1 ].z;

	x2 = pVer[ pLink->v2 ].x;
	y2 = pVer[ pLink->v2 ].y;
	z2 = pVer[ pLink->v2 ].z;

	//@xNg߂
	vect->x = ( y1 - y0 ) * ( z2 - z0 ) - ( z1 - z0 ) * ( y2 - y0 );
	vect->y = ( z1 - z0 ) * ( x2 - x0 ) - ( x1 - x0 ) * ( z2 - z0 );
	vect->z = ( x1 - x0 ) * ( y2 - y0 ) - ( y1 - y0 ) * ( x2 - x0 );

}

///////////////////////////////////////////////////////////////////////
//_̖@xNgiʂ̕ϒlj߂
//F|S\
//ߒl@Ȃ
///////////////////////////////////////////////////////////////////////
void GetVertexVect( FIGDATA *fig ){

	int			i, j;
	int			MatchCount;

	for( i = 0; i < fig->nVertex; i++ ){

		fig->VerVect[i].x = 0;
		fig->VerVect[i].y = 0;
		fig->VerVect[i].z = 0;
		MatchCount = 0;

		for( j = 0; j < fig->nPlane; j++ ){
			//_LʂAxNg̕ς߂
			if( fig->pLinkBuf[j].v0 == i || 
				fig->pLinkBuf[j].v1 == i ||
				fig->pLinkBuf[j].v2 == i ){
				GetFaceVect( fig->pVertexBuf_cnt, &fig->pLinkBuf[j], &fig->FaceVect );
				fig->VerVect[i].x += fig->FaceVect.x;	//xNg̍v
				fig->VerVect[i].y += fig->FaceVect.y;
				fig->VerVect[i].z += fig->FaceVect.z;
				MatchCount++;
			}			
		}

		if( MatchCount != 0 ){
			fig->VerVect[i].x /= MatchCount;	//ϒľvZ
			fig->VerVect[i].y /= MatchCount;
			fig->VerVect[i].z /= MatchCount;
		}

	}

}
