//////////////////////////////////////////////////////////////////
//|S֘A@wb_[
//////////////////////////////////////////////////////////////////
#ifndef MAIN_H_
#define MAIN_H_

#include<windows.h>
#include<ddraw.h>

#define	FIG_NUM		1
#define VERTEX_NUM	60
#define PLANE_NUM	116
#define MOTION_NUM	4
#define	MOTION_P	12
#define	WAIT		1
#define	FRAME		64

///////////////////////////////////////////////////////////////////
//\
///////////////////////////////////////////////////////////////////
struct ANGLE_3D{
	float	xy;	//wxʂł̉]px
	float	yz;	//xyʂł̉]px
	float	zx;	//ywʂł̉]px
};

struct ANGLE_3Df{
	float	x;	//w]p
	float	y;	//x]p
	float	z;	//y]p
};

struct VERTEX{
	float x;	//wW
	float y;	//xW
	float z;	//yW
};

struct RGBCOLOR{
	BYTE r;	//O`QTT̐ԗvfi[p
	BYTE g;	//O`QTT̗Ηvfi[p
	BYTE b;	//O`QTT̐vfi[p
};

struct LINKDATA{
	short v0;
	short v1;
	short v2;
};

typedef struct	FIGDATA{
	int			nVertex;			//_
	int			nPlane;				//ʐ
	BOOL		DrawFlag;			//`EstO
	VERTEX		*pVertexBuf;		//_f[^ւ̃|C^
	VERTEX		*pVertexBuf_cnt;	//_f[^ivZpjւ̃|C^
	LINKDATA	*pLinkBuf;			//_̌qf[^ւ̃|C^
	float		*pBrightness;		//eʂ̋Pxl
	int			*pPolygonOrder;		//|S̕\
	VERTEX		Local;				//[JWň_
	VERTEX		Local_Cnt;			//[JWnvZp
	ANGLE_3D	RotateAngle;		//]px
	ANGLE_3D	Angle_c;			//]pxvZp
	FIGDATA		*pFig_Parent;		//eɂȂ}`f[^
	VERTEX		*pShadowBuf;		//e
	BYTE		mode;				//`@
	float		Dis;				//̂Ǝ_̋i[p
	RGBCOLOR	*col;				//Ff[^
	RGBCOLOR	*col_c;				//Ff[^vZp
	VERTEX		FaceVect;			//ʂ̖@xNgi[p
	VERTEX		*VerVect;			//_̖@xNgi[p
}FIGDATA, *LPFIGDATA;

typedef	struct	_MOTION{
	//sړ
	float	mov_x;	//̈ړ
	float	mov_y;	//̈ړ
	float	mov_z;	//̈ړ
	//]
	float	ang_x;	//]px
	float	ang_y;	//]px
	float	ang_z;	//]px
}MOTION;

typedef	struct	_MOTION_R{
	//]
	float	s_x;	//]pxEJn
	float	s_y;	//]pxEJn
	float	s_z;	//]pxEJn
	float	e_x;	//]pxEI
	float	e_y;	//]pxEI
	float	e_z;	//]pxEI
	float	a_x;
	float	a_y;
	float	a_z;
	float	b_x;
	float	b_y;
	float	b_z;
}MOTION_R;

typedef	struct	_MOTION_M{
	//sړ
	float	s_x;	//ړʁEJn
	float	s_y;	//ړʁEJn
	float	s_z;	//ړʁEJn
	float	e_x;	//ړʁEI
	float	e_y;	//ړʁEI
	float	e_z;	//ړʁEI
	float	a_x;
	float	a_y;
	float	a_z;
	float	b_x;
	float	b_y;
	float	b_z;
}MOTION_M;

struct	CAMERA{
	VERTEX		ViewPoint;
	ANGLE_3Df	ViewAngle;
};

struct	RGBCOLORF{
	float	r;
	float	g;
	float	b;
};

//p\
struct	FOGDATA{
	RGBCOLOR	col;	//̐F
	float		rng;	//씼a
};

///////////////////////////////////////////////////////////////////
//GNX^[
///////////////////////////////////////////////////////////////////

extern float	GXO, GYO;		//O[oWň_
extern CAMERA	camera[2];
extern VERTEX	ViewPoint;
extern ANGLE_3Df ViewAngle;
extern float	BackScreen;	//eʂ̂yW
extern BYTE	Motion_MODE;
extern BYTE Attack;
extern BYTE PerFlag;

///////////////////////////////////////////////////////////////////
//vg^Cv錾
///////////////////////////////////////////////////////////////////
void MainFunc( LPDIRECTDRAWSURFACE7 );
void Revolve( VERTEX *, VERTEX *, ANGLE_3D *, VERTEX * );
void Rotate( FIGDATA * );
void Rotate( FIGDATA *, FIGDATA * );
void RotateF( VERTEX *, ANGLE_3D *, int );
void Parallel( FIGDATA * );	
BOOL Projection( VERTEX *, short );	//}`\Wɕϊ
void VertexTranslate( VERTEX *, VERTEX *, short );
void SortPolygon1( FIGDATA * );
void SortPolygon2( FIGDATA *, float * );
int	 SideCheck( POINT * );
void ViewTransform( VERTEX *, short );	//]
float GetDistance( VERTEX *, VERTEX *, DWORD );
void SortFig( void );
void LinePolygon( HDC, POINT *, DWORD );
void PlaneMove( FIGDATA *, VERTEX *, VERTEX * );

#endif 
