#include<windows.h>
#include"Macro.h"
#include"DirectDraw.h"
#include"DD_Draw.h"
#include"DirectMusic.h"
#include"DirectSound.h"
#include"DD_Draw.h"
#include"Input.h"
#include"Global.h"
#include"SoundLoad.h"
#include"Fps.h"
#include"Input.h"
#include"Flag.h"
#include"Rect.h"
#include"DrawDanjon.h"
#include"DrawAnother.h"
#include"CharaDraw.h"
#include"DrawBox.h"

#define	MAPVIEW_DDSOFF_MAX	11		//Q[̊G̖
#define	MAPVIEW_DSSBUF_MAX	1		//Q[wave̐i퓬pj

typedef struct tagclip{
	int	x;
	int	y;
}CLIP;

/////////////////////////////////////////////////////////////////
//}bv\ݒ
/////////////////////////////////////////////////////////////////
BYTE InitMapView()
{
	int		i;
	LPSTR	lpszMapFileName[ MAPVIEW_DDSOFF_MAX ] = {
		"bitmap/play/chip.bmp",
		"bitmap/play/chara.bmp",
		"bitmap/play/chipdanjon.bmp",
		"bitmap/play/chara.bmp",
		"bitmap/play/chiptown.bmp",
		"bitmap/play/menuitem.bmp",		
		"bitmap/play/skill.bmp",		//sgp
		"bitmap/play/charatown.bmp",
		"bitmap/play/chipdanjon2.bmp",
		"bitmap/play/bmptown.bmp",
		"bitmap/opening/chip.bmp"
	};
	bDDSOffMax = MAPVIEW_DDSOFF_MAX;

	for( i = 0 ; i < bDDSOffMax ; i++ ){
		//ItXN[T[tFCX̍쐬
		if(	!LoadBitmapImage( &lpszStorageFileName[ i ], lpszMapFileName[ i ], &lpDDSOffscreen[ i ], 0, hWnd, SCREEN_WIDTH )){
			DestroyWindow( hWnd );
		}
	}

	//wavet@C
	LPSTR	lpszMapWaveName2[ MAPVIEW_DSSBUF_MAX ] = {
		"wave\\fight\\hit_s06.wav"
	};

	bDSSBufMax = MAPVIEW_DSSBUF_MAX;

	//ZJ_obt@̍쐬
	for( i = 0 ; i < bDSSBufMax ; i++ ){		
		if( !CreateDSSBuffer( lpszMapWaveName2[ i ], &lpDSSBuffer[ i+20 ] ) ){
			DestroyWindow( hWnd );
		}
	}

	SoundLoad();				//[h

	switch( PlaceFlag ){	//ꏊ
	case MODE_FIELD:
		lpDMSegment[0] -> SetRepeats(50);	//MidiĐ
		lpDMPerformance->PlaySegment( lpDMSegment[ 0 ], DMUS_SEGF_DEFAULT, 0, NULL );
		break;
	case MODE_DANJON:
		if( DanjonNO <= 5 ){
			lpDMSegment[0] -> SetRepeats(100);	//MidiĐ
			lpDMPerformance->PlaySegment( lpDMSegment[ 0 ], DMUS_SEGF_DEFAULT, 0, NULL );
		}else{
			lpDMSegment[3] -> SetRepeats(100);	//MidiĐ
			lpDMPerformance->PlaySegment( lpDMSegment[ 3 ], DMUS_SEGF_DEFAULT, 0, NULL );
		}
		break;
	case MODE_TOWN:
		lpDMSegment[0] -> SetRepeats(50);	//MidiĐ
		lpDMPerformance->PlaySegment( lpDMSegment[ 0 ], DMUS_SEGF_DEFAULT, 0, NULL );
		break;
	case MODE_ISEKI:
		lpDMSegment[0] -> SetRepeats(50);	//MidiĐ
		lpDMPerformance->PlaySegment( lpDMSegment[ 0 ], DMUS_SEGF_DEFAULT, 0, NULL );
		break;
	}

	return FUNC_USE;
}

/////////////////////////////////////////////////////////////////
//}bv\s
/////////////////////////////////////////////////////////////////
BYTE MapView()
{

	int				i,j,num;
	RECT			rcDst, rcSrc;
	DDBLTFX			ddbltfx;				//ǉ
	static CLIP		clip[50];				//}bv`bvi[p
	HANDLE			hFile;					//t@C̃nh
	DWORD			dwByteCnt;				//oCgi[
	static int		MAP_W, MAP_H;			//TCY
	static BYTE		map1[50 * 50] = {0};	//}bvf[^
	static BYTE		map2[100 * 100] = {0};	//}bvf[^
	static BYTE		map3[150 * 150] = {0};	//}bvf[^
	static BYTE		map4[200 * 200] = {0};	//}bvf[^
	static BYTE		map5[250 * 250] = {0};	//}bvf[^
	static int		mpx, mpy;				//}bvpʒuW
	static int		OS_NO;					//ItXN[mn
	static BYTE		SetFlag = FALSE;		//ptO
	static int		motion = 0;
	static POSE		*patData[1] = { poseFire };
	static POSE		*pat;	
	static int		Wait;
	static int		patIndex;

	if( SetFlag == FALSE ){				//
		SetFlag = TRUE;
		mpx = px;
		mpy = py;
		
		for( i = 0; i < 10; i++ ){			//}bv`bvi[
			for( j = 0; j < 5; j++ ){
				clip[i * 5 + j].x = j*32;
				clip[i * 5 + j].y = i*32;
			}
		}

		//TCY
		switch( PlaceFlag ){
		case MODE_TOWN:
		case MODE_FIELD:
			MAP_W = 50;
			MAP_H = 50;
			break;
		case MODE_DANJON:
			switch( DanjonNO ){
			case 1:
				MAP_W = 50;
				MAP_H = 50;
				break;
			case 2:
			case 3:
			case 4:
			case 5:
				MAP_W = 100;
				MAP_H = 100;
				break;
			case 6:
			case 7:
			case 8:
				MAP_W = 150;
				MAP_H = 150;
				break;
			case 9:
				MAP_W = 200;
				MAP_H = 200;
				break;
			case 10:
				MAP_W = 250;
				MAP_H = 250;
				break;
			}
		}

		//PDt@Cnh̎擾@ItXN[mnI
		switch( PlaceFlag ){
		case MODE_FIELD:		
			OS_NO = 0;
			hFile = CreateFile(
				"mapdata\\field\\map.dat",	//t@C̃AhX
				GENERIC_READ,			//ANZX[h(ǂݍ)
				0,						//L[h(LȂ)
				NULL,					//ZLeBLqq̃AhX
				OPEN_ALWAYS	,			//쐬@
				FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
				NULL					//Rs[鑮t@C̃nh
			);
			break;
		case MODE_TOWN:
			OS_NO = 4;
			hFile = CreateFile(
				"mapdata\\town\\map.dat",	//t@C̃AhX
				GENERIC_READ,			//ANZX[h(ǂݍ)
				0,						//L[h(LȂ)
				NULL,					//ZLeBLqq̃AhX
				OPEN_ALWAYS	,			//쐬@
				FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
				NULL					//Rs[鑮t@C̃nh
			);
			break;
		case MODE_DANJON:
			switch( DanjonNO ){
			case 1:
				OS_NO = 2;
				hFile = CreateFile(
					"mapdata\\danjon\\map1.dat",	//t@C̃AhX
					GENERIC_READ,			//ANZX[h(ǂݍ)
					0,						//L[h(LȂ)
					NULL,					//ZLeBLqq̃AhX
					OPEN_ALWAYS	,			//쐬@
					FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
					NULL					//Rs[鑮t@C̃nh
				);
				break;
			case 2:
				OS_NO = 2;
				hFile = CreateFile(
					"mapdata\\danjon\\map2.dat",	//t@C̃AhX
					GENERIC_READ,			//ANZX[h(ǂݍ)
					0,						//L[h(LȂ)
					NULL,					//ZLeBLqq̃AhX
					OPEN_ALWAYS	,			//쐬@
					FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
					NULL					//Rs[鑮t@C̃nh
				);
				break;
			case 3:
				OS_NO = 2;
				hFile = CreateFile(
					"mapdata\\danjon\\map3.dat",	//t@C̃AhX
					GENERIC_READ,			//ANZX[h(ǂݍ)
					0,						//L[h(LȂ)
					NULL,					//ZLeBLqq̃AhX
					OPEN_ALWAYS	,			//쐬@
					FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
					NULL					//Rs[鑮t@C̃nh
				);
				break;
			case 4:
				OS_NO = 2;
				hFile = CreateFile(
					"mapdata\\danjon\\map4.dat",	//t@C̃AhX
					GENERIC_READ,			//ANZX[h(ǂݍ)
					0,						//L[h(LȂ)
					NULL,					//ZLeBLqq̃AhX
					OPEN_ALWAYS	,			//쐬@
					FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
					NULL					//Rs[鑮t@C̃nh
				);
				break;
			case 5:
				OS_NO = 2;
				hFile = CreateFile(
					"mapdata\\danjon\\map5.dat",	//t@C̃AhX
					GENERIC_READ,			//ANZX[h(ǂݍ)
					0,						//L[h(LȂ)
					NULL,					//ZLeBLqq̃AhX
					OPEN_ALWAYS	,			//쐬@
					FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
					NULL					//Rs[鑮t@C̃nh
				);
				break;
			case 6:
				OS_NO = 8;
				hFile = CreateFile(
					"mapdata\\danjon\\map6.dat",	//t@C̃AhX
					GENERIC_READ,			//ANZX[h(ǂݍ)
					0,						//L[h(LȂ)
					NULL,					//ZLeBLqq̃AhX
					OPEN_ALWAYS	,			//쐬@
					FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
					NULL					//Rs[鑮t@C̃nh
				);
				break;
			case 7:
				OS_NO = 8;
				hFile = CreateFile(
					"mapdata\\danjon\\map7.dat",	//t@C̃AhX
					GENERIC_READ,			//ANZX[h(ǂݍ)
					0,						//L[h(LȂ)
					NULL,					//ZLeBLqq̃AhX
					OPEN_ALWAYS	,			//쐬@
					FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
					NULL					//Rs[鑮t@C̃nh
				);
				break;
			case 8:
				OS_NO = 8;
				hFile = CreateFile(
					"mapdata\\danjon\\map8.dat",	//t@C̃AhX
					GENERIC_READ,			//ANZX[h(ǂݍ)
					0,						//L[h(LȂ)
					NULL,					//ZLeBLqq̃AhX
					OPEN_ALWAYS	,			//쐬@
					FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
					NULL					//Rs[鑮t@C̃nh
				);
				break;
			case 9:
				OS_NO = 8;
				hFile = CreateFile(
					"mapdata\\danjon\\map9.dat",	//t@C̃AhX
					GENERIC_READ,			//ANZX[h(ǂݍ)
					0,						//L[h(LȂ)
					NULL,					//ZLeBLqq̃AhX
					OPEN_ALWAYS	,			//쐬@
					FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
					NULL					//Rs[鑮t@C̃nh
				);
				break;
			case 10:
				OS_NO = 8;
				hFile = CreateFile(
					"mapdata\\danjon\\map10.dat",	//t@C̃AhX
					GENERIC_READ,			//ANZX[h(ǂݍ)
					0,						//L[h(LȂ)
					NULL,					//ZLeBLqq̃AhX
					OPEN_ALWAYS	,			//쐬@
					FILE_ATTRIBUTE_NORMAL,	//t@C(ɑ͖)
					NULL					//Rs[鑮t@C̃nh
				);
				break;
			}
		}

		//G[`FbN
		if( hFile == INVALID_HANDLE_VALUE ){
			DestroyWindow( hWnd );
		}

		//QDǂݍ([h)
		switch( PlaceFlag ){
		case MODE_TOWN:
		case MODE_FIELD:
			ReadFile(
				hFile,						//t@C̃nh
				map1,						//f[^󂯎obt@̃AhX
				sizeof(BYTE)*MAP_W*MAP_H,	//ǂݍރoCg
				&dwByteCnt,					//ǂݍ񂾃oCgi[ϐ̃AhX
				NULL						//dI/OɕKvȍ\̂̃AhX
			);
			break;
		case MODE_DANJON:
			switch( DanjonNO ){
			case 1:
				ReadFile(
					hFile,						//t@C̃nh
					map1,						//f[^󂯎obt@̃AhX
					sizeof(BYTE)*MAP_W*MAP_H,	//ǂݍރoCg
					&dwByteCnt,					//ǂݍ񂾃oCgi[ϐ̃AhX
					NULL						//dI/OɕKvȍ\̂̃AhX
				);
				break;
			case 2:
			case 3:
			case 4:
			case 5:
				ReadFile(
					hFile,						//t@C̃nh
					map2,						//f[^󂯎obt@̃AhX
					sizeof(BYTE)*MAP_W*MAP_H,	//ǂݍރoCg
					&dwByteCnt,					//ǂݍ񂾃oCgi[ϐ̃AhX
					NULL						//dI/OɕKvȍ\̂̃AhX
				);
				break;
			case 6:
			case 7:
			case 8:
				ReadFile(
					hFile,						//t@C̃nh
					map3,						//f[^󂯎obt@̃AhX
					sizeof(BYTE)*MAP_W*MAP_H,	//ǂݍރoCg
					&dwByteCnt,					//ǂݍ񂾃oCgi[ϐ̃AhX
					NULL						//dI/OɕKvȍ\̂̃AhX
				);
				break;
			case 9:
				ReadFile(
					hFile,						//t@C̃nh
					map4,						//f[^󂯎obt@̃AhX
					sizeof(BYTE)*MAP_W*MAP_H,	//ǂݍރoCg
					&dwByteCnt,					//ǂݍ񂾃oCgi[ϐ̃AhX
					NULL						//dI/OɕKvȍ\̂̃AhX
				);
				break;
			case 10:
				ReadFile(
					hFile,						//t@C̃nh
					map5,						//f[^󂯎obt@̃AhX
					sizeof(BYTE)*MAP_W*MAP_H,	//ǂݍރoCg
					&dwByteCnt,					//ǂݍ񂾃oCgi[ϐ̃AhX
					NULL						//dI/OɕKvȍ\̂̃AhX
				);
				break;
			}
		}

		//RDt@Cnh̉
		CloseHandle(hFile);

	}

	//T[tFCXXg̃`FbN
	CheckDDSurfaceLost( hWnd, SCREEN_WIDTH );

	//͏@
	if( stDown == KEY_KEEP || stDown == KEY_HIT || stDown == KEY_CNT ){
		mpy += 16;

		if( PlaceFlag != MODE_DANJON ){		//AtB[h
			if( mpy > 32*49 )	mpy = 32*49;	
		}else{
			switch( DanjonNO ){				//_W
			case 1:
				if( mpy > 32*49 )	mpy = 32*49;
				break;
			case 2:
			case 3:
			case 4:
			case 5:
				if( mpy > 32*99 )	mpy = 32*99;
				break;
			case 6:
			case 7:
			case 8:
				if( mpy > 32*149 )	mpy = 32*149;
				break;
			case 9:
				if( mpy > 32*199 )	mpy = 32*199;
				break;
			case 10:
				if( mpy > 32*249 )	mpy = 32*249;
				break;
			}
		}
	}

	//
	if( stUp == KEY_KEEP || stUp == KEY_HIT || stUp == KEY_CNT ){
		mpy -= 16;
		if( mpy < 0 )	mpy = 0;
	}

	//
	if( stLeft == KEY_KEEP || stLeft == KEY_HIT || stLeft == KEY_CNT ){
		mpx -= 16;
		if( mpx < 0 )	mpx = 0;
	}

	//E
	if( stRight == KEY_KEEP || stRight == KEY_HIT || stRight == KEY_CNT ){
		mpx += 16;
		if( PlaceFlag != MODE_DANJON ){			//AtB[h
			if( mpx > 32*49 )	mpx = 32*49;
		}else{
			switch( DanjonNO ){					//_W
			case 1:
				if( mpx > 32*49 )	mpx = 32*49;
				break;
			case 2:
			case 3:
			case 4:
			case 5:
				if( mpx > 32*99 )	mpx = 32*99;
				break;
			case 6:
			case 7:
			case 8:
				if( mpx > 32*149 )	mpx = 32*149;
				break;
			case 9:
				if( mpx > 32*199 )	mpx = 32*199;
				break;
			case 10:
				if( mpx > 32*249 )	mpx = 32*249;
				break;
			}
		}
	}

	//wi
	ddbltfx.dwSize = sizeof( ddbltfx );
	ddbltfx.dwFillColor = 0;
	SetRect( &rcDst, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );		//]
	lpDDSBackBuffer -> Blt( &rcDst, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx );
	
	//J̈ړ
	if( mpx + 32 - scrX > 340 ){
		scrX = mpx + 32 - 340;
		if( scrX > 32 * MAP_W - 640 ){
			scrX = 32 * MAP_W - 640;
		}
	}
	if( mpx - scrX < 280 ){
		scrX = mpx - 280;
		if( scrX < 0 ){
			scrX = 0;
		}
	}
	if( mpy + 32 - scrY > 288 ){
		scrY = mpy + 32 - 288;
		if( scrY > 32 * MAP_W - 480 ){
			scrY = 32 * MAP_W - 480;
		}
	}
	if( mpy - scrY < 192 ){
		scrY = mpy - 192;
		if( scrY < 0 ){
			scrY = 0;
		}
	}

	//wii`bvj
	mapX = scrX / 32;
	mapY = scrY / 32;
	restX = scrX % 32;
	restY = scrY % 32;

	if( restX != 0 )	restX = 1;
	if( restY != 0 )	restY = 1;

	//`
	for( i = mapY ; i < mapY+15+restY ; i++){
		for( j = mapX; j < mapX+20+restX ; j++){
			//}bvf[^i[ϐI
			switch( PlaceFlag ){
			case MODE_TOWN:
			case MODE_FIELD:
				num = map1[i * MAP_W + j];
				break;
			case MODE_DANJON:
				switch( DanjonNO ){
				case 1:
					num = map1[i * MAP_W + j];
					break;
				case 2:
				case 3:
				case 4:
				case 5:
					num = map2[i * MAP_W + j];
					break;
				case 6:
				case 7:
				case 8:
					num = map3[i * MAP_W + j];
					break;
				case 9:
					num = map4[i * MAP_W + j];
					break;
				case 10:
					num = map5[i * MAP_W + j];
					break;
				}
			}

			SetRect( &rcSrc, clip[num].x, clip[num].y, clip[num].x+32, clip[num].y+32 );
			//ClipBlt( lpDDSBackBuffer, rcDst, lpDDSOffscreen[ OS_NO ], rcSrc, NULL );
			ClipBltFast( lpDDSBackBuffer, j*32-scrX, i*32-scrY, lpDDSOffscreen[ OS_NO ],rcSrc, 0 );
	
		}
	}

	SetRect( &rcSrc, 352, 320, 384, 352 );	//󔠋`

	if( PlaceFlag == MODE_DANJON ){
		SetRect( &rcSrc, 352, 320, 384, 352 );	//JO
		SetRect( &rcDst, 352, 352, 384, 384 );	//J
		for( i = 0; i < 50; i++ ){	//eKɎ
			if( !(B_X[DanjonNO-1][i] == 0 && B_Y[DanjonNO-1][i] == 0) ){
				if( BoxFlag[ DanjonNO-1 ][ i ] == TRUE ){	//J
					ClipBltFast( lpDDSBackBuffer, 32*B_X[DanjonNO-1][i]-scrX, 32*B_Y[DanjonNO-1][i]-scrY,
						lpDDSOffscreen[5], rcSrc, DDBLTFAST_SRCCOLORKEY );	//
				}
				if( BoxFlag[ DanjonNO-1 ][ i ] == FALSE ){	//Jς
					ClipBltFast( lpDDSBackBuffer, 32*B_X[DanjonNO-1][i]-scrX, 32*B_Y[DanjonNO-1][i]-scrY,
						lpDDSOffscreen[5], rcDst, DDBLTFAST_SRCCOLORKEY );	//
				}
			}
		}

		for( i = 0; i < 12; i++ ){	//eKɎ
			if( !(C_X[DanjonNO-1][i] == 0 && C_Y[DanjonNO-1][i] == 0) ){
				SetRect( &rcSrc, 192, 128, 224, 160 );		//e
				ClipBltFast( lpDDSBackBuffer, 32*C_X[DanjonNO-1][i]-scrX, 32*C_Y[DanjonNO-1][i]-scrY, 
					lpDDSOffscreen[1],rcSrc,DDBLTFAST_SRCCOLORKEY );

				SetRect( &rcSrc, C_rc[DanjonNO-1][i].left+32, C_rc[DanjonNO-1][i].top, 
					C_rc[DanjonNO-1][i].right+32, C_rc[DanjonNO-1][i].bottom );
				ClipBltFast( lpDDSBackBuffer, 32*C_X[DanjonNO-1][i]-scrX, 32*C_Y[DanjonNO-1][i]-scrY, 
					lpDDSOffscreen[7],rcSrc, DDBLTFAST_SRCCOLORKEY );
			}
		}

		if( DanjonNO == 5 )	MapDanjonDrawWarp();
		MapDanjonDrawTerep();		
		MapDanjonDraw();
		DrawBoss();
		DrawDanjonEtc();
			
		//AjI
		pat = patData[0];

		Wait++;

		if( Wait >  pat[patIndex].frame ){
			Wait = 0;
			patIndex++;
			if( pat[patIndex].index == -1 ){
				patIndex = 0;
			}
		}

		for( i = 0; i < TAI; i++ ){	//eKɎ
			if( !(T_X[DanjonNO-1][i] == 0 && T_Y[DanjonNO-1][i] == 0) ){
				ClipBltFast( lpDDSBackBuffer, 32*T_X[DanjonNO-1][i]-scrX, 32*T_Y[DanjonNO-1][i]-scrY,
					lpDDSOffscreen[1], rcFire[ patIndex ], DDBLTFAST_SRCCOLORKEY );	//
			}
		}
	}

	if( PlaceFlag == MODE_TOWN ){	//l\
		for( i = 0; i < 4; i++ ){
			for( j = 0; j < 5; j++ ){
				SetRect( &rcSrc, 192, 128, 224, 160 );		//e
				ClipBltFast( lpDDSBackBuffer, CharaTown[i*5+j].x-scrX, CharaTown[i*5+j].y-scrY, 
					lpDDSOffscreen[3],rcSrc,DDBLTFAST_SRCCOLORKEY );

				SetRect( &rcSrc, CharaTown[i*5+j].bmpx+32, CharaTown[i*5+j].bmpy, 
					CharaTown[i*5+j].bmpx+64, CharaTown[i*5+j].bmpy+32 );
				ClipBltFast( lpDDSBackBuffer, CharaTown[i*5+j].x-scrX, CharaTown[i*5+j].y-scrY, 
					lpDDSOffscreen[7],rcSrc,DDBLTFAST_SRCCOLORKEY );
			}
		}

		if( B_L_Flag[4] == FALSE ){
			SetRect( &rcSrc, 192, 128, 224, 160 );		//e
			ClipBltFast( lpDDSBackBuffer, 32*44 -scrX, 32*8 -scrY, lpDDSOffscreen[1],	//I[
				rcSrc, DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 32*44 -scrX, 32*8 -scrY, lpDDSOffscreen[10],	//T
				B_rc[4][1], DDBLTFAST_SRCCOLORKEY );
		}

		if( B_L_Flag[5] == FALSE ){
			SetRect( &rcSrc, 192, 128, 224, 160 );		//e
			ClipBltFast( lpDDSBackBuffer, 32*6 -scrX, 32*39 -scrY, lpDDSOffscreen[1],	//I[
				rcSrc, DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 32*6 -scrX, 32*39 -scrY, lpDDSOffscreen[10],	//_
				B_rc[5][1], DDBLTFAST_SRCCOLORKEY );
		}
		if( B_L_Flag[6] == FALSE ){
			SetRect( &rcSrc, 192, 128, 224, 160 );		//e
			ClipBltFast( lpDDSBackBuffer, 32*35 -scrX, 32*43 -scrY, lpDDSOffscreen[1],	//I[
				rcSrc, DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 32*35 -scrX, 32*43 -scrY, lpDDSOffscreen[10],	//BVk
				B_rc[6][1], DDBLTFAST_SRCCOLORKEY );
		}
		if( B_L_Flag[7] == FALSE ){
			SetRect( &rcSrc, 192, 128, 224, 160 );		//e
			ClipBltFast( lpDDSBackBuffer, 32*6 -scrX, 32*24 -scrY, lpDDSOffscreen[1],	//I[
				rcSrc, DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 32*6 -scrX, 32*24 -scrY, lpDDSOffscreen[10],	//M
				B_rc[7][1], DDBLTFAST_SRCCOLORKEY );
		}
		MapTownDraw();
	}
	
	SetRect( &rcSrc, 384, 448, 576,480 );	//o
	ClipBltFast( lpDDSBackBuffer, 0, 0, lpDDSOffscreen[5],rcSrc,DDBLTFAST_SRCCOLORKEY );
	SetRect( &rcSrc, 384, 416, 531,448 );	//o
	ClipBltFast( lpDDSBackBuffer, 0, 32, lpDDSOffscreen[5],rcSrc,DDBLTFAST_SRCCOLORKEY );
	SetRect( &rcSrc, 64, 0, 96, 32 );	//Op
	ClipBltFast( lpDDSBackBuffer, mpx-scrX, mpy-scrY, lpDDSOffscreen[5],rcSrc,DDBLTFAST_SRCCOLORKEY );

	/*lpDDSBackBuffer->GetDC( &hDC );	
	hFontBack = ( HFONT )SelectObject( hDC, hFont2 );
	SetBkMode( hDC, TRANSPARENT );
	SetTextColor( hDC, RGB( 255, 255, 255 ) );

	char mes[256];
	//\
	wsprintf(mes,"X :%d",mpx/32);						//\
	TextOut(hDC,10,40,mes,lstrlen(mes));
	wsprintf(mes,"Y :%d",mpy/32);						//\
	TextOut(hDC,10,60,mes,lstrlen(mes));
	
	SelectObject( hDC, hFontBack );
	lpDDSBackBuffer->ReleaseDC( hDC );*/

	//ŏIo
	DD_Flip();

	if( stBButton == KEY_HIT ){
		SetFlag = FALSE;
		//px = mpx;
		//py = mpy;
		return FUNC_RELEASE;		
	}

	return FUNC_USE;

}

/////////////////////////////////////////////////////////////////
//}bv\I
/////////////////////////////////////////////////////////////////
BYTE ReleaseMapView()
{
	int		i;

	for( i = 0 ; i < bDDSOffMax ; i++ ){
		//ItXN[T[tFCX̍폜
		ReleaseDDSOffScreen( lpszStorageFileName[ i ], &lpDDSOffscreen[ i ] );
	}
	
	MapFlag = FALSE;
	bGameMode = MODE_PLAY;	//[hGfBO

	return	FUNC_INIT;
}

/////////////////////////////////////////////////////////////////
//}bv\t[
/////////////////////////////////////////////////////////////////
void MapViewIdle()
{
	static	BYTE	mode = FUNC_INIT;
	BYTE	(*funcMapView[ 3 ])() = {
		InitMapView,
		MapView,
		ReleaseMapView
	};	

	mode = funcMapView[ mode ]();

	return;
}