/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include<windows.h>
#include"math.h"
#include"Macro.h"
#include"DirectDraw.h"
#include"DD_Draw.h"
#include"Input.h"
#include"Global.h"
#include"ItemText.h"
#include"DirectSound.h"
#include"DirectMusic.h"
#include"Struct.h"
#include"TimeGet.h"
#include"SaveLoad.h"

#define	OPENING_DDSOFF_MAX	3		//I[vjO̊G̖
#define OPENING_DSSBUF_MAX 1		//I[vjOwave̐
#define OPENING_DMSEG_MAX  1		//I[vjOMIDI̐

/////////////////////////////////////////////////////////////////
//I[vjOݒ
/////////////////////////////////////////////////////////////////
BYTE InitGameOpening()
{
	int		i;
	LPSTR	lpszOpeningFileName[ OPENING_DDSOFF_MAX ] = {
		"bitmap/opening/title.bmp",
		"bitmap/opening/chip.bmp",
		"bitmap/opening/titlefade.bmp",
	};
	bDDSOffMax = OPENING_DDSOFF_MAX;

	for( i = 0 ; i < bDDSOffMax ; i++ ){
		//ItXN[T[tFCX̍쐬
		if(	!LoadBitmapImage( &lpszStorageFileName[ i ], lpszOpeningFileName[ i ], &lpDDSOffscreen[ i ], 0, hWnd, SCREEN_WIDTH )){
			DestroyWindow( hWnd );
		}		
	}

	//wavet@C
	LPSTR	lpszPlayWaveName[ OPENING_DSSBUF_MAX ] = {
		"wave\\all\\071.wav",
	};
	//MIDIt@C
	LPSTR	lpszPlayMidiName[ OPENING_DMSEG_MAX ] = {
		"mid\\opening\\recapture(pianosolo-remix).mid"		
	};

	bDSSBufMax = OPENING_DSSBUF_MAX;
	bDMSegMax = OPENING_DMSEG_MAX;
	
	//ZJ_obt@̍쐬
	for( i = 0 ; i < bDSSBufMax ; i++ ){		
		if( !CreateDSSBuffer( lpszPlayWaveName[ i ], &lpDSSBuffer[ i ] ) ){
			DestroyWindow( hWnd );
		}
	}
	//ZOg̍쐬
	for( i = 0 ; i < bDMSegMax ; i++ ){		
		if( !CreateDMSegment( lpszPlayMidiName[ i ], &lpDMSegment[ i ] ) ){
			DestroyWindow( hWnd );
		}
	}

	lpDMSegment[0] -> SetRepeats(50);	//MidiĐ
	lpDMPerformance->PlaySegment( lpDMSegment[ 0 ], DMUS_SEGF_DEFAULT, 0, NULL );

	for( i = 0 ; i < 360 ; i++ ){	//TCARTČvZ
		sin_table[ i ] = (int)( sin( i * 3.141592 / 180 ) * 0x10000 );
		cos_table[ i ] = (int)( cos( i * 3.141592 / 180 ) * 0x10000 );
	}	

	for( i = 0; i < 400; i++ ){	//\̏
		snow[i].flag = FALSE;
	}

	for( i = 0; i < WAVE; i++ ){
		WaveCnt[i] = 300 - (i * 100);
		WaveOrder[i] = i;
		for( int j = 0; j < 3; j++ ){//g\̏
			wave[i][j].flag = FALSE;
		}
	}

		return FUNC_USE;
}

/////////////////////////////////////////////////////////////////
//I[vjOs
/////////////////////////////////////////////////////////////////
BYTE GameOpening()
{
	HDC			hDC;
	RECT		rcSrc,rcDst;
	static int	CY = 320;			//J[\ʒu
	static int	MovePlay = FALSE;	//ʏJn
	static int	CSFlag = FALSE;		//ʐ؂ւtO
	DDBLTFX		ddbltfx;			//ǉ
	int			i, j;
	char		mes[256];
	BOOL		ret = FALSE;
	static int	MAx = -32;			//̍W
	static int	Flag = FALSE;		//ptO
	static int	DataFlag = FALSE;	//f[^邩ǂ
	HPEN				hPen,hBPen;			//y̓ꕨ
	HBRUSH				hBrush,hBBrush;		//uV̓ꕨ
	RECT		Datarc1[3] = {		//[hf[^̕`Aꍇ
		{320,60, 460,80},
		{320,80, 460,100},
		{320,100,460,120}
	};
	RECT		Datarc2[3] = {		//[hf[^̕`AȂꍇ
		{320,120,460,140},	
		{320,140,460,160},
		{320,160,460,180}
	};

	DS_BufferVolume( &lpDSSBuffer[ 0 ], -2000 );	//J[\ړ

	if( Flag == FALSE ){
		Flag = TRUE;
		if( DCFlag[0] == TRUE || DCFlag[1] == TRUE || DCFlag[2] == TRUE ){	//f[^ЂƂł
			DataFlag = TRUE;
		}
	}

	//T[tFCXXg̃`FbN
	CheckDDSurfaceLost( hWnd, SCREEN_WIDTH );

	for( i = 0; i < 400; i++ ){//Ꮙݒ
		if( snow[i].flag == FALSE ){
			snow[i].flag = TRUE;			
			snow[i].x = rand() % 1000+10;
			snow[i].y = rand() % 30 -50;
			snow[i].size = rand() % 2;
			snow[i].waitx = rand() % 5;
			snow[i].waity = rand() % 2;
			if( snow[i] .size == 0 ){
				snow[i].my = 2;
				snow[i].mx = -2;
			}else{
				snow[i].my = 3;
				snow[i].mx = -3;
			}
			break;
		}		
	}

	for( i = 0; i < WAVE; i++ ){
		if( wave[i][2].flag == FALSE ){			
			wave[i][0].x = rand() % 540 + 50;
			wave[i][0].y = rand() % 100 + 350;	
			wave[i][0].rx = 0;
			wave[i][0].ry = 0;
			wave[i][0].flag = TRUE;
			wave[i][0].wait = 0;
			wave[i][0].speed = 0;
			for( j = 1; j < 3; j++ ){
				wave[i][j].x = wave[i][0].x;
				wave[i][j].y = wave[i][0].y;
				wave[i][j].rx = 0;
				wave[i][j].ry = 0;
				wave[i][j].flag = TRUE;
				wave[i][j].speed = 0;
			}
		}
	}

	//͏
	if( stCButton == KEY_HIT && LoadFlag == FALSE && MovePlay == FALSE ){//
		if( (CY -320) / 70 == 0 ){	//߂
			MovePlay = TRUE;		//ʓ]Jn
			stCButton = KEY_FREE;
		}else{						//
			if( DataFlag == TRUE ){
				LoadFlag = TRUE;	//Z[uf[^\tO
				CY = 30;
				stCButton = KEY_FREE;
			}
		}
	}

	if( stCButton == KEY_HIT && LoadFlag == TRUE && MovePlay == FALSE ){//[h
		if( DCFlag[ ( CY - 30 ) / 50 ] == TRUE ){	//f[^I
			Load_NO = ( CY - 30 ) / 50;
			MovePlay = TRUE;						//ʓ]Jn
			stCButton = KEY_FREE;
		}
	}

	if( (stUp == KEY_HIT || stUp == KEY_KEEP) && MovePlay == FALSE ){//
		DS_BufferPlay( &lpDSSBuffer[ 0 ], 0 );
		if( LoadFlag == FALSE ){		//
			CY -= 70;
			if( CY < 320 )	CY = 390;
		}else{							//Z[uf[^I
			CY -= 50;
			if( CY < 30 )	CY = 130;
		}
	}
	if( (stDown == KEY_HIT || stDown == KEY_KEEP) && MovePlay == FALSE ){//
		DS_BufferPlay( &lpDSSBuffer[ 0 ], 0 );
		if( LoadFlag == FALSE ){		//
			CY += 70;
			if( CY > 390 )	CY = 320;
		}else{							//Z[uf[^I
			CY += 50;
			if( CY > 130 )	CY = 30;
		}
	}

	//wi\
	ddbltfx.dwSize = sizeof( ddbltfx );	//wihԂ
	ddbltfx.dwFillColor = 0;
	SetRect( &rcDst, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );		//]
	lpDDSBackBuffer -> Blt( &rcDst, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx );

	lpDDSBackBuffer->GetDC( &hDC );	
	//ݒ
	hPen = CreatePen(PS_SOLID,1,RGB(255,255,255));//y
	hBPen= (HPEN)SelectObject(hDC,hPen);//yݒ
	hBrush = CreateSolidBrush(RGB(0,0,0));
	hBBrush = (HBRUSH)SelectObject(hDC,hBrush);

	//gړE`
	for( i = 0; i < WAVE; i++ ){
		j = WaveOrder[i];
		WaveCnt[j]++;
		if( WaveCnt[j] >= 300 ){
			if( wave[j][2].flag == TRUE ){
				wave[j][0].wait++;
				if( wave[j][0].flag == TRUE ){
					wave[j][0].speed++;
					if( wave[j][0].speed % 3 == 0 ){
						wave[j][0].rx += 3;
						wave[j][0].ry += 1;
					}
					Ellipse( hDC, wave[j][0].x - wave[j][0].rx, wave[j][0].y - wave[j][0].ry,
								  wave[j][0].x + wave[j][0].rx, wave[j][0].y + wave[j][0].ry);
					if( wave[j][0].rx >= 150 )	wave[j][0].flag = FALSE;
				}
				if( wave[j][1].flag == TRUE ){
					if( wave[j][0].wait >= 20 ){
						wave[j][1].speed++;
						if( wave[j][1].speed % 3 == 0 ){
							wave[j][1].rx += 3;
							wave[j][1].ry += 1;
						}
						Ellipse( hDC, wave[j][1].x - wave[j][1].rx, wave[j][1].y - wave[j][1].ry,
									  wave[j][1].x + wave[j][1].rx, wave[j][1].y + wave[j][1].ry);
					}
					if( wave[j][1].rx >= 150 )	wave[j][1].flag = FALSE;
				}
				if( wave[j][2].flag == TRUE ){
					if( wave[j][0].wait >= 40 ){
						wave[j][2].speed++;
						if( wave[j][2].speed % 3 == 0 ){
							wave[j][2].rx += 3;
							wave[j][2].ry += 1;
						}
						Ellipse( hDC, wave[j][2].x - wave[j][2].rx, wave[j][2].y - wave[j][2].ry,
									  wave[j][2].x + wave[j][2].rx, wave[j][2].y + wave[j][2].ry);
					}
					if( wave[j][2].rx >= 150 ){
						wave[j][2].flag = FALSE;
						WaveCnt[j] = -200;
						WaveSort();
					}
				}
			}
		}
	}

	//ɖ߂
	SelectObject(hDC,hBPen);//yɖ߂
	DeleteObject(hPen);//y폜
	SelectObject(hDC,hBBrush);//uVɖ߂
	DeleteObject(hBrush);//uV폜
	lpDDSBackBuffer->ReleaseDC( hDC );

	for( i = 0; i < 400; i++ ){		//\ij
		if( snow[i].flag == TRUE && snow[i].size == 0 ){
			SetRect( &rcSrc, 0, 180, 4, 184 );
			ClipBltFast( lpDDSBackBuffer, snow[i].x, snow[i].y, 
				lpDDSOffscreen[1],rcSrc, DDBLTFAST_SRCCOLORKEY );
		}
	}
	
	if( CSFlag != TRUE ){	//ʋyсAf[^I
		if( LoadFlag == FALSE ){
			SetRect( &rcSrc, 0, 0, 640, 480 );//͗l
			ClipBltFast( lpDDSBackBuffer, 0, 0, lpDDSOffscreen[0],rcSrc, DDBLTFAST_SRCCOLORKEY );	

			//\
			SetRect( &rcSrc, 0, 0, 192, 48 );//n߂
			ClipBltFast( lpDDSBackBuffer, 420, 320, lpDDSOffscreen[1],rcSrc, DDBLTFAST_SRCCOLORKEY );
			if( DataFlag == TRUE ){	//f[^ł
				SetRect( &rcSrc, 0, 48, 192, 96 );//@f[^
				ClipBltFast( lpDDSBackBuffer, 420, 390, lpDDSOffscreen[1],rcSrc, DDBLTFAST_SRCCOLORKEY );
			}else{
				SetRect( &rcSrc, 307, 0, 499, 48 );//@f[^Ȃ
				ClipBltFast( lpDDSBackBuffer, 420, 390, lpDDSOffscreen[1],rcSrc, DDBLTFAST_SRCCOLORKEY );
			}
			//J[\\@
			SetRect( &rcSrc, 0, 96, 48, 144 );
			ClipBltFast( lpDDSBackBuffer, 360, CY, lpDDSOffscreen[1],rcSrc, DDBLTFAST_SRCCOLORKEY );
		}else{			
			SetRect( &rcSrc, 0, 0, 640, 480 );//͗l
			ClipBltFast( lpDDSBackBuffer, 0, 0, lpDDSOffscreen[2],rcSrc, DDBLTFAST_SRCCOLORKEY );

			//\
			for( i = 0; i < 3; i++ ){
				if( DCFlag[i] == TRUE ){//ef[^݂
					ClipBltFast( lpDDSBackBuffer, 350, i*50+30, lpDDSOffscreen[1],
						Datarc1[i], DDBLTFAST_SRCCOLORKEY );
				}else{					//Ȃ
					ClipBltFast( lpDDSBackBuffer, 350, i*50+30, lpDDSOffscreen[1],
						Datarc2[i], DDBLTFAST_SRCCOLORKEY );
				}
			}

			//J[\\@
			SetRect( &rcSrc, 0, 144, 24, 168 );
			ClipBltFast( lpDDSBackBuffer, 320, CY-3, lpDDSOffscreen[1],rcSrc, DDBLTFAST_SRCCOLORKEY );

			ret = Data_Load_S( (CY-30)/50 );
			if( ret == FALSE )	DestroyWindow( hWnd );

			//fchgp
			lpDDSBackBuffer->GetDC( &hDC );	
			hFontBack = ( HFONT )SelectObject( hDC, hFont3 );
			SetBkMode( hDC, TRANSPARENT );
			SetTextColor( hDC, RGB( 255, 255, 255 ) );

			if( DCFlag[(CY-30)/50] == TRUE ){
				wsprintf( mes, "LV");			//\
				TextOut( hDC,390,200,mes,lstrlen(mes) );
				wsprintf( mes, "n");			//\
				TextOut( hDC,450,200,mes,lstrlen(mes) );
				wsprintf( mes, "");			//\
				TextOut( hDC,450,230,mes,lstrlen(mes) );
				wsprintf( mes, "IuN");			//\
				TextOut( hDC,450,260,mes,lstrlen(mes) );
				wsprintf( mes, "");			//\
				TextOut( hDC,450,290,mes,lstrlen(mes) );
				wsprintf( mes, "ꏊ");			//\
				TextOut( hDC,390,320,mes,lstrlen(mes) );
				wsprintf( mes, "");		//\
				TextOut( hDC,390,350,mes,lstrlen(mes) );
				wsprintf( mes, "");		//\
				TextOut( hDC,520,350,mes,lstrlen(mes) );
				wsprintf( mes, "vC");	//\
				TextOut( hDC,390,380,mes,lstrlen(mes) );

				for( i = 0; i < 4; i++ ){
					wsprintf( mes, "%d", C_S[i].Lv);			//\
					TextOut( hDC,520,200+i*30,mes,lstrlen(mes) );
				}
				wsprintf( mes, "%d", Money);		//\
				TextOut( hDC,450,350,mes,lstrlen(mes) );
				wsprintf( mes, "%d", H);	//\
				TextOut( hDC,480,380,mes,lstrlen(mes) );
				wsprintf( mes, "%d", M);	//\
				TextOut( hDC,520,380,mes,lstrlen(mes) );
				wsprintf( mes, "%d", S);	//\
				TextOut( hDC,560,380,mes,lstrlen(mes) );
				wsprintf( mes, "F");	//\
				TextOut( hDC,500,380,mes,lstrlen(mes) );
				wsprintf( mes, "F");	//\
				TextOut( hDC,540,380,mes,lstrlen(mes) );

				switch( Place ){
				case MODE_FIELD:
					wsprintf( mes, "tB[h" );			//\
					break;
				case MODE_TOWN:
					wsprintf( mes, "V" );			//\
					break;
				case MODE_DANJON:
					wsprintf( mes, "Ǎ@%d K", Floor );			//\
					break;
				case MODE_ISEKI:
					wsprintf( mes, "" );			//\
					break;
				}
				TextOut( hDC,450,320,mes,lstrlen(mes) );
			}else{
				wsprintf( mes, "NO_DATA");			//\
				TextOut( hDC,390,200,mes,lstrlen(mes) );
			}

			SelectObject( hDC, hFontBack );
			lpDDSBackBuffer->ReleaseDC( hDC );
		}

		//\(O)
		for( i = 0; i < 400; i++ ){//ړ
			snow[i].waitx++;
			snow[i].waity++;
			if( snow[i].flag == TRUE ){
				if( snow[i].waitx % 5 == 0 ){
					snow[i].x += snow[i].mx;
				}
				if( snow[i].waity % 2 == 0 ){
					snow[i].y += snow[i].my;
				}			
				if( snow[i].y >= 480 || snow[i].x <= 0 )	snow[i].flag = FALSE;
			}
		}

		for( i = 0; i < 400; i++ ){//\
			if( snow[i].flag == TRUE && snow[i].size == 1 ){
				SetRect( &rcSrc, 0, 172, 6, 178 );
				ClipBltFast( lpDDSBackBuffer, snow[i].x, snow[i].y, 
					lpDDSOffscreen[1],rcSrc, DDBLTFAST_SRCCOLORKEY );
			}
		}
	}

	if( MovePlay == TRUE ){//ʓ]
		if( stCButton == KEY_HIT )	CSFlag = TRUE;//IāA֐i
		MAx += 1;			//ړ
		if( MAx >= 288 )	CSFlag = TRUE;	//܂肫
		SetRect( &rcSrc, 224, 0, 256, 480 );
		ClipBltFast( lpDDSBackBuffer, MAx, 0, //
			lpDDSOffscreen[1],rcSrc, DDBLTFAST_SRCCOLORKEY );
		SetRect( &rcSrc, 256, 0, 288, 480 );  //E
		ClipBltFast( lpDDSBackBuffer, 608-MAx, 0, 
			lpDDSOffscreen[1],rcSrc, DDBLTFAST_SRCCOLORKEY );

		ddbltfx.dwSize = sizeof( ddbltfx );	//hԂ
		ddbltfx.dwFillColor = 0;
		SetRect( &rcDst, 0, 0, MAx, SCREEN_HEIGHT );		//]
		lpDDSBackBuffer -> Blt( &rcDst, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx );
		ddbltfx.dwSize = sizeof( ddbltfx );	//EhԂ
		ddbltfx.dwFillColor = 0;
		SetRect( &rcDst, 640-MAx, 0, SCREEN_WIDTH, SCREEN_HEIGHT );		//]
		lpDDSBackBuffer -> Blt( &rcDst, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx );
	}
	
	if( CSFlag == TRUE && LoadFlag == TRUE ){		//ʓ]
		ddbltfx.dwSize = sizeof( ddbltfx );
		ddbltfx.dwFillColor = 0;
		SetRect( &rcDst, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );		//]
		lpDDSBackBuffer -> Blt( &rcDst, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx );
		lpDDSBackBuffer->GetDC( &hDC );	
		hFontBack = ( HFONT )SelectObject( hDC, hFont );
		SetBkMode( hDC, TRANSPARENT );
		SetTextColor( hDC, RGB( 255, 255, 255 ) );

		//\
		wsprintf(mes,"%s","[hc");						//\
		TextOut(hDC,450,440,mes,lstrlen(mes));

		SelectObject( hDC, hFontBack );
		lpDDSBackBuffer->ReleaseDC( hDC );
	}

	//ŏIo
	DD_Flip();

	//ʓ]I
	if( CSFlag == TRUE ){
		CY = 320;			//J[\ʒu
		MovePlay = FALSE;	//ʏJn
		CSFlag = FALSE;		//ʐ؂ւtO
		ddbltfx;			//ǉ
		MAx = -32;			//̍W
		Flag = FALSE;		//ptO
		DataFlag = FALSE;	//f[^邩ǂ
		return FUNC_RELEASE;
	}

	return	FUNC_USE;
}

/////////////////////////////////////////////////////////////////
//I[vjOI
/////////////////////////////////////////////////////////////////
BYTE ReleaseGameOpening()
{
	int		i;
	
	for( i = 0 ; i < bDDSOffMax ; i++ ){
		//ItXN[T[tFCX̍폜
		ReleaseDDSOffScreen( lpszStorageFileName[ i ], &lpDDSOffscreen[ i ] );
	}
	
	if( LoadFlag == TRUE ){
		bGameMode = MODE_PLAY;
	}else{
		bGameMode = MODE_PROLOGUE;
	}

	return FUNC_INIT;	
}

/////////////////////////////////////////////////////////////////
//I[vjOt[
/////////////////////////////////////////////////////////////////
void GameOpeningIdle()
{

	BYTE	(*funcGameOpening[ 3 ])() = {
		InitGameOpening,
		GameOpening,
		ReleaseGameOpening
	};
		
	bGameOpeningMode = funcGameOpening[ bGameOpeningMode ]();
	
	return;
}