
/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include<dsound.h>
#include"DirectSound.h"
#include"Macro.h"
#include"Global.h"

/////////////////////////////////////////////////////////////////
//	O[o
//////////////////////////////////////////////////////////////////

LPDIRECTSOUND		lpDS = NULL;					//DirectSoundIuWFNg
LPDIRECTSOUNDBUFFER	lpDSPrimary = NULL;				//vC}obt@
LPDIRECTSOUNDBUFFER	lpDSSBuffer[ DSSBUFMAX ] = {0};	//ZJ_obt@
BYTE				bDSSBufMax = 0;					//gp̉̐	

/////////////////////////////////////////////////////////////////
//	InitDirectSound֐
//@DirectSound̏
/////////////////////////////////////////////////////////////////
BOOL InitDirectSound()
{
	DSBUFFERDESC	dsbd;	//TEhobt@
	HRESULT			ret;	//G[`FbNp

	//DirectSoundIuWFNg̐
	ret = DirectSoundCreate( NULL, &lpDS, NULL );
	if( ret != DS_OK ){
		MessageBox( hWnd, "DirectSoundIuWFNg̐Ɏs","DirectSoundCreate", MB_OK );
		return FALSE;
	}
	//x̐ݒ
	ret = lpDS->SetCooperativeLevel( hWnd, DSSCL_NORMAL );
	if( ret != DS_OK ){		
		MessageBox( hWnd, "x̐ݒɎs","SetCooperativeLevel", MB_OK );
		return FALSE;
	}
	//Xs[J[̐ݒ
	ret = lpDS->SetSpeakerConfig( DSSPEAKER_COMBINED( DSSPEAKER_STEREO , DSSPEAKER_GEOMETRY_WIDE) );
	if( ret != DS_OK ){		
		MessageBox( hWnd, "Xs[J[̐ݒɎs","SetSpeakerConfig", MB_OK );
		return FALSE;
	}
	//vC}obt@̐
	ZeroMemory( &dsbd, sizeof( dsbd ) );
	dsbd.dwSize = sizeof( dsbd );
	dsbd.dwFlags = DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLPAN | DSBCAPS_PRIMARYBUFFER;
	dsbd.dwBufferBytes = 0;
	dsbd.lpwfxFormat = NULL;
	ret = lpDS->CreateSoundBuffer( &dsbd, &lpDSPrimary, NULL );
	if( ret != DS_OK ){		
		MessageBox( hWnd, "vC}obt@̐Ɏs","CreateSoundBuffer", MB_OK );
		return FALSE;
	}

	//DirectSound̏
	return TRUE;
}

/////////////////////////////////////////////////////////////////
//	CreateDSBuffer֐
//@ZJ_obt@,wavet@C̓ǂݍ
/////////////////////////////////////////////////////////////////
BOOL CreateDSSBuffer(
	LPSTR lpszFileName,
	LPDIRECTSOUNDBUFFER *lplpDSSBuffer )
{
	HMMIO			hFile;			//t@Cnh
	MMCKINFO		parent,child;	//`N
	WAVEFORMATEX	wfex;			//tH[}bg
	DSBUFFERDESC	dsbd;			//TEhobt@
	LPVOID			p1,p2;			//bNobt@̃|C^
	DWORD			size1,size2;	//bNobt@̃TCY
	LONG			wb;				//ǂ݂񂾃oCg

	HRESULT			ret;			//G[`FbNp

	//ɑ݂Ă
	ReleaseDSSBuffer( lplpDSSBuffer );

	//wavet@C̓ǂݍ
	hFile = mmioOpen( lpszFileName, NULL, MMIO_READ );
	if( !hFile ){		
		MessageBox( hWnd, "wavet@C̓ǂݍ݂Ɏs","mmioRead", MB_OK );
		return FALSE;
	}
	//t@C̃`FbN
	parent.ckid = mmioFOURCC( 'R','I','F','F' );
	parent.fccType = mmioFOURCC( 'W','A','V','E' );
	if( mmioDescend( hFile, &parent, NULL, MMIO_FINDRIFF ) == MMIOERR_CHUNKNOTFOUND ){
		mmioClose( hFile, 0 );
		MessageBox( hWnd, "wavet@Cł͂܂","mmioDescend", MB_OK );
		return FALSE;
	}
	//tH[}bg̎擾
	child.ckid = mmioFOURCC( 'f','m','t',' ' );
	if( mmioDescend( hFile, &child, &parent, MMIO_FINDCHUNK ) == MMIOERR_CHUNKNOTFOUND ){
		mmioClose( hFile, 0 );
		MessageBox( hWnd, "tH[}bg`N܂","mmioDescend", MB_OK );
		return FALSE;
	}	
	if( mmioRead( hFile, ( char * )&wfex,sizeof( wfex ) ) != sizeof(wfex) ){	
		mmioClose( hFile, 0 );
		MessageBox( hWnd, "tH[}bgf[^̓ǂݍ݂Ɏs","mmioDescend", MB_OK );
		return FALSE;
	}
	//PCMtH[}bg̃`FbN
	if( wfex.wFormatTag != WAVE_FORMAT_PCM ){	
		mmioClose( hFile, 0 );
		MessageBox( hWnd, "PCMtH[}bgł͂Ȃ","", MB_OK );
		return FALSE;
	}
	//tH[}bg`No
	mmioAscend( hFile, &child, 0 );
	
	//f[^`NɈړ
	child.ckid = mmioFOURCC( 'd','a','t','a' );
	if( mmioDescend( hFile, &child, &parent, MMIO_FINDCHUNK ) == MMIOERR_CHUNKNOTFOUND ){
		mmioClose( hFile, 0 );
		MessageBox( hWnd, "f[^`N܂","mmioDescend", MB_OK );
		return FALSE;
	}	

	//ZJ_obt@̐
	ZeroMemory( &dsbd, sizeof( dsbd ) );
	dsbd.dwSize = sizeof( dsbd );
	dsbd.dwFlags = DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_LOCDEFER | DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLPAN;
	dsbd.dwBufferBytes = child.cksize;
	dsbd.lpwfxFormat = &wfex;
	ret = lpDS->CreateSoundBuffer( &dsbd,lplpDSSBuffer, NULL );
	if( ret != DS_OK ){
		mmioClose( hFile, 0 );
		MessageBox( hWnd, "ZJ_obt@̐Ɏs","CreateSoundBuffer", MB_OK );
		return FALSE;
	}

	//wavef[^𐶐ZJ_obt@ɒu
	//obt@bN
	ret = (*lplpDSSBuffer)->Lock( 0, child.cksize, &p1, &size1, &p2, &size2, 0 );
	if( ret != DS_OK ){
		mmioClose( hFile, 0 );
		MessageBox( hWnd, "ZJ_obt@̃bNɎs","Lock", MB_OK );
		return FALSE;
	}
	//bNobt@f[^o
	wb = mmioRead( hFile, (char *)p1, child.cksize );
	if( wb < 0 ){
		(*lplpDSSBuffer)->Unlock( p1, size1, p2, size2 );
		mmioClose( hFile, 0 );
		MessageBox( hWnd, "f[^ǂ݂݂ɎsɎs","mmioRead", MB_OK );
		return FALSE;
	}
	//AbN
	(*lplpDSSBuffer)->Unlock( p1, size1, p2, size2 );
	mmioAscend( hFile, &child, 0 );		//f[^`No
	mmioClose( hFile, 0 );				//t@CN[Y

	//ZJ_obt@
	return TRUE;
}

/////////////////////////////////////////////////////////////////
//	ReleaseDS֐
//@DirectSound̊eIuWFNg̉
/////////////////////////////////////////////////////////////////
void ReleaseDS()
{
	//vC}obt@̉
	if( lpDSPrimary != NULL ){
		lpDSPrimary->Release();
		lpDSPrimary = NULL;
	}

	//DirectSoundIuWFNg̉
	if( lpDS != NULL ){
		lpDS->Release();
		lpDS = NULL;
	}

	return;
}

/////////////////////////////////////////////////////////////////
//	ReleaseDSBuffer֐
//@ZJ_obt@̉
/////////////////////////////////////////////////////////////////
void ReleaseDSSBuffer(  LPDIRECTSOUNDBUFFER *lplpDSBuffer )
{
	//DirectSoundIuWFNg̉
	//T[tFCX̉
	if( ( *lplpDSBuffer ) != NULL ){
		( *lplpDSBuffer )->Stop();
		( *lplpDSBuffer )->Release();
		( *lplpDSBuffer ) = NULL;
	}

	return;
}

/////////////////////////////////////////////////////////////////
//	DS_BufferPlay֐
//@Đ
/////////////////////////////////////////////////////////////////
void DS_BufferPlay( LPDIRECTSOUNDBUFFER *lplpDSSBuffer, DWORD dwFlags )
{
	if( (*lplpDSSBuffer) != NULL ){
		(*lplpDSSBuffer)->Stop();						//~
		(*lplpDSSBuffer)->SetCurrentPosition( 0 );	//Đʒu
		(*lplpDSSBuffer)->Play( 0, 0, dwFlags );		//Đ
	}
	return;
}

/////////////////////////////////////////////////////////////////
//	DS_BufferStop֐
//@~
/////////////////////////////////////////////////////////////////
void DS_BufferStop( LPDIRECTSOUNDBUFFER *lplpDSSBuffer )
{
	if( (*lplpDSSBuffer) != NULL ){
		(*lplpDSSBuffer)->Stop();						//~
	}
	return;
}

/////////////////////////////////////////////////////////////////
//	DS_BufferVolume֐
//@{[ύX
/////////////////////////////////////////////////////////////////
void DS_BufferVolume( LPDIRECTSOUNDBUFFER *lplpDSSBuffer, LONG lVolume )
{
	if( (*lplpDSSBuffer) != NULL ){
		(*lplpDSSBuffer)->SetVolume( lVolume );		//{[ύX
	}
	return;
}

/////////////////////////////////////////////////////////////////
//	DS_BufferPan֐
//@pύX
/////////////////////////////////////////////////////////////////
void DS_BufferPan( LPDIRECTSOUNDBUFFER *lplpDSSBuffer, LONG lPan )
{
	if( (*lplpDSSBuffer) != NULL ){
		(*lplpDSSBuffer)->SetPan( lPan );		//pύX
	}
	return;
}