//////////////////////////////////////////////////////////
//CN[ht@C
//////////////////////////////////////////////////////////
#include<windows.h>
#include<math.h>
#include"Main.h"
#include"Light.h"
#include"FigData.h"
#include"Input.h"
#include"Motion.h"

#define	AxisSize	800
#define PI 3.141592 / 180			//~

//////////////////////////////////////////////////////////
//GNX^[
///////////////////////////////////////////////////////////

VERTEX Axis[3][2] = {
	-AxisSize, 0, 0,	AxisSize, 0, 0,	//w
	0, -AxisSize, 0,	0, AxisSize, 0,	//x
	0, 0, -AxisSize,	0, 0, AxisSize	//y
};

//////////////////////////////////////////////////////////
//֘A
//////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////
//]pxXV
//F|S\
//ߒlFȂ
////////////////////////////////////////////////////////////////
void AngleUpdate( FIGDATA *fig ){

	//======}`]pxݒ======//
	fig->RotateAngle.zx++;
	if( fig->RotateAngle.zx > 360 )	fig->RotateAngle.zx = 0;
	/*fig->RotateAngle.yz = ( fig->RotateAngle.yz + 1.f ) % 360.f;
	fig->RotateAngle.zx = ( fig->RotateAngle.zx + 1.f ) % 360.f;*/

}

//////////////////////////////////////////////////////////////////////
//W\
//Fgcb
//ߒlFȂ
//////////////////////////////////////////////////////////////////////
void AxisDraw( HDC hdc ){

	short		i, j;
	float		X, Y, Z, Cos, Sin, AxisX, AxisY, AxisZ;
	int			x[2], y[2];
	HPEN		hPen, hPEN;
	char		cBuf[50];

	for( i = 0; i < 3; i++ ){
		for( j = 0; j < 2; j++ ){
			AxisX = Axis[i][j].x - ViewPoint.x;
			AxisY = Axis[i][j].y - ViewPoint.y;
			AxisZ = Axis[i][j].z - ViewPoint.z;

			//=======wxʏł̉]=====//
			X = AxisX;								//vZpɂwW擾
			Y = AxisY;								//vZpɂxW擾
			Cos = (float)cos( PI * ViewAngle.z );	//vZpɂbnrlɕϊ
			Sin = (float)sin( PI * ViewAngle.z );	//vZpɂrhmlɕϊ
			AxisX = ( X * Cos - Y * Sin );//]vZiwWj
			AxisY = ( X * Sin + Y * Cos );//]vZixWj

			//======xyʏł̉]======//		
			Y = AxisY;								//vZpɂxW擾
			Z = AxisZ;								//vZpɂyW擾
			Cos = (float)cos( PI * ViewAngle.x );	//vZpɂbnrlɕϊ
			Sin = (float)sin( PI * ViewAngle.x );	//vZpɂrhmlɕϊ
			AxisY = ( Y * Cos - Z * Sin );//]vZixWj
			AxisZ = ( Y * Sin + Z * Cos );//]vZiyWj

			//======ywʏł̉]======//		
			Z = AxisZ;								//vZpɂyW擾
			X = AxisX;								//vZpɂwW擾
			Cos = (float)cos( PI * ViewAngle.y );	//vZpɂbnrlɕϊ
			Sin = (float)sin( PI * ViewAngle.y );	//vZpɂrhmlɕϊ		
			AxisZ = ( Z * Cos - X * Sin );//]vZiyWj
			AxisX = ( Z * Sin + X * Cos );//]vZiwWj

			x[j] = (int)( GXO + (AxisX * BackScreen) / AxisZ );
			y[j] = (int)( GYO - (AxisY * BackScreen) / AxisZ );

		}		

		switch( i ){
		case 0:
			//F̃y
			hPen = CreatePen( PS_SOLID, 2, RGB( 0, 0, 0) );	//y
			break;
		case 1:	
			//ԐF̃y
			hPen = CreatePen( PS_SOLID, 2, RGB( 255, 0, 0) );	//y
			break;
		case 2:
			//ΐF̃y
			hPen = CreatePen( PS_SOLID, 2, RGB( 0, 255, 0) );	//y
			break;
		}
		
		hPEN = ( HPEN )SelectObject( hdc, hPen );			//yݒ

		MoveToEx( hdc, x[0], y[0], NULL );
		LineTo( hdc, x[1], y[1] );

		SelectObject( hdc, hPEN );							//yɖ߂
		DeleteObject( hPen );								//y폜

	}

	//W̐F\
	wsprintf( cBuf, "Fw" );
	TextOut( hdc, 0, 200, cBuf, lstrlen(cBuf) );
	wsprintf( cBuf, "ԁFx" );
	TextOut( hdc, 0, 220, cBuf, lstrlen(cBuf) );
	wsprintf( cBuf, "΁Fy" );
	TextOut( hdc, 0, 240, cBuf, lstrlen(cBuf) );

}

//////////////////////////////////////////////////////////////////
//eLXg\
//F@gcb
//		@[JW
//		O@`\ǂ̃tO
//ߒlFȂ
//////////////////////////////////////////////////////////////////
void Text( HDC hdc, VERTEX *Local, BOOL DrawFlag ){

	char	cBuf[50];

	//݂̃[JW\
	wsprintf( cBuf, "}`̊_̍W(%4d, %4d, %4d)", (int)Local->x, (int)Local->y, (int)Local->z );
	TextOut( hdc, 0, 0, cBuf, lstrlen(cBuf) );

	//_W\
	wsprintf( cBuf, "_W(%4d, %4d, %4d)", (int)ViewPoint.x, (int)ViewPoint.y, (int)ViewPoint.z );
	TextOut( hdc, 0, 20, cBuf, lstrlen(cBuf) );
	
}

//////////////////////////////////////////////////////////////////////
//L[ꂽ̏
//FȂ
//ߒlFȂ
//////////////////////////////////////////////////////////////////////
void On_KeyDownI(){

	//int		i;
	static int	NO;

	//for( i = 0; i < FIG_NUM; i++ ){

		if( stUp == KEY_HIT || stUp == KEY_KEEP || stUp == KEY_CNT ){	//YZ
			FigData[0].RotateAngle.yz++;	//]pxύX
			if( FigData[0].RotateAngle.yz >= 360 )	FigData[0].RotateAngle.yz = 0;
		}
		if( stDown == KEY_HIT || stDown == KEY_KEEP || stDown == KEY_CNT ){
			FigData[0].RotateAngle.yz--;	//]pxύX
			if( FigData[0].RotateAngle.yz <= 0 )	FigData[0].RotateAngle.yz = 360;
		}

		if( stLeft == KEY_HIT || stLeft == KEY_KEEP || stLeft == KEY_CNT ){	//ZX
			FigData[0].RotateAngle.zx++;	//]pxύX
			if( FigData[0].RotateAngle.zx >= 360 )	FigData[0].RotateAngle.zx = 0;
		}
		if( stRight == KEY_HIT || stRight == KEY_KEEP || stRight == KEY_CNT ){
			FigData[0].RotateAngle.zx--;	//]pxύX
			if( FigData[0].RotateAngle.zx <= 0 )	FigData[0].RotateAngle.zx = 360;
		}

		if( stAButton == KEY_HIT || stAButton == KEY_KEEP || stAButton == KEY_CNT ){		//XY
			FigData[0].RotateAngle.xy++;	//]pxύX
			if( FigData[0].RotateAngle.xy >= 360 )	FigData[0].RotateAngle.xy = 0;
		}
		if( stBButton == KEY_HIT || stBButton == KEY_KEEP || stBButton == KEY_CNT ){
			FigData[0].RotateAngle.xy--;	//]pxύX
			if( FigData[0].RotateAngle.xy <= 0 )	FigData[0].RotateAngle.xy = 360;
		}

	//}

}

//////////////////////////////////////////////////////////////////////
//L[ꂽ̏
//FꂽL[f[^
//ߒlFȂ
//////////////////////////////////////////////////////////////////////
void On_KeyDown( WPARAM wParam ){

	switch( wParam ){
	//_ړ
	case VK_NUMPAD4:	ViewPoint.x-=4;	break;
	case VK_NUMPAD6:	ViewPoint.x+=4;	break;
	case VK_NUMPAD2:	ViewPoint.y-=4;	break;
	case VK_NUMPAD8:	ViewPoint.y+=4;	break;
	case VK_NUMPAD7:	ViewPoint.z-=4;	break;
	case VK_NUMPAD1:	ViewPoint.z+=4;	break;
	//_]
	case 'A':	ViewAngle.x--;	break;
	case 'S':	ViewAngle.x++;	break;
	case 'D':	ViewAngle.y--;	break;
	case 'F':	ViewAngle.y++;	break;
	case 'G':	ViewAngle.z--;	break;
	case 'H':	ViewAngle.z++;	break;
	//̕ύX
	case 'C':
		if( light.type == FALSE ){
			light.type  = TRUE;
		}else{
			light.type = FALSE;
		}		
		break;
	case 'J':	light.pos.x-=30;	break;
	case 'B':	light.pos.x+=30;	break;
	case 'K':	light.pos.y-=30;	break;
	case 'N':	light.pos.y+=30;	break;
	case 'L':	light.pos.z-=30;	break;
	case 'M':	light.pos.z+=30;	break;
	//`@̕ύX
	case VK_NUMPAD5:	FigData[ 0 ].mode = ( FigData[ 0 ].mode + 1 ) % 2;	break;
	//[V̕ύX
	case VK_NUMPAD9:
		if( Motion_MODE == FALSE )	Motion_MODE = TRUE;
		else						Motion_MODE = FALSE;
		break;
	}

}