/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////
#include<windows.h>
#include"Macro.h"
#include"DirectDraw.h"
#include"DirectSound.h"
#include"DirectMusic.h"
#include"DD_Draw.h"
#include"Input.h"
#include"Global.h"
#include"Fps.h"
#include"Draw.h"
#include"Rect.h"
#include"DrawEtc.h"
#include"Flag.h"
#include"ButtonInput.h"
#include"Story.h"
#include"Fade.h"
#include"CharaDraw.h"
#include"DrawBox.h"

#define	ENDING_DDSOFF_MAX	10		//GfBO̊G̖
#define ENDING_DSSBUF_MAX	1		//wave̐
#define ENDING_DMSEG_MAX	3		//tB[hMIDI̐

/////////////////////////////////////////////////////////////////
//GfBOݒ
/////////////////////////////////////////////////////////////////
BYTE InitGameEnding()
{

	int		i;

	LPSTR	lpszEndingFileName[ ENDING_DDSOFF_MAX ] = {
		"bitmap/play/chipdanjon2.bmp",
		"bitmap/play/chip.bmp",
		"bitmap/play/chiptown.bmp",
		"bitmap/play/bar.bmp",
		"bitmap/play/charabig.bmp",
		"bitmap/play/menuitem.bmp",
		"bitmap/play/chara.bmp",		
		"bitmap/play/charatown.bmp",
		"bitmap/opening/chip.bmp",
		"bitmap/play/bmptown.bmp"		
	};

	bDDSOffMax = ENDING_DDSOFF_MAX;

	for( i = 0 ; i < bDDSOffMax ; i++ ){
		//ItXN[T[tFCX̍쐬
		if(	!LoadBitmapImage( &lpszStorageFileName[ i ], lpszEndingFileName[ i ], &lpDDSOffscreen[ i ], 0, hWnd, SCREEN_WIDTH )){
			DestroyWindow( hWnd );
		}
	}

	//MIDIt@C
	LPSTR	lpszEndingMidiName[ ENDING_DMSEG_MAX ] = {
		"mid\\play\\build of new order.mid",
		"mid\\ending\\soldier repose(loop version).mid",
		"mid\\ending\\snow covered house.mid"
	};

	bDSSBufMax = ENDING_DSSBUF_MAX;
	bDMSegMax = ENDING_DMSEG_MAX;
	
	//ZOg̍쐬
	for( i = 0 ; i < bDMSegMax ; i++ ){		
		if( !CreateDMSegment( lpszEndingMidiName[ i ], &lpDMSegment[ i ] ) ){
			DestroyWindow( hWnd );
		}
	}

	//wavet@C
	LPSTR	lpszEndingWaveName[ ENDING_DSSBUF_MAX ] = {
		"wave\\all\\opening.wav"
	};

	//ZJ_obt@̍쐬
	for( i = 0 ; i < bDSSBufMax ; i++ ){		
		if( !CreateDSSBuffer( lpszEndingWaveName[ i ], &lpDSSBuffer[ i ] ) ){
			DestroyWindow( hWnd );
		}
	}

	BarFlag = TRUE;	//̓Xy[X\
	PlaceFlag = MODE_DANJON;

	lpDMSegment[0] -> SetRepeats(100);	//MidiĐ
	lpDMPerformance->PlaySegment( lpDMSegment[ 0 ], DMUS_SEGF_DEFAULT, 0, NULL );

	return FUNC_USE;
}

/////////////////////////////////////////////////////////////////
//GfBOs
/////////////////////////////////////////////////////////////////
BYTE GameEnding()
{

	RECT				rcDst,rcSrc;
	static DWORD		Wait = 0, Wait2 = 0;	//JEgp
	static int			motion = 0;		//LpAj
	int					patWalk[5] = {0,1,0,2,-1};
	static int			*patData[1] = { patWalk };
	static int			*pat;
	static int			patIndex = 0;	//
	static int			ANO[4] = {0,1,2,1};	//uvAjp^[
	int					i, j, num;
	static BYTE			E_Flag = FALSE;		//p
	DDBLTFX		ddbltfx;			//ǉ
	RECT				rcPo[3] = {			//uv`
		{0, 192,32,224},
		{32,192,64,224},
		{64,192,96,224}
	};
	RECT				rcSo[3] = {			//`
		{192,64,224,96},
		{224,64,256,96},
		{256,64,288,96}
	};
	RECT				rcSi[3] = {			//n`
		{0,  0,32,32},
		{32, 0,64,32},
		{64, 0,96,32}
	};
	RECT				rcHe[3] = {			//m`
		{192,96,224,128},
		{224,96,256,128},
		{256,96,288,128}
	};
	RECT				rcOn[3] = {			//̎q`
		{192,32,224,64},
		{224,32,256,64},
		{256,32,288,64}
	};

	//T[tFCXXg̃`FbN
	CheckDDSurfaceLost( hWnd, SCREEN_WIDTH );

	//͏
	if( EndEnd == 2 ){
		stCButton = KEY_FREE;
		return FUNC_RELEASE;
	}

	if( FadeStart == FALSE ){
		pat = patData[0];

		Wait++;

		if( Wait > 10 ){	//Ajp^[I
			Wait = 0;
			Wait2++;
			patIndex++;
			if( pat[patIndex] == -1 )	patIndex = 0;
			if( Wait2 > 3)	Wait2 = 0;
		}

		if( Story_NO <= 28 ){	//_W

			//wi\
			for( i = mapY ; i < mapY+15+restY ; i++){
				for( j = mapX; j < mapX+20+restX ; j++){
					num = mapLLL[i*250+j];
					rcSrc = rcChipS[num];
					ClipBltFast( lpDDSBackBuffer, j*32-scrX, i*32-scrY, lpDDSOffscreen[0],rcSrc, 0 );
				}
			}		

			//uv\
			if( Story_NO >= 25 ){
				ClipBltFast( lpDDSBackBuffer, 125*32-scrX, 4*32-scrY, lpDDSOffscreen[8],	//͕\
					rcPo[ ANO[Wait2] ], DDBLTFAST_SRCCOLORKEY );
			}

			//L\
			for( i = 0; i < 4; i++ ){
				SetRect( &rcSrc, 192, 128, 224, 160 );		//e
				ClipBltFast( lpDDSBackBuffer, ex[i]-scrX, ey[i]-scrY,
					lpDDSOffscreen[6],rcSrc, DDBLTFAST_SRCCOLORKEY );
			}

			for( i = 0; i < 4; i++ ){
				rcSrc = rcChara[ pat[ patIndex ] + (ViewFlagE[i]*6) + (Stand_NO[i]*24) ];
				ClipBltFast( lpDDSBackBuffer, ex[i]-scrX, ey[i]-scrY, 
					lpDDSOffscreen[6],rcSrc, DDBLTFAST_SRCCOLORKEY );
			}	

			//̕
			SetRect( &rcSrc, 192, 128, 224, 160 );		//e
			ClipBltFast( lpDDSBackBuffer, 32*125 -scrX, 32*1 -scrY, lpDDSOffscreen[6],	//e
				rcSrc, DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 32*125 -scrX, 32*1 -scrY, lpDDSOffscreen[8],	//_
				B_rc[9][Wait2], DDBLTFAST_SRCCOLORKEY );

			//̕_
			if( Story_NO == 24 ){
				SetRect( &rcDst, yx-scrX, yy-scrY, yx+32-scrX, yy+32-scrY );
				SetRect( &rcSrc, 32, 224, 64, 256);
				DD_AlphaBlt( lpDDSBackBuffer, rcDst, lpDDSOffscreen[ 8 ], rcSrc, 
					0.8, USE_COLORKEY );
			}

			DrawDanjonEtc();//_W̑X
			
		}else{	//

			if( E_Flag == FALSE ){
				E_Flag = TRUE;
				BarFlag = 1;
				StoryFlag = TRUE;				
				lpDMSegment[2] -> SetRepeats(100);	//MidiĐ
				lpDMPerformance->PlaySegment( lpDMSegment[ 2 ], DMUS_SEGF_DEFAULT, 0, NULL );
			}

			//J̈ړ
			if( px + 32 - scrX > 340 ){
				scrX = px + 32 - 340;
				if( scrX > 32 * 50 - 640 ){
					scrX = 32 * 50 - 640;
				}
			}
			if( px - scrX < 280 ){
				scrX = px - 280;
				if( scrX < 0 ){
					scrX = 0;
				}
			}
			if( py + 32 - scrY > 288 ){
				scrY = py + 32 - 288;
				if( scrY > 32 * 50 - 480 ){
					scrY = 32 * 50 - 480;
				}
			}
			if( py - scrY < 192 ){
				scrY = py - 192;
				if( scrY < 0 ){
					scrY = 0;
				}
			}

			//wii`bvj
			mapX = scrX / 32;
			mapY = scrY / 32;
			restX = scrX % 32;
			restY = scrY % 32;

			if( restX != 0 )	restX = 1;
			if( restY != 0 )	restY = 1;
			
			for( i = mapY ; i < mapY+15+restY ; i++){
				for( j = mapX; j < mapX+20+restX ; j++){
					num = mapS[i*50+j];
					rcSrc = rcChipS[num];
					ClipBltFast( lpDDSBackBuffer, j*32-scrX, i*32-scrY, lpDDSOffscreen[2],rcSrc, 0 );
				}
			}

			//L\
			for( i = 0; i < 4; i++ ){
				SetRect( &rcSrc, 192, 128, 224, 160 );		//e
				ClipBltFast( lpDDSBackBuffer, ex[i]-scrX, ey[i]-scrY,
					lpDDSOffscreen[6],rcSrc, DDBLTFAST_SRCCOLORKEY );
			}

			for( i = 0; i < 4; i++ ){
				rcSrc = rcChara[ pat[ patIndex ] + (ViewFlagE[i]*6) + (Stand_NO[i]*24) ];
				ClipBltFast( lpDDSBackBuffer, ex[i]-scrX, ey[i]-scrY, 
					lpDDSOffscreen[6],rcSrc, DDBLTFAST_SRCCOLORKEY );
			}	

			SetRect( &rcSrc, 192, 128, 224, 160 );		//eATl
			ClipBltFast( lpDDSBackBuffer, 26*32 -scrX, 36*32 -scrY, lpDDSOffscreen[6],	//e
				rcSrc, DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 24*32 -scrX, 36*32 -scrY, lpDDSOffscreen[6],	//e
				rcSrc, DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 27*32 -scrX, 34*32 -scrY, lpDDSOffscreen[6],	//e
				rcSrc, DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 18*32 -scrX, 37*32 -scrY, lpDDSOffscreen[6],	//e
				rcSrc, DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 25*32 -scrX, 36*32 -scrY, lpDDSOffscreen[6],	//e
				rcSrc, DDBLTFAST_SRCCOLORKEY );

			ClipBltFast( lpDDSBackBuffer, 26*32-scrX, 36*32-scrY, lpDDSOffscreen[7],//\
					rcSo[ ANO[Wait2] ], DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 24*32-scrX, 36*32-scrY, lpDDSOffscreen[7],//n\
					rcSi[ ANO[Wait2] ], DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 27*32-scrX, 34*32-scrY, lpDDSOffscreen[7],//m\
					rcHe[ ANO[Wait2] ], DDBLTFAST_SRCCOLORKEY );
			ClipBltFast( lpDDSBackBuffer, 18*32-scrX, 37*32-scrY, lpDDSOffscreen[7],//̎q\
					rcOn[ ANO[Wait2] ], DDBLTFAST_SRCCOLORKEY );			
			ClipBltFast( lpDDSBackBuffer, 25*32 -scrX, 36*32 -scrY, lpDDSOffscreen[8],	//_
				B_rc[9][Wait2], DDBLTFAST_SRCCOLORKEY );

			MapTownDraw();

		}

	}else{
		if( EndEnd == FALSE ){
			//tF[hCEAEg	
			if( g_dwRGBBitCount == 16 ){	//16bit
				Fade16(52);				
			}else{
				Fade32(52);				//32bit
			}
		}else{
			//tF[hCEAEg	
			if( g_dwRGBBitCount == 16 ){	//16bit
				Fade16w(53);				
			}else{
				Fade32w(53);				//32bit
			}	
		}
	}

	ButtonInput();		//͏

	if( BarFlag >= 1 && BarFlag <= 2 )	BarDraw();		//Xy[X\
	
	Story_1();	//Cxg	

	if( WhiteFlag == TRUE ){		//hԂ
		ddbltfx.dwSize = sizeof( ddbltfx );
		if( g_dwRGBBitCount == 16 ){	//16bit
			ddbltfx.dwFillColor = 0xffff;
		}else{							//32bit
			ddbltfx.dwFillColor = 0xffffff;
		}
		SetRect( &rcDst, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );
		lpDDSBackBuffer -> Blt( &rcDst, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx );
	}

	//ŏIo
	DD_Flip();
	
	return	FUNC_USE;
}

/////////////////////////////////////////////////////////////////
//GfBOI
/////////////////////////////////////////////////////////////////
BYTE ReleaseGameEnding()
{
	int		i;

	for( i = 0 ; i < bDDSOffMax ; i++ ){
		//ItXN[T[tFCX̍폜
		ReleaseDDSOffScreen( lpszStorageFileName[ i ], &lpDDSOffscreen[ i ] );
	}

	EndEnd = FALSE;

	bGameMode = MODE_STAFFROLL;
	
	return FUNC_INIT;
}

/////////////////////////////////////////////////////////////////
//GfBOt[
/////////////////////////////////////////////////////////////////
void GameEndingIdle()
{
	
	BYTE	(*funcGameEnding[ 3 ])() = {
		InitGameEnding,
		GameEnding,
		ReleaseGameEnding
	};	

	bGameEndingMode = funcGameEnding[ bGameEndingMode ]();

	return;
}