//////////////////////////////////////////////////////////////////////
//CN[ht@C
//////////////////////////////////////////////////////////////////////
#include <windows.h>
#include "Input.h"
#include "Global.h"

//////////////////////////////////////////////////////////////////////
//O[o
//////////////////////////////////////////////////////////////////////
//L[{[h͂̏
DWORD		stKeyUp;	
DWORD		stKeyDown;
DWORD		stKeyLeft;
DWORD		stKeyRight;
DWORD		stKeyAButton;
DWORD		stKeyBButton;
DWORD		stKeyCButton;
DWORD		stKeyDButton;

//WCpbg͂̏
DWORD		stJoyUp;	
DWORD		stJoyDown;
DWORD		stJoyLeft;
DWORD		stJoyRight;
DWORD		stJoyAButton;
DWORD		stJoyBButton;
DWORD		stJoyCButton;
DWORD		stJoyDButton;

//ꂽ
DWORD		stUp;	
DWORD		stDown;
DWORD		stLeft;
DWORD		stRight;
DWORD		stAButton;
DWORD		stBButton;
DWORD		stCButton;
DWORD		stDButton;

POINT		mousePos;	//}EXJ[\W
DWORD		stLButton;
DWORD		stRButton;

int	KEEP_CNT = 0;
///////////////////////////////////////////////////////////////////////
//Input֐
//e͂𒲂ׂ
//		
//	ߒl	
//////////////////////////////////////////////////////////////////////
void Input()
{

	//L[{[h͂̏
	CheckKeyState( VK_UP,	&stKeyUp );
	CheckKeyState( VK_DOWN, &stKeyDown );
	CheckKeyState( VK_LEFT, &stKeyLeft );
	CheckKeyState( VK_RIGHT,&stKeyRight );
	CheckKeyState( 'Z', &stKeyAButton );
	CheckKeyState( 'X', &stKeyBButton );
	CheckKeyState( 'C', &stKeyCButton );
	CheckKeyState( 'V', &stKeyDButton );
	
	//WCpbh͂̏
	CheckJoypadState( PAD_UP,	&stJoyUp );
	CheckJoypadState( PAD_DOWN, &stJoyDown );
	CheckJoypadState( PAD_LEFT, &stJoyLeft );
	CheckJoypadState( PAD_RIGHT,&stJoyRight );
	CheckJoypadState( PAD_A, &stJoyAButton );
	CheckJoypadState( PAD_B, &stJoyBButton );
	CheckJoypadState( PAD_C, &stJoyCButton );
	CheckJoypadState( PAD_D, &stJoyDButton );

	//ꂽ
	stUp = stKeyUp | stJoyUp;
	stDown = stKeyDown | stJoyDown;
	stLeft = stKeyLeft | stJoyLeft;
	stRight = stKeyRight | stJoyRight;
	stAButton = stKeyAButton | stJoyAButton;
	stBButton = stKeyBButton | stJoyBButton;
	stCButton = stKeyCButton | stJoyCButton;
	stDButton = stKeyDButton | stJoyDButton;

	//}EX̎擾
	GetMouseState();

	return;
}

//////////////////////////////////////////////////////////////////////
//CheckKeyState֐
//L[{[h͂̏Ԃ𒲂ׂ
//	
//		PFzL[R[h
//		QFԊi[pϐւ̃|C^
//	ߒl	
//////////////////////////////////////////////////////////////////////
void CheckKeyState( DWORD vKey, DWORD *st )
{
	if( HIBYTE( GetAsyncKeyState( vKey ) ) ){
		if( *st == KEY_FREE || *st == KEY_AWAY ){
			*st = KEY_HIT;
		}else{
			if( KEEP_CNT <= 19 ){
				*st = KEY_CNT;
				KEEP_CNT++;
			}
			if( KEEP_CNT >= 20 )	*st = KEY_KEEP;
		}
	}else{
		if( *st == KEY_KEEP || *st == KEY_HIT || *st == KEY_CNT ){
			*st = KEY_AWAY;
			KEEP_CNT = 0;
		}else{
			*st = KEY_FREE;
		}
	}
	
	return;
}

//////////////////////////////////////////////////////////////////////
//CheckJoypadState֐
//WCpbh͂̏Ԃ𒲂ׂ
//	
//		PFzL[R[h(Inpt.h)
//		QFԊi[pϐւ̃|C^
//	ߒl	
//////////////////////////////////////////////////////////////////////
void CheckJoypadState( DWORD vKey, DWORD *st )
{
	
	if( GetJoypadState( vKey )  ){
		if( *st == KEY_FREE || *st == KEY_AWAY ){
			*st = KEY_HIT;
		}else{
			if( KEEP_CNT <= 19 ){
				*st = KEY_CNT;
				KEEP_CNT++;
			}
			if( KEEP_CNT >= 20 )	*st = KEY_KEEP;
		}
	}else{
		if( *st == KEY_KEEP || *st == KEY_HIT || *st == KEY_CNT ){
			*st = KEY_AWAY;
			KEEP_CNT = 0;
		}else{
			*st = KEY_FREE;
		}
	}
	return;
}

//////////////////////////////////////////////////////////////////////
//GetJoypadState֐
//WCpbh͂𒲂ׂ
//	
//		PFzL[R[h(Inpt.h)
//	ߒl	
//@FTRUE
//@ĂȂFFALSE
//////////////////////////////////////////////////////////////////////
BOOL GetJoypadState( DWORD	vKey )
{
	JOYINFOEX			joy;
	static DWORD		err = JOYERR_NOERROR;

	joy.dwSize = sizeof( JOYINFOEX );
	joy.dwFlags = JOY_RETURNX | JOY_RETURNY | JOY_RETURNBUTTONS;
	if( err == JOYERR_NOERROR ){
		err = joyGetPosEx( JOYSTICKID1, &joy );
		if( joy.dwButtons == ( DWORD )vKey )		return TRUE;
		if( vKey == PAD_UP && joy.dwYpos < 16000 )	return TRUE;
		if( vKey == PAD_DOWN && joy.dwYpos > 48000 )return TRUE;
		if( vKey == PAD_LEFT && joy.dwXpos < 16000 )return TRUE;
		if( vKey == PAD_RIGHT && joy.dwXpos > 48000 )return TRUE;
	}
	return FALSE;	//ĂȂ
}

//////////////////////////////////////////////////////////////////////
//GetMouseState֐
//}EX͏̎擾
//		
//	ߒl	
//////////////////////////////////////////////////////////////////////
void GetMouseState()
{

	GetCursorPos( &mousePos );
	ScreenToClient( hWnd, &mousePos );
	CheckKeyState( VK_LBUTTON, &stLButton );
	CheckKeyState( VK_RBUTTON, &stRButton );

	return;
}