//////////////////////////////////////////////////////////////////
//|S֘A//
//////////////////////////////////////////////////////////////////
#include<windows.h>
#include<ddraw.h>
#include<math.h>
#include <stdio.h>
#include"Main.h"
#include"Global.h"
#include"Input.h"
#include"FigData.h"
#include"Light.h"
#include"Etc.h"
#include"Motion.h"

#define PI 3.141592 / 180			//~

////////////////////////////////////////////////////////////////////
//|S@O[oϐ
/////////////////////////////////////////////////////////////////////
float	GXO, GYO;			//O[oWň_
float	BackScreen = 500.0;	//eʂ̂yW

CAMERA	camera[2] = {
	{ {   0.0, 100.0, -500.0}, {  0,  0,  0} },
	{ { 800.0, 200.0,    0.0}, {  0, 90,  0} }
};

VERTEX ViewPoint = camera[0].ViewPoint;	//_̍W

ANGLE_3D	RevolveAngle;			//S}`̌]px

ANGLE_3Df	ViewAngle = camera[0].ViewAngle;	//_̌

VERTEX Global = {	//O[oWň_ïʒuj
	0.0, 0.0, 0.0
};

int		FigOrder[FIG_NUM];	//}`̃\[gf[^

VERTEX VertexBuf_Draw[VERTEX_NUM];

BYTE	Motion_MODE = FALSE;
//BYTE	Motion_MODE = TRUE;
BYTE	Attack = FALSE;

//pWl
VERTEX	*VerPer;

//EtOisqtdŕj
BYTE	PerFlag = FALSE;

//Wړ̍Wۊǂϐ
VERTEX	*Move;

//////////////////////////////////////////////////////////////////
//|S@C
//FobNobt@
//ߒlFȂ
//////////////////////////////////////////////////////////////////
void MainFunc( LPDIRECTDRAWSURFACE7 lpDDBackSurface ){

	HDC			hdc;
	int			i = 0,j = 0;
	static BYTE	fSetData = FALSE;	//
	static BYTE	FSETDATA = FALSE;	//ړʒu

	if( fSetData == FALSE ){
		fSetData = TRUE;
		VerPer = new VERTEX[ FigData[0].nPlane ];		//_Wi[p
		Move   = new VERTEX[ FigData[0].nPlane ];		//_Wi[p
		for( i = 0; i < FigData[0].nPlane; i++ ){	//ŏIړW
			VerPer[i].x = 0;
			VerPer[i].y = 0;
			VerPer[i].z = 0;
			Move[i].x = 0;//݂̍Wړpϐɑ
			Move[i].y = 0;
			Move[i].z = 0;
		}
	}

	//
	if( PerFlag == TRUE ){//
		if( FSETDATA == FALSE ){
			FSETDATA = TRUE;
			for( i = 0; i < FigData[0].nPlane; i++ ){	//ŏIړW
				VerPer[i].x = (float)(rand() % 700);
				VerPer[i].y = (float)(rand() % 520);
				VerPer[i].z = (float)(rand() % 600);
				if( rand() % 2 == 0 ){			//W̐
					VerPer[i].x *= -1;	
				}
				if( rand() % 2 == 0 ){
					VerPer[i].y *= -1;	
				}
				if( rand() % 2 == 0 ){
					VerPer[i].z *= -1;
				}
			}
		}
	}

	//]pxXV
	AngleUpdate( &FigData[0] );

	lpDDBackSurface -> GetDC( &hdc );	//foCXReLXgnh擾
	SetBkMode( hdc, TRANSPARENT );	
	
	for( i = 0; i < 1; i++ ){
		//_̈ړ
		Parallel( &FigData[i] );
		FigData[i].Angle_c = FigData[i].RotateAngle;
		FigData[i].Local_Cnt = FigData[i].Local;
	}

	for( i = 0; i < 1; i++ ){	

		//_̈ړi]j
		Revolve( &FigData[ i ].Local_Cnt, &FigData[ i ].Local, &RevolveAngle, &Global );		
		
		//}`̎]
		Rotate( &FigData[i] );
		
		//Ȅ
		if( PerFlag == TRUE ){
			SortPolygon1( &FigData[i] );
			PlaneMove( &FigData[i], VerPer, Move );
		}

		//@xNg߂
		GetVertexVect( &FigData[i] );

		//
		GetPolygonColor( &FigData[i] );		

		//e̎_ړE]
		ViewTransform( FigData[i].pShadowBuf, FigData[i].nVertex );			
		
		//_ړE]
		ViewTransform( FigData[i].pVertexBuf_cnt, FigData[i].nVertex );
	}

	//̂̕\vZ
	SortFig();

	/*for( i = 0; i < 1; i++ ){
		//e̓eϊƕ`
		FigData[i].DrawFlag = Projection( FigData[i].pShadowBuf, FigData[i].nVertex );		
		if( FigData[i].DrawFlag ){
			DrawShadow( hdc, &FigData[i] );
		}	
	}*/

	lpDDBackSurface -> ReleaseDC( hdc );	//foCXReLXgnh̊J

	for( i = 0; i < 1; i++ ){

		j = FigOrder[i];
		
		//̂̐F߂
		GetModelColor( FigData[ j ].col, FigData[ j ].col_c, FigData[ j ].pBrightness,
			&light, FigData[ j ].nVertex );
		
		//eϊƕ`
		FigData[j].DrawFlag = Projection( FigData[j].pVertexBuf_cnt, FigData[j].nVertex );
		//}``\Ȕ͈͂ɑ݂Ă`悷
		if( FigData[j].DrawFlag ){
			SortPolygon1( &FigData[j] );
			Draw( &FigData[j], lpDDBackSurface, VerPer, Move );
		}
			
	}

}

//////////////////////////////////////////////////////////////////
//|S֌W֐Q
//////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////
//]i[JW̉]j
//F@[JWvZp
//		@[JW
//		O@]px
//		l@e̍W
//ߒlFȂ
//////////////////////////////////////////////////////////////////
void	Revolve( VERTEX		*local,			//]̍Wi[AhX
				 VERTEX		*local_before,	//]_̍W
				 ANGLE_3D	*angle,			//]px
				 VERTEX		*parent			//]̊_ie̍Wj
){

	float	X, Y, Z, Cos, Sin;

	/*local->x = local_before->x;		//vZpɉ]ÔwW擾
	local->y = local_before->y;		//vZpɉ]ÔxW擾
	local->z = local_before->z;		//vZpɉ]ÔyW擾*/
	local->x -= parent->x;
	local->y -= parent->y;
	local->z -= parent->z;

	//======wxʏł̉]======//
	X = local->x;						//vZpɂwW擾
	Y = local->y;						//vZpɂxW擾
	Cos = ( float )cos( PI * angle->xy );	//vZpCOS lɕϊ
	Sin = ( float )sin( PI * angle->xy );	//vZpSIN lɕϊ
	local->x = ( X*Cos - Y*Sin );		//]vZiwWj
	local->y = ( X*Sin + Y*Cos );		//]vZixWj

	//======xyʏł̉]======//
	Y = local->y;						//vZpɂxW擾
	Z = local->z;						//vZpɂyW擾
	Cos = ( float )cos( PI * angle->yz );	//vZpCOS lɕϊ
	Sin = ( float )sin( PI * angle->yz );	//vZpSIN lɕϊ
	local->y = ( Y*Cos - Z*Sin );		//]vZixWj
	local->z = ( Y*Sin + Z*Cos );		//]vZiyWj

	//======ywʏł̉]======//
	Z = local->z;						//vZpɂyW擾
	X = local->x;						//vZpɂwW擾
	Cos = ( float )cos( PI * angle->zx );	//vZpCOS lɕϊ
	Sin = ( float )sin( PI * angle->zx );	//vZpSIN lɕϊ
	local->z = ( Z*Cos - X*Sin );		//]vZiyWj
	local->x = ( Z*Sin + X*Cos );		//]vZiwWj

	local->x += parent->x;
	local->y += parent->y;
	local->z += parent->z;

}

//////////////////////////////////////////////////////////////////////
//]vZieq[Jzu܂ށj
//F@|S\
//		@e̍\
//ߒlFȂ
//////////////////////////////////////////////////////////////////////
void Rotate( FIGDATA *fig, FIGDATA *parent ){

	//]vZ
	RotateF( fig->pVertexBuf_cnt, &parent->Angle_c, fig->nVertex );
	//sړ
	VertexTranslate( fig->pVertexBuf_cnt, &parent->Local_Cnt, fig->nVertex );

	//̐e߂
	if( parent->pFig_Parent == NULL )	return;

	//ẻ]pE[JWŉ]vZi]js
	Rotate( fig, parent->pFig_Parent );

}

//////////////////////////////////////////////////////////////////////
//]vZiŚj
//F|S\
//ߒlFȂ
//////////////////////////////////////////////////////////////////////
void Rotate( FIGDATA *fig ){

	//ŏ͎̉]pxŉ]Jn
	Rotate( fig, fig );

}

//////////////////////////////////////////////////////////////////////
//]i}`Ŝ̉]j
//F@_Wi[p
//		@]px
//		O@_
//ߒlFȂ
//////////////////////////////////////////////////////////////////////
void RotateF( VERTEX		*vertex_cnt,	//]̍Wi[AhX
		      ANGLE_3D		*angle,			//]px
			  int			dwVer			//}`̒_̐
){

	int		i;
	float	X, Y, Z, Cos, Sin;

	for( i=0; i<dwVer; i++ )
	{

		//======wxʕ\ł̉]======//
		X = vertex_cnt->x;					//vZpɂwW擾
		Y = vertex_cnt->y;					//vZpɂxW擾
		Cos = ( float )cos( PI * angle->xy );	//vZpCOS lɕϊ
		Sin = ( float )sin( PI * angle->xy );	//vZpSIN lɕϊ
		vertex_cnt->x = ( X*Cos - Y*Sin );	//]vZiwWj
		vertex_cnt->y = ( X*Sin + Y*Cos );	//]vZiwWj

		//======xyʕ\ł̉]======//
		Y = vertex_cnt->y;					//vZpɂxW擾
		Z = vertex_cnt->z;					//vZpɂyW擾
		Cos = ( float )cos( PI * angle->yz );	//vZpCOS lɕϊ
		Sin = ( float )sin( PI * angle->yz );	//vZpSIN lɕϊ
		vertex_cnt->y = ( Y*Cos - Z*Sin );	//]vZixWj
		vertex_cnt->z = ( Y*Sin + Z*Cos );	//]vZiyWj

		//======ywʕ\ł̉]======//
		Z = vertex_cnt->z;					//vZpɂyW擾
		X = vertex_cnt->x;					//vZpɂwW擾
		Cos = ( float )cos( PI * angle->zx );	//vZpCOS lɕϊ
		Sin = ( float )sin( PI * angle->zx );	//vZpSIN lɕϊ
		vertex_cnt->z = ( Z*Cos - X*Sin );	//]vZiyWj
		vertex_cnt->x = ( Z*Sin + X*Cos );	//]vZiwWj

		vertex_cnt++;
	}

}

//////////////////////////////////////////////////////////////////
//}`̕sړ
//F|S\
//ߒlFȂ
//////////////////////////////////////////////////////////////////
void Parallel( FIGDATA *fig ){

	int			i;

	for( i = 0; i < fig->nVertex; i++ ){
		if( fig->pVertexBuf_cnt != fig->pVertexBuf ){
			fig->pVertexBuf_cnt[i].x = fig->pVertexBuf[i].x;
			fig->pVertexBuf_cnt[i].y = fig->pVertexBuf[i].y;
			fig->pVertexBuf_cnt[i].z = fig->pVertexBuf[i].z;
		}
	}

}

//////////////////////////////////////////////////////////////////
//}`\Wnɕϊ
//F@_WivZpj
//		@_
//ߒlF\\ʒu
//////////////////////////////////////////////////////////////////
BOOL Projection( VERTEX *vertex_d, short nVertex ){

	short	i;


	//`p̒_W̌vZyѕ`\ǂ̃`FbN
	for( i = 0; i < nVertex; i++ ){

		if( vertex_d->z <= 0 ){		//\\Ȉʒui_OɂjH
			return FALSE;	//\s\ȈʒuȂȌ̏͂Ȃ
		}

		//eϊi_̓O[oW̌_j
		//fBXvC̍Wnɕϊ
		vertex_d->x = ( vertex_d->x * BackScreen ) / vertex_d->z;
		vertex_d->y = ( vertex_d->y * BackScreen ) / vertex_d->z;
		vertex_d++;
	}

	return TRUE;

}

/////////////////////////////////////////////////////////////////
//sړϊi[JO[oϊj
//F@_W
//		@O[oW
//		O@_
//ߒlFȂ
/////////////////////////////////////////////////////////////////
void VertexTranslate( VERTEX *vertex, VERTEX *pos, short nVertex ){

	short		i;

	for( i = 0; i < nVertex; i++ ){
		vertex[i].x += pos->x;
		vertex[i].y += pos->y;
		vertex[i].z += pos->z;
	}

}

/////////////////////////////////////////////////////////////////
//ʂ̕\߂ivZj
//F|S\
//ߒlFȂ
/////////////////////////////////////////////////////////////////
void SortPolygon1( FIGDATA *fig ){

	int			i;
	float		z0, z1, z2;
	float		*PolygonZ;

	PolygonZ = new float[ fig->nPlane ];
	for( i = 0; i < fig->nPlane; i++ ){
		fig->pPolygonOrder[i] = i;

		z0 = fig->pVertexBuf_cnt[ fig->pLinkBuf[i].v0 ].z;
		z1 = fig->pVertexBuf_cnt[ fig->pLinkBuf[i].v1 ].z;
		z2 = fig->pVertexBuf_cnt[ fig->pLinkBuf[i].v2 ].z;
		PolygonZ[i] = (float)( ( z0 + z1 + z2 ) / 3.0 );
	}

	SortPolygon2( fig, PolygonZ );
	delete PolygonZ;

}

/////////////////////////////////////////////////////////////////
//ʂ̕\߂ivZj
//F@|S\
//		@ʂ̕\i[p
//ߒlFȂ
/////////////////////////////////////////////////////////////////
void SortPolygon2( FIGDATA *fig, float *PolygonZ ){

	int			i, j, Num;
	float		z;

	for( i = 0; i < fig->nPlane-1; i++ ){
		for( j = i + 1; j < fig->nPlane; j++ ){
			if( PolygonZ[i] < PolygonZ[j] ){
				Num = fig->pPolygonOrder[i];
				fig->pPolygonOrder[i] = fig->pPolygonOrder[j];
				fig->pPolygonOrder[j] = Num;
				z = PolygonZ[i];
				PolygonZ[i] = PolygonZ[j];
				PolygonZ[j] = (float)Num;
			}
		}
	}

}

///////////////////////////////////////////////////////////////
//\
//F_f[^iꖇj
//ߒlF\
///////////////////////////////////////////////////////////////
int SideCheck( POINT *pTri ){

	int		Zvct, x0, y0, x1, y1, x2, y2;

	x0 = pTri[0].x;		//Op`̒_OXW
	y0 = pTri[0].y;		//Op`̒_OYW
	x1 = pTri[1].x;		//Op`̒_PXW
	y1 = pTri[1].y;		//Op`̒_PYW
	x2 = pTri[2].x;		//Op`̒_QXW
	y2 = pTri[2].y;		//Op`̒_QYW

	Zvct = ( x1 - x0 ) * ( y2 - y0 ) - ( y1 - y0 ) * ( x2 - x0 );
	if( Zvct < 0 ){	//@xNgZvf̏ꍇ
		return (1);	//Ei\j
	}

	return (0);		//łȂ΍ij

}

//////////////////////////////////////////////////////////////////////
//]
//F@_Wi[p
//		@_
//ߒlFȂ
//////////////////////////////////////////////////////////////////////
void ViewTransform( VERTEX		*vertex_cnt,	//]̍Wi[AhX
			 	   short		nVertex			//}`̒_̐
){

	short	i;
	float	X, Y, Z, Cos, Sin;

	for( i = 0; i < nVertex; i++ ){

		vertex_cnt[i].x -= ViewPoint.x;
		vertex_cnt[i].y -= ViewPoint.y;
		vertex_cnt[i].z -= ViewPoint.z;

		//======wxʏł̉]======//
		X = vertex_cnt[i].x;					//vZpɂwW擾
		Y = vertex_cnt[i].y;					//vZpɂxW擾
		Cos = (float)cos( PI * ViewAngle.z );	//vZpɂbnrlɕϊ
		Sin = (float)sin( PI * ViewAngle.z );	//vZpɂrhmlɕϊ
		vertex_cnt[i].x = ( X * Cos - Y * Sin );//]vZiwWj
		vertex_cnt[i].y = ( X * Sin + Y * Cos );//]vZixWj

		//======xyʏł̉]======//		
		Y = vertex_cnt[i].y;					//vZpɂxW擾
		Z = vertex_cnt[i].z;					//vZpɂyW擾
		Cos = (float)cos( PI * ViewAngle.x );	//vZpɂbnrlɕϊ
		Sin = (float)sin( PI * ViewAngle.x );	//vZpɂrhmlɕϊ
		vertex_cnt[i].y = ( Y * Cos - Z * Sin );//]vZixWj
		vertex_cnt[i].z = ( Y * Sin + Z * Cos );//]vZiyWj

		//======ywʏł̉]======//		
		Z = vertex_cnt[i].z;					//vZpɂyW擾
		X = vertex_cnt[i].x;					//vZpɂwW擾
		Cos = (float)cos( PI * ViewAngle.y );	//vZpɂbnrlɕϊ
		Sin = (float)sin( PI * ViewAngle.y );	//vZpɂrhmlɕϊ		
		vertex_cnt[i].z = ( Z * Cos - X * Sin );//]vZiyWj
		vertex_cnt[i].x = ( Z * Sin + X * Cos );//]vZiwWj

	}

}

///////////////////////////////////////////////////////////////////////
//}`̒S王_܂ł̋vZ
//F@_WvZp
//		@_f[^
//		O@_
//ߒlFȂ
///////////////////////////////////////////////////////////////////////
float GetDistance(
	VERTEX *vertex_c,	//_vZpf[^
	VERTEX *Eye,		//_f[^
	DWORD dwVer		//_
){

	float	x = 0.0, y = 0.0, z = 0.0, Dis;
	DWORD	i;

		//̂̒SW(el̕)߂
	for( i=0; i<dwVer; i++ ){
		x += vertex_c[i].x;
		y += vertex_c[i].y;
		z += vertex_c[i].z;
	}

	x /= dwVer;
	y /= dwVer;
	z /= dwVer;

	//̂Ǝ_̋߂
	Dis = ( float )sqrt( (x*x) + (y*y) + ( (z-Eye->z)*(z-Eye->z) ) );

	return Dis;
}

///////////////////////////////////////////////////////////////////////
//}`̕\߂
//FȂ
//ߒlFȂ
///////////////////////////////////////////////////////////////////////
void SortFig(){

	int		i, j, Num;
	float	z;
	float	L[FIG_NUM];

	for( i = 0; i < FIG_NUM; i++ ){
		L[i] = GetDistance( FigData[i].pVertexBuf_cnt, &ViewPoint, FigData[i].nVertex );
	}

	for( i = 0; i < FIG_NUM; i++ ){
		FigOrder[i] = i;	//\̏
	}

	for( i = 0; i < FIG_NUM - 1; i++ ){
		for( j = i + 1; j < FIG_NUM; j++ ){
			if( L[i] < L[j] ){
				Num = FigOrder[i];
				FigOrder[i] = FigOrder[j];
				FigOrder[j] = Num;
				z = L[i];
				L[i] = L[j];
				L[j] = z;
			}
		}
	}

}

//////////////////////////////////////////////////////////////////
//eʈړ
//F@|S\
//		@_ŏIړW
//		O@ړ
//ߒlFȂ
//////////////////////////////////////////////////////////////////
void PlaneMove( FIGDATA *fig, VERTEX *pPer, VERTEX *pMov ){

	double	mx,my,mz,w,h,z,d;
	int		i,NO;

	for( i = 0; i < fig->nPlane; i++ ){
		NO = fig->pPolygonOrder[i];	//\ʂ̔ԍ

		w = ( pPer[NO].x - pMov[NO].x );	//x̍
		h = ( pPer[NO].y - pMov[NO].y );	//y̍
		z = ( pPer[NO].z - pMov[NO].z );	//z̍
		d = sqrt(w*w+h*h+z*z);	//R_Ԃ̋
		mx = 3 * w /d;
		my = 3 * h /d;
		mz = 3 * z /d;

		if( mx > 1 || mx < -1 )	pMov[NO].x += (int)mx*2;	//ňړ
		if( my > 1 || my < -1 )	pMov[NO].y += (int)my*2;
		if( mz > 1 || mz < -1 )	pMov[NO].z += (int)mz*2;		
	}

}

