#pragma comment( lib, "winmm.lib")
#pragma comment( lib, "dxguid.lib")
#pragma comment( lib, "ddraw.lib")
#pragma comment( lib, "dsound.lib")

/////////////////////////////////////////////////////////////////
//	CN[ht@C
/////////////////////////////////////////////////////////////////

#include<windows.h>
#include"Macro.h"
#include"DirectDraw.h"
#include"DirectSound.h"
#include"DirectMusic.h"
#include"Fps.h"
#include"Global.h"
#include"resource.h"
#include"Struct.h"
#include"Animetion.h"
#include"SaveLoad.h"
#include"Main.h"
#include"FigData.h"

/////////////////////////////////////////////////////////////////
//	vg^Cv
/////////////////////////////////////////////////////////////////

LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );	//EBhEvV[W
void GameMain();										//Ct[
static void OnCreate( HWND, LPCREATESTRUCT );
static void OnDestroy( HWND );

/////////////////////////////////////////////////////////////////
//	O[o
/////////////////////////////////////////////////////////////////

static BOOL		fActive = FALSE;			//AvP[ṼANeBuANeBȕ


/////////////////////////////////////////////////////////////////
//	WinMain(Gg|Cg)
/////////////////////////////////////////////////////////////////

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszArgs, int nWinMode )
{
	LPCSTR	lpszWinClsName = "WinCls";	//EBhENX
	LPCSTR	lpszWndTitle = "r\";	//^Cg
	WNDCLASSEX		wcex;				//EBhENX
	MSG				msg;				//bZ[W
	RECT			rect;				//NCAg̈
	int				Width,Height;		//EBhE̕ƍ
	HANDLE			hMutex = NULL;		//dNh~p
	int				i;

	//EBhENXݒ
	wcex.cbSize = sizeof( WNDCLASSEX );		//TCY̐ݒ
	wcex.style = 0;							//X^C̐ݒ
	wcex.lpfnWndProc = ( WNDPROC )WndProc;	//vV[W̐ݒ
	wcex.cbClsExtra = 0;					//gp
	wcex.cbWndExtra = 0;					//gp
	wcex.hInstance = hInstance;				//CX^Xnh̐ݒ				
	wcex.hIcon = LoadIcon(hInstance,MAKEINTRESOURCE(IDI_ICON1));	//ACR̐ݒ
	wcex.hCursor = LoadCursor( NULL, IDC_ARROW );					//J[\̐ݒ
	wcex.hbrBackground = ( HBRUSH )GetStockObject( WHITE_BRUSH );	//wi̐ݒ
	wcex.lpszMenuName = NULL;										//j[̐ݒ
	wcex.lpszClassName = lpszWinClsName;							//EBhENX̐ݒ
	wcex.hIconSm = LoadIcon( NULL, IDI_APPLICATION );				//X[ACR̐ݒ
	//EBhENXo^
	if( !RegisterClassEx( &wcex ) )		return 0;	//EBhENXo^s

	//NCAg̈悩EChETCYݒ
	SetRect( &rect, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );		//NCAg̈̃TCYw
	AdjustWindowRectEx( &rect, WNDSTYLE, FALSE, WNDSTYLEEX );	//EBhË̎擾
	Width = rect.right - rect.left;		//EBhE̕
	Height = rect.bottom - rect.top;	//EBhE̍

	//EBhE쐬
	hWnd = CreateWindowEx(
		WNDSTYLEEX,				//gEBhEX^C̐ݒ
		lpszWinClsName,			//o^ꂽEBhENX̐ݒ
		lpszWndTitle,			//^Cg̐ݒ
		WNDSTYLE,				//EBhEX^C̐ݒ
		189,128,				//EBhE̕\ʒu̐ݒ
		Width,					//EBhE̕
		Height,					//EBhE̍
		NULL,					//eEBhEnh̐ݒ
		NULL,					//j[nh̐ݒ
		hInstance,				//CX^Xnh̐ݒ
		NULL					//gp
		);
	if( hWnd == NULL )		return 0;	//EBhE쐬s
	//EBhE\
	ShowWindow( hWnd, nWinMode );
	UpdateWindow( hWnd );

	//MutexObjectiLj̍쐬
	hMutex = CreateMutex( NULL, TRUE, "{" );

	//L̃`FbNAɍ쐬ĂI
	if( GetLastError() == ERROR_ALREADY_EXISTS ){
		//ÕG[擾ł֐
		CloseHandle( hMutex );	//Mutex
		return 0;
	}

	if( FFlag == FALSE ){
		FFlag = TRUE;
		Data_LoadEX();		//ʃTCYmF
		Data_LoadCheack();	//f[^邩ǂ
	}

	//J[\̕\A\
	if( fDDrawMode == MODE_FULLSCREEN ){	//tXN[
		while( ShowCursor( FALSE ) >= 0 );	//\
	}else{									//EBhE
		while( ShowCursor( TRUE ) < 0 );	//\
	}

	//DirectDraw
	if( !InitDirectDraw( hWnd, SCREEN_WIDTH, SCREEN_HEIGHT, DEPTH ) ){
		ReleaseDD();
		return 0;
	}
	//bpp𒲂ׂ
	g_dwRGBBitCount = CheckRGBBitCount( lpDDSBackBuffer );

		//DirectSound
	if( !InitDirectSound() ){
		ReleaseDS();
		ReleaseDD();
		return 0;
	}

	//DirectMusic
	if( !InitDirectMusic() ){
		ReleaseDM();
		ReleaseDS();
		ReleaseDD();
		return 0;
	}

	hFont = CreateFont( 25,0, 0,0,600,
								0,0,0, SHIFTJIS_CHARSET, 
								OUT_DEFAULT_PRECIS, 
								CLIP_DEFAULT_PRECIS,
								PROOF_QUALITY,
								DEFAULT_PITCH | FF_ROMAN,
								"MS PSVbN" );

	hFont2 = CreateFont( 18,0, 0,0,600,
								0,0,0, SHIFTJIS_CHARSET, 
								OUT_DEFAULT_PRECIS, 
								CLIP_DEFAULT_PRECIS,
								PROOF_QUALITY,
								DEFAULT_PITCH | FF_ROMAN,
								"MS P" );

	hFont3 = CreateFont( 14,0, 0,0,600,
								0,0,0, SHIFTJIS_CHARSET, 
								OUT_DEFAULT_PRECIS, 
								CLIP_DEFAULT_PRECIS,
								PROOF_QUALITY,
								DEFAULT_PITCH | FF_ROMAN,
								"MS P" );

	hFont4 = CreateFont( 40,0, 0,0,1000,
								0,0,0, SHIFTJIS_CHARSET, 
								OUT_DEFAULT_PRECIS, 
								CLIP_DEFAULT_PRECIS,
								PROOF_QUALITY,
								DEFAULT_PITCH | FF_ROMAN,
								"MS " );

	timeBeginPeriod( 1 );	//ŏ\ݒ

	//bZ[W[v
	while( 1 ){
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ){	//bZ[WL
			if( msg.message == WM_QUIT )	break;
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}else{												//bZ[W	
			if( fActive ){		//ANeBȕ
				if( KeepFps( 60 ) ){	//t[Œ					
					GameMain();		//Ct[Ăяo
				}
			}else{				//ANeBȕ
				WaitMessage();
			}
		}
	}

	timeEndPeriod( 1 );//ŏ\̐ݒ̉

	//p[eBÑ
	for( i = 0 ; i < 1 ; i++){
		ReleaceParticle(&efect[i].particle);//֐
	}

	//tHg̉
	DeleteObject( hFont );
	DeleteObject( hFont2 );
	DeleteObject( hFont3 );
	DeleteObject( hFont4 );
	DeleteObject( hFontBack );

	//ZOg̉
	for( i = 0 ; i < bDMSegMax ; i++ ){
		ReleaseDMSegment( &lpDMSegment[ i ] );
	}
	//DirectMusic
	ReleaseDM();

	//ZJ_obt@̉	
	for( i = 0 ; i < bDSSBufMax ; i++ ){
		ReleaseDSSBuffer( &lpDSSBuffer[ i ] );
	}
	//DirectSound
	ReleaseDS();

	//DirectDraw
	for( i = 0 ; i < DDSOFFMAX ; i++ ){//ItXN[T[tFCX
		ReleaseDDSOffScreen( lpszStorageFileName[ i ], &lpDDSOffscreen[ i ] );
	}
	ReleaseDD();	//̑IuWFNg

	CloseHandle( hMutex );		//Mutex̉

	//WinMain̏I
	return msg.wParam;
}

/////////////////////////////////////////////////////////////////
//	EBhEvV[W
/////////////////////////////////////////////////////////////////

LRESULT CALLBACK WndProc( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{

	switch( message ){		
		case WM_CREATE:		
		srand( timeGetTime() );//
		OnCreate( hWnd, ( LPCREATESTRUCT )lParam );
		break;

	case WM_KEYDOWN:		
		//I{^
		if( LOWORD(wParam) == VK_ESCAPE ){
			DestroyWindow( hWnd );
		}
		break;

	case WM_ACTIVATEAPP:
		//AvP[ṼANeBuANeBȕ
		fActive = ( BOOL )wParam;		
		break;

	case WM_DESTROY:	//EBhEj
		OnDestroy( hWnd );
		PostQuitMessage( 0 );	//IbZ[Ws
		break;

	default:
		return DefWindowProc( hWnd, message, wParam, lParam );
	}

	return 0;
}

///////////////////////////////////////////////////////////////////
//ACh
///////////////////////////////////////////////////////////////////
void OnIdle( HWND hWnd ){

}

///////////////////////////////////////////////////////////////////
//CEBhE쐬
///////////////////////////////////////////////////////////////////
void OnCreate( HWND hWnd, LPCREATESTRUCT lpcs ){

	GXO = (float)g_Width / 2;	//EBhETCYij̔iSj
	GYO = (float)g_Height / 2;	//EBhETCYij̔iSj
	
	CreatePolygon();

}

///////////////////////////////////////////////////////////////////
//vOI
///////////////////////////////////////////////////////////////////
void OnDestroy( HWND hWnd ){
	ReleaseDD();
	DeletePolygon();
	PostQuitMessage( 0 );
}